' This module can Launch different qbasic programs with a CHAIN qbasic instruction.
' Just add the same COMMON arrays to your launcher. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.

DIM Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER

COMMON SHARED Endk$

CONST NormForeColor = 7' Normal Foreground Color
CONST NormBackColor = 0 ' Normal Background Color
FC = NormForeColor
BC = NormBackColor
HFC = 14         ' Higlighted Foreground Color
HBC = 0          ' Higlighted Background Color

DIM SHARED DoubleBorder$    ' Double Border Box characters
DIM SHARED SingleBorder$
DoubleBorder$ = "ͻͼ"      ' Double Border Box characters
SingleBorder$ = "Ŀ"      ' Single Border Box characters

              TYPE IDXType
              Section AS STRING * 20
              StartRec AS DOUBLE
              RecLength AS SINGLE
              END TYPE
              DIM SHARED IDXRecord AS IDXType
           	
           	TYPE REK
           	Content as STRING * 256
           	END TYPE
           	DIM Rekord AS REK
           	
Endk$ = CHR$(13)
Endk$ = Endk$ + CHR$(27)
Endk$ = Endk$ + CHR$(9)
Endk$ = Endk$ + CHR$(0) + CHR$(72) ' Arrow Up
Endk$ = Endk$ + CHR$(0) + CHR$(80) ' Arrow Down
Endk$ = Endk$ + CHR$(0) + CHR$(59) ' F1 = Help 
Endk$ = Endk$ + CHR$(0) + CHR$(64) ' F6  Key
Endk$ = Endk$ + CHR$(0) + CHR$(68) ' F10 Key


DIM SktTrk$ (0 TO 11)	' Sector per Track. 9, 16, 18, 36 or whatever
DIM TrkSide$ (0 TO 11)	' Track/side 40 or 80 or whatever
DIM NSides$  (0 TO 11)	' Number of Sides. 1= Single Side, 2=Double Side
DIM DiskDens$ (0 TO 11)	' Disk Density. 1=Single Density, 2=Double Density, 3=High Density, 4=Extended Density


' Sector per Track. 9, 16, 18, 36 or whatever     		
		
		SktTrk$ (1) 	= "9"   ' A=  90 KB,  SS/SD, 40 TK,   360 Sctrs
		SktTrk$ (2)   = "18"  ' B= 180 KB,  SS/DD, 40 TK,   720 Sctrs
		SktTrk$ (3)   = "9"   ' C= 180 KB,  DS/SD, 40 TK,   720 Sctrs
		SktTrk$ (4)   = "18"  ' D= 360 KB,  DS/DD, 40 TK,  1440 Sctrs
		SktTrk$ (5)   = "16"  ' E= 320 KB,  DS/DD, 40 TK,  1280 Sctrs
		SktTrk$ (6)   = "18"  ' F= 360 KB,  SS/DD, 80 TK,  1440 Sctrs
		SktTrk$ (7)   = "18"  ' G= 720 KB,  DS/DD, 80 TK,  2880 Sctrs
		SktTrk$ (8)   = "36"  ' H= 720 KB,  SS/HD, 80 TK,  2880 Sctrs
		SktTrk$ (9)   = "36"  ' I= 1440 KB, DS/HD, 80 TK,  5760 Sctrs
		SktTrk$ (10)  = "72"  ' J= 1440 KB, SS/ED, 80 TK,  5760 Sctrs
		SktTrk$ (11)  = "72"  ' K= 2880 KB, DS/ED, 80 TK, 11520 Sctrs
' Track/side 40 or 80 or whatever		
		TrkSide$ (1) 	 = "40" ' A=  90 KB,  SS/SD, 40 TK,   360 Sctrs
		TrkSide$ (2)   = "40" ' B= 180 KB,  SS/DD, 40 TK,   720 Sctrs
		TrkSide$ (3)   = "40" ' C= 180 KB,  DS/SD, 40 TK,   720 Sctrs
		TrkSide$ (4)   = "40" ' D= 360 KB,  DS/DD, 40 TK,  1440 Sctrs
		TrkSide$ (5)   = "40" ' E= 320 KB,  DS/DD, 40 TK,  1280 Sctrs
		TrkSide$ (6)   = "80" ' F= 360 KB,  SS/DD, 80 TK,  1440 Sctrs
		TrkSide$ (7)   = "80" ' G= 720 KB,  DS/DD, 80 TK,  2880 Sctrs
		TrkSide$ (8)   = "80" ' H= 720 KB,  SS/HD, 80 TK,  2880 Sctrs
		TrkSide$ (9)   = "80" ' I= 1440 KB, DS/HD, 80 TK,  5760 Sctrs
		TrkSide$ (10)  = "80" ' J= 1440 KB, SS/ED, 80 TK,  5760 Sctrs
		TrkSide$ (11)  = "80" ' K= 2880 KB, DS/ED, 80 TK, 11520 Sctrs
		
' Number of Sides. 1= Single Side, 2=Double Side 		
		NSides$  (1) 	 = "1" ' A=  90 KB,  SS/SD, 40 TK,   360 Sctrs
		NSides$   (2)   = "1" ' B= 180 KB,  SS/DD, 40 TK,   720 Sctrs
		NSides$   (3)   = "2" ' C= 180 KB,  DS/SD, 40 TK,   720 Sctrs
		NSides$   (4)   = "2" ' D= 360 KB,  DS/DD, 40 TK,  1440 Sctrs
		NSides$   (5)   = "2" ' E= 320 KB,  DS/DD, 40 TK,  1280 Sctrs
		NSides$   (6)   = "1" ' F= 360 KB,  SS/DD, 80 TK,  1440 Sctrs
		NSides$   (7)   = "2" ' G= 720 KB,  DS/DD, 80 TK,  2880 Sctrs
		NSides$   (8)   = "1" ' H= 720 KB,  SS/HD, 80 TK,  2880 Sctrs
		NSides$   (9)   = "2" ' I= 1440 KB, DS/HD, 80 TK,  5760 Sctrs
		NSides$   (10)  = "2" ' J= 1440 KB, SS/ED, 80 TK,  5760 Sctrs
		NSides$   (11)  = "2" ' K= 2880 KB, DS/ED, 80 TK, 11520 Sctrs 
		   
' Disk Density. 1=Single Density, 2=Double Density, 3=High Density, 4=Extended Density		
		DiskDens$ (1)   = "1" ' A=  90 KB,  SS/SD, 40 TK,   360 Sctrs
		DiskDens$ (2)   = "2" ' B= 180 KB,  SS/DD, 40 TK,   720 Sctrs
		DiskDens$ (3)   = "1" ' C= 180 KB,  DS/SD, 40 TK,   720 Sctrs
		DiskDens$ (4)   = "2" ' D= 360 KB,  DS/DD, 40 TK,  1440 Sctrs
		DiskDens$ (5)   = "2" ' E= 320 KB,  DS/DD, 40 TK,  1280 Sctrs
		DiskDens$ (6)   = "2" ' F= 360 KB,  SS/DD, 80 TK,  1440 Sctrs
		DiskDens$ (7)   = "2" ' G= 720 KB,  DS/DD, 80 TK,  2880 Sctrs
		DiskDens$ (8)   = "3" ' H= 720 KB,  SS/HD, 80 TK,  2880 Sctrs
		DiskDens$ (9)   = "3" ' I= 1440 KB, DS/HD, 80 TK,  5760 Sctrs
		DiskDens$ (10)  = "4" ' J= 1440 KB, SS/ED, 80 TK,  5760 Sctrs
		DiskDens$ (11)  = "4" ' K= 2880 KB, DS/ED, 80 TK, 11520 Sctrs 
		   
		DummyRec$ = STRING$(256, CHR$(&HBC))
		ZeroedRec$= STRING$(256, CHR$(&H0))
		NewDiskName$= MyName$(3)
		frf% = FREEFILE
		PN$="Y"     ' Go ahead with creating the new disk (YN)?
		
' Read User's variables from last access		
		ff% = FREEFILE
		GOSUB GetVariables ' Get back all the user's variables from "CrVrtl.DAT" file

		GOTO  NoAbort
Abort: 	GOSUB SaveVariables ' Save all the user's variables in "CrVrtl.DAT" file
		IF MyName$(0) <> "" THEN CHAIN MyName$(0) ELSE CLS : SYSTEM

NoAbort: 
		GOSUB FirstScreen 'Display First Screen
		GOTO TIDskName12
TIDskNameAgn:		
		TIDskName$ = Xinput$(6, 22, 10, TIDskName$, "", Endk$, Exitk$, RealStrLen%) 
		IF ASC(Exitk$)=27 THEN GOTO Abort 
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO TIDskNameAgn ' Arrow Up
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB FirstScreen : GOTO TIDskNameAgn	' F1 = Help  
TIDskName12:	
		TIDskName$=LTRIM$(RTRIM$(TIDskName$))
		K=INSTR(TIDskName$," "): IF K=0 THEN GOTO TIDskNameOK
		GOTO TIDskNameAgn	
		
TIDskNameOK:	IF LEN(TIDskName$)<10 THEN TIDskName$=TIDskName$+SPACE$(10-LEN(TIDskName$))
	
TIDskNameOK2:	LOCATE 16,3,1: PRINT "Type of disk, your choice (A-K,X):  "; LUC$
              UC$ = Xinput$(16, 39, 1, LUC$, "ABCDEFGHIJKXSabcdefghijkxs", Endk$, Exitk$, RealStrLen%) 
		IF ASC(Exitk$)=27 THEN GOTO Abort 
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB FirstScreen : LUC$=UC$ : GOTO TIDskNameOK2	' F1 = Help
		UC$=LTRIM$(RTRIM$(UC$))
		UC$=(UCASE$(UC$))
		IF UC$="" THEN GOTO TIDskNameOK2
		
AcceptIt:	LUC$=UC$
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO TIDskNameAgn ' Arrow Up
		IF UC$="X" THEN GOSUB CustomFormatting : CLS: GOTO NoAbort
		IF UC$="S" THEN GOSUB AddFolderExist : CLS: GOTO Abort	
		ChsnFrmt%=ASC(UC$)-64	' Format Type chosen by user
		GOSUB ResultingDisk: ' Display Size of the resulting disk 
		GOSUB ProceedNow
		IF ASC(Exitk$)=27 THEN GOTO Abort
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB FirstScreen : LUC$=UC$ : GOTO TIDskNameOK2	' F1 = Help
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOSUB FirstScreen: GOTO TIDskNameOK2 'Display First Screen
		IF PN$="Y" THEN GOSUB CreateDisk : GOTO Abort' Real action now. Create V9T9 Disk: open output file and add sectors to it
		CLS 
		GOTO NoAbort		
		

' Display First Screen 		
FirstScreen:  CLS
       	CALL BOX(1,1,80,25,SingleBorder$)
		LOCATE 2,3,1 : PRINT "FORMAT A V9T9 DISK OF ANY SIZE/ADD SUBDIRS TO AN EXISTING V9T9 DISK"
		LOCATE 4,3,1 : PRINT "DOS new disk name: ";NewDiskName$
		LOCATE 6,3,1 : PRINT "TI new Disk Name :"; TAB(22);TIDskName$

		LOCATE 7,1,1 : PRINT "";STRING$(30,"");"Available V9T9 Disk Formats"; STRING$(18,"");"";
		LOCATE 9,3,1  : COLOR HFC,HBC : PRINT "A=  90 KB, SS/SD, 40 TK,  360 Sctrs" : COLOR FC,BC 
		LOCATE 10,3,1  : PRINT "B= 180 KB, SS/DD, 40 TK,  720 Sctrs"
		LOCATE 11,3,1  : PRINT "C= 180 KB, DS/SD, 40 TK,  720 Sctrs"
		LOCATE 12,3,1 : COLOR HFC,HBC : PRINT "D= 360 KB, DS/DD, 40 TK, 1440 Sctrs" : COLOR FC,BC 
		LOCATE 13,3,1 : PRINT "E= 320 KB, DS/DD, 40 TK, 1280 Sctrs" 
		LOCATE 14,3,1 : PRINT "F= 360 KB, SS/DD, 80 TK, 1440 Sctrs" 
		LOCATE 9,41,1 : COLOR HFC,HBC : PRINT "G= 720 KB, DS/DD, 80 TK, 2880 Sctrs" : COLOR FC,BC 
		LOCATE 10,41,1 : PRINT "H= 720 KB, SS/HD, 80 TK,  2880 Sctrs"  
		LOCATE 11,41,1 : COLOR HFC,HBC :  PRINT "I= 1440 KB, DS/HD, 80 TK,  5760 Sctrs"   : COLOR FC,BC  
		LOCATE 12,41,1 : PRINT "J= 1440 KB, SS/ED, 80 TK,  5760 Sctrs"  
		LOCATE 13,41,1 : PRINT "K= 2880 KB, DS/ED, 80 TK, 11520 Sctrs"   
		LOCATE 14,41,1 : COLOR 12,0 : PRINT "X"; : COLOR FC,BC : PRINT "= Custom V9T9 Disk Formatting";
		LOCATE 15,41,1 : COLOR 11,0 : PRINT "S"; : COLOR FC,BC : PRINT "= Add SubDirs to an existing V9T9 Disk";
		LOCATE 18,1,1 : PRINT "";STRING$(78,"");"";
		LOCATE 22,1,1 : PRINT  "";STRING$(78,"");"";
		LOCATE 23,3,1 : PRINT "SS=Single Side, DS=Double Side, SD=Single Density, DD=Double Density,";
		LOCATE 24,3,1 : PRINT "HD=High Density, ED=Enhanced Density - Keys: ESCape=abort, Enter=OK";
		'DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
		RETURN 		

CustomFormatting: 
		CLS 
		ChsnFrmt%=0 		' Format Type chosen by user 
		GOSUB CustomScreen
		
Xinp1:		SktTrk$(0) = Xinput$(11, 31, 4, SktTrk$(0), "", Endk$, Exitk$, RealStrLen%)
		IF ASC(Exitk$)=27 THEN GOTO CustomFormEnd
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB CustomScreen : GOTO Xinp1	' F1 = Help
		GOSUB ResultingDisk: IF TooMany$<>"" THEN GOTO Xinp1 ' Display Size of the resulting disk
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO Xinp1 ' Arrow Up 
		IF Exitk$= CHR$(0) + CHR$(64) THEN GOTO ExecCstm ' F6
		
		
Xinp2:		TrkSide$(0) = Xinput$(12, 31, 4, TrkSide$(0), "", Endk$, Exitk$, RealStrLen%)
		IF ASC(Exitk$)=27 THEN GOTO CustomFormEnd
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB CustomScreen : GOTO Xinp2	' F1 = Help
		GOSUB ResultingDisk: IF TooMany$<>"" THEN GOTO Xinp2 ' Display Size of the resulting disk
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO Xinp1 ' Arrow Up
		IF Exitk$= CHR$(0) + CHR$(64) THEN GOTO ExecCstm ' F6  
		
		
Xinp3:		NSides$(0) = Xinput$(13, 31, 3, NSides$(0), "", Endk$, Exitk$, RealStrLen%)
		IF ASC(Exitk$)=27 THEN GOTO CustomFormEnd
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB CustomScreen : GOTO Xinp3	' F1 = Help
		GOSUB ResultingDisk: IF TooMany$<>"" THEN GOTO Xinp3 ' Display Size of the resulting disk
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO Xinp2 ' Arrow Up
		IF Exitk$= CHR$(0) + CHR$(64) THEN GOTO ExecCstm ' F6
		
				
Xinp4:		DiskDens$(0) = Xinput$(14, 31, 1, DiskDens$(0), "", Endk$, Exitk$, RealStrLen%)
		IF ASC(Exitk$)=27 THEN GOTO CustomFormEnd 
		IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB CustomScreen : GOTO Xinp4	' F1 = Help
		GOSUB ResultingDisk: IF TooMany$<>"" THEN GOTO Xinp4 ' Display Size of the resulting disk
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO Xinp3 ' Arrow Up 
		IF Exitk$= CHR$(0) + CHR$(64) THEN GOTO ExecCstm ' F6
		
		
ExecCstm: 	
		GOSUB ProceedNow
		IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO Xinp4 ' Arrow Up
		IF ASC(Exitk$)=27 THEN GOTO CustomFormEnd	
		IF PN$="Y" THEN GOSUB CreateDisk : GOTO Abort   ' Real action now. Create V9T9 Disk: open output file and add sectors to it
 		
CustomFormEnd:		
		RETURN 
		
				
CustomScreen: 
		CALL BOX(1,1,80,25,SingleBorder$)
		LOCATE 2,33,1 : COLOR 12,0  : PRINT "CUSTOM FORMATTING" : COLOR FC,BC 
		LOCATE 3,3,1 : COLOR HFC,HBC  : PRINT "Warning: non standard disk images may not be compatible with other software."
		LOCATE 4,13,1 : PRINT "You'd better know what you're doing here..." : COLOR FC,BC 
		LOCATE 5,1,1 : PRINT "";STRING$(78,"");"";
		LOCATE 6,3,1 : PRINT "DOS new disk name: ";NewDiskName$
		LOCATE 7,3,1 : PRINT "TI new Disk Name :"; TAB(22);TIDskName$
		LOCATE 8,1,1 : PRINT "";STRING$(78,"");"";
		LOCATE 9,29,1 : PRINT "NEW DISK VITAL PARAMETERS"
		LOCATE 11,3,1 : PRINT "Sector/Track (9,16,18,...): "; SktTrk$(0)
		LOCATE 12,3,1 : PRINT "Track/Side (40,80,...)    : "; TrkSide$(0) 
		LOCATE 13,3,1 : PRINT "Total Sides (1 or 2)      : "; NSides$(0) 
		LOCATE 14,3,1 : PRINT "Disk Density (1,2,...)    : "; DiskDens$(0); TAB(34);"[1=Single,2=Double,3=High,4=Extended,...]" 
		LOCATE 18,1,1 : PRINT  "";STRING$(78,"");"";
		LOCATE 22,1,1 : PRINT  "";STRING$(78,"");"";
		LOCATE 24,23,1 : PRINT "- F6 to proceed, ESC to abort -";
		GOSUB ResultingDisk ' Display Size of the resulting disk
		RETURN

ResultingDisk: ' Display Size of the resulting disk
		GOSUB Convert			' Work out: Sector/Track, Track/Side and # of Sides	
		
		LOCATE 19,3,1 : PRINT "The Resulting Disk will have"; TotSect&;"sectors,"; TotSize&;"KB.    "
		TooMany$="":IF TotSect&<65536 THEN GOTO ResultDisk2
		LOCATE 20,3,1 : COLOR 12,0 : PRINT "That is too many sectors even for a crazy V9T9 virtual disk! "
		LOCATE 21,3,1 : PRINT "Please change disk parameters...                                          ": COLOR FC,BC
		
		TooMany$="Y": GOTO ResultDisk3
ResultDisk2:	LOCATE 20,3,1 : PRINT "Each AU will contain"; SectAU;"sectors. This means that a single file 256 bytes";
		LOCATE 21,3,1 : PRINT "long (or less) will use";SectAU;"sector(s), which is";SectAU*256;"bytes of disk space."
ResultDisk3:	RETURN
		
' Work out: Sector/Track, Track/Side and # of Sides		
Convert: 		
		SktTrk=VAL(RTRIM$(LTRIM$(SktTrk$(ChsnFrmt%))))   ' Sector/Track
		TrkSide=VAL(RTRIM$(LTRIM$(TrkSide$(ChsnFrmt%)))) ' Track/Side
		NSides=VAL(RTRIM$(LTRIM$(NSides$(ChsnFrmt%))))   ' # of Sides
              DiskDens=VAL(RTRIM$(LTRIM$(DiskDens$(ChsnFrmt%))))
              TotSect&=SktTrk*TrkSide*NSides
              TotSize&=(TotSect&/1024)*256
              SectAU = -1 * (INT((-TotSect& / 1600)))
              UpperABM=TotSect&/(8*SectAU)
              RETURN 

ProceedNow:   ' Final step. Go ahead with creating the new disk? 
              LOCATE 17,3,1 : PRINT "Go ahead with creating the new disk (YN)? ";PN$
              PN$ = Xinput$(17, 45, 1, PN$, "YNyn", Endk$, Exitk$, RealStrLen%)
              PN$=UCASE$(PN$)
              RETURN

' Real action now. Create V9T9 Disk: open output file and add sectors to it
CreateDisk:   
              GOSUB Convert               ' Work out: Sector/Track, Track/Side and # of Sides
              L1$ = CHR$(INT(TotSect& / 256)): L2$ = CHR$(TotSect& MOD 256)
              SectorZero$ = TIDskName$ + L1$ + L2$ + CHR$(SktTrk) + "DSK " + CHR$(TrkSide) + CHR$(NSides) + CHR$(DiskDens)
              IF TotSect& > 1600 THEN T$ = CHR$(1) ELSE T$ = CHR$(3)
              'SectorZero$ = SectorZero$ + STRING$(36, CHR$(0)) + T$ + STRING$(199, CHR$(0))
              SectorZero$ = SectorZero$ + STRING$(36, CHR$(0)) + T$ + STRING$(UpperABM - 1, CHR$(0))
              SectorZero$ = SectorZero$ + STRING$(256 - LEN(SectorZero$), CHR$(&HFF))
              
	      NewDiskNam$=NewDiskName$
              CALL ShortLongName(NewDiskNam$,CR$,3) ' Get Short Name out of a long filename
              
              OPEN NewDiskNam$ FOR BINARY ACCESS WRITE AS #frf%  ' Default Variables
              CLOSE #frf%
              KILL NewDiskNam$ 
              OPEN NewDiskNam$ FOR BINARY ACCESS WRITE AS #frf%  ' Default Variables
              
              BytePos& = 1
              
              PUT #frf%, BytePos&, SectorZero$: BytePos& = BytePos& + 256
              FillZero$ = STRING$(256, CHR$(0))
              PUT #frf%, BytePos&,  FillZero$ : BytePos& = BytePos& + 256
 'SECTRNUMBER%= 2              
              FOR Record = 3 TO TotSect&  ' Sector 0 and 1 are already out, add remaining sectors
 'SECTRNUMBER$="This sector:   "+ STR$(SECTRNUMBER%) + "  "
 'SECTRNUMBER$=SECTRNUMBER$ + STRING$(256-LEN(SECTRNUMBER$), CHR$(&H00))
 'PUT #frf%, BytePos&, SECTRNUMBER$: BytePos& = BytePos& + 256  
 'SECTRNUMBER%= SECTRNUMBER% + 1            
              PUT #frf%, BytePos&, DummyRec$: BytePos& = BytePos& + 256
              NEXT Record
              CLOSE #frf%

' See if disk was created  
	      NewDiskNam$=NewDiskName$
              CALL ShortLongName(NewDiskNam$,CR$,3) ' Get Short Name out of a long filename        
              OPEN NewDiskNam$ FOR BINARY ACCESS READ AS #frf%
              BytePos& = 1
              Dname$=INPUT$(10,#frf%)
              CLOSE #frf%
                            
              LOCATE 20,3,1 : PRINT STRING$(78," ");
              LOCATE 21,3,1 : PRINT STRING$(78," ");
              LOCATE 21,3,1 : COLOR HFC,HBC :
              PRINT "The new disk "; 
              IF TIDskName$ = Dname$ THEN Dname$="" : PRINT "has been" ; ELSE COLOR 12,0 : PRINT "WAS NOT" ; : COLOR HFC,HBC 
              PRINT " succesfully created. Press any key now."; : COLOR FC,BC
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
              IF TotSect&=>1440 AND Dname$="" THEN GOSUB AddFolders
              RETURN 
              
' *****************************************
' Add Folders to an existing TI V9T9 Disk
' *****************************************
' Up to 3 SubDirectories can be added to a floppy disk according to Myarc HFDC strucure. 
' Rules:
' a) 3 Arrays, each containing 3 elements,  will contain all the needed parameters
'      1) "SubAlphaPtr(3)" 	- Pointer to a Free Sector to hold the 1st new Alphabetical SubDirectory
'                             If this Pointer=0 then this directory already exists and cannot be touched!
'      2) "SubDir$(3))"	- SubDirectory Name (10 character String)
'      3  "SubDirFlg$(3)"  - Flag: ""= don't create it, "Y"= create this directory, "F"=could be created, but
'                                  user has chosen not to.
' b) If a Subdirectory field is already in use in the V9T9 disk, that directory must be preserved. 
' c) A New Subdirector can be created only on an empty Subdirectory field
' d) All 3 Directory names must differ (i.e. cannot be the same)
AddFolderExist: 

		NewDiskNam$=NewDiskName$
                CALL ShortLongName(NewDiskNam$,CR$,3) ' Get Short Name out of a long filename
		ON ERROR GOTO AddFXNotFnd
                OPEN NewDiskNam$ FOR RANDOM ACCESS READ WRITE AS #frf% LEN = 256
		ON ERROR GOTO 0 
              GET #frf%, 1, Rekord  ' Get Sector Zero
' See if it is a V9T9 Disk. "DSK" at position 14-16              
              IF MID$(Rekord.Content,14,3)="DSK" THEN GOTO AddFXFnd1
              CLS
              CALL BOX(7,1,80,8,DoubleBorder$)
              LOCATE 9,3,1 : PRINT NewDiskName$;
              COLOR 12,0 : LOCATE 11,3,1  : PRINT "either does not exist or is not a true V9T9 file."  : COLOR FC,BC 	
              GOTO AddFXFndAbrt

' See if we have room for additional subdirectories              
AddFXFnd1:	
		AllowedSubs=0 ' Allowed SubDirectories
		
		FOR T=1 TO 3
		'CCC$=MID$(Rekord.Content,SubAlphaPtr(T),10): call ShowASCI(CCC$)
		
		IF MID$(Rekord.Content,21+12*(T-1),12)= STRING$(12,CHR$(0)) THEN  
			SubAlphaPtr(T)=T 	' Pointer to a Free Sector to hold the 1st new Alphabetical SubDirectory
			SubDirFlg$(T)="Y"	' This directory can be created
			AllowedSubs=AllowedSubs+1
			ELSE
			SubAlphaPtr(T)=0	' Pointer to a Free Sector. If 0 then this directory already exists and cannot be touched!
			SubDirFlg$(T)=""	' No need to create this directory
			SubDir$(T)=MID$(Rekord.Content,21+12*(T-1),10)
		       END IF
	       NEXT T
	       IF AllowedSubs=3 THEN GOTO AddFXFnd04
	       IF AllowedSubs>0 THEN GOTO AddFXFnd03

' No Name room for Subdirectories in current disk
TooManySubs:  CLS
              CALL BOX(7,1,80,8,DoubleBorder$)
              LOCATE 9,3,1 : COLOR 12,0 : PRINT "You can't add Subdirectories to "; NewDiskName$;  : COLOR FC,BC 
              LOCATE 11,3,1 : PRINT "There is no room inside the disk for that purpose.";
                
AddFXFndAbrt: CLOSE #ff%
AddFXFndAbr2:	LOCATE 13,23,1 : PRINT "- Press any key to exit - "; 
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
              IF K$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : CLS : GOSUB CustomScreen : GOTO TooManySubs	' F1 = Help	
	       GOTO Abort
	       
AddFXFnd03: 	' Only 1-2 Subdirectories will be allowed in current disk     
		GOSUB SomeRoomTaken ' Some room inside the disk has already been taken

		IF ASC(K$)=27 THEN CLOSE #ff% : GOTO Abort
AddFXFnd04:	
		GOTO AddFXFnd06
		
AddFXNotFnd:	RESUME AddFXNotFnd2	
AddFXNotFnd2:	ON ERROR GOTO 0
		CLS
              CALL BOX(7,1,80,8,DoubleBorder$)
              LOCATE 9,3,1 : COLOR 12,0 : PRINT "V9T9 Disk "; NewDiskName$;" doesn't exist."  : COLOR FC,BC 
              LOCATE 11,3,1 : PRINT "You can add SubDirectories only to an existing V9T9 Disk ";  
              GOTO AddFXFndAbr2
              
AddFXFnd06:   'Find available space inside the Free/Used Bit Map In sector Zero
		TotSect&=ASC(MID$(Rekord.Content,11,1))*256 + ASC(MID$(Rekord.Content,12,1))
		IF TotSect& > 1600 THEN SectAU=-1*(INT((-TotSect&/1600))) ELSE SectAU=1
              UpperABM=TotSect&/(8*SectAU)

              FOR S=1 to 3 
              IF SubAlphaPtr(S)=0 THEN GOTO AddFXFnd10 ' Any 10 byte space for this SubDir? If No, jump
		GOSUB FindFreeSector ' Find a Free Sector in Free/Used Bit Map In sector Zero and Update it 
		IF SectNum<>0 THEN SubAlphaPtr(S)=SectNum ELSE GOTO AddFXFnd14 ' Jump if no free sector has been found
AddFXFnd10:	NEXT S
		
		GOTO AddFXFnd40 ' Everything fine: all AllowedSubs sectors have been found

' Only Some (or none) Free Sesctors have been found 
AddFXFnd14:	' AllowedSubs
		S=S-1 : IF S>0 THEN GOTO AddFXFnd16
		CLS
              CALL BOX(7,1,80,8,DoubleBorder$)
              LOCATE 9,3,1 : COLOR 12,0 : PRINT "V9T9 Disk "; NewDiskName$;" is full."  : COLOR FC,BC 
              GOTO AddFXFndAbrt
              
AddFXFnd16:   IF S<AllowedSubs THEN AllowedSubs=S: GOSUB SomeRoomTaken ' Some room inside the disk has already been taken
		IF ASC(K$)=27 THEN CLOSE #ff% : GOTO Abort
		AllowedSubs=S
		
          
AddFXFnd40: 	'PUT #frf%, 1, Rekord  ' Save New Sector Zero
		
		CLOSE #ff%
		GOTO AddDirNowST

' Add Folders        
AddFolders:   

		CLS
              CALL BOX(7,13,50,8,DoubleBorder$)
              LOCATE 9,16,1 : PRINT "You can now add Sudirectories to your disk"
              LOCATE 12,16,1 : PRINT "Do you want that (YN)? "; AddSub$
              LOCATE 12,39,1
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
              K$=UCASE$(K$)
              IF K$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : GOTO AddFolders      ' F1 = Help 
              IF K$= CHR$(13) AND AddSub$="Y" THEN GOTO AddDirNow
              IF K$<>"Y" OR ASC(AddSub$)=27 THEN AddSub$="N" :GOTO AddFoldEnd
              
              AddSub$="Y"  
AddDirNow:    SubAlphaPtr(1)=66:  SubAlphaPtr(2)=66+(1*SectAU):SubAlphaPtr(3)=66+(2*SectAU) ' Pointers to a Free Sector to hold the new Alphabetical SubDirectories
AddDirNowST:  GOSUB AddDirScreen
' Input user's Subdirectory Names
SubDirNum1:   
		IF SubAlphaPtr(1)=0 THEN GOTO SubDirNum2
		SubDir$(1) = Xinput$(10, 27, 10, SubDir$(1), "", Endk$, Exitk$, RealStrLen%)
		'IF RTRIM$(LTRIM$(SubDir$(1)))<>"" THEN SubDirFlg$(1)="F"	' This directory can be created, but user has chosen not to
              IF ASC(Exitk$)=27 THEN GOTO AddFoldEnd
              IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : GOTO AddDirNow   ' F1 = Help
              SubDir$(1)= AdjDskName(SubDir$(1),Flag)
              IF Flag<>0 THEN GOSUB MsgEditSubName : GOTO SubDirNum1
              LOCATE 20,3,1 : PRINT SPACE$(77)
              
SubDirNum2:   
	
		IF SubAlphaPtr(2)=0 THEN GOTO SubDirNum3
		
   		SubDir$(2) = Xinput$(12, 27, 10, SubDir$(2), "", Endk$, Exitk$, RealStrLen%)
              IF ASC(Exitk$)=27 THEN GOTO AddFoldEnd
              IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : GOTO AddDirNow   ' F1 = Help
              SubDir$(2)= AdjDskName(SubDir$(2),Flag)
              IF Flag<>0 THEN GOSUB MsgEditSubName : GOTO SubDirNum2
              LOCATE 20,3,1 : PRINT SPACE$(77)
              IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO SubDirNum1 ' Arrow Up
              

SubDirNum3:   IF SubAlphaPtr(3)=0 THEN GOTO SubDirTrim
		
              SubDir$(3) = Xinput$(14, 27, 10, SubDir$(3), "", Endk$, Exitk$, RealStrLen%)
              IF ASC(Exitk$)=27 THEN GOTO AddFoldEnd
              SubDir$(3)= AdjDskName(SubDir$(3),Flag)
              IF Flag<>0 THEN GOSUB MsgEditSubName : GOTO SubDirNum3
              LOCATE 20,3,1 : PRINT SPACE$(77)
              IF Exitk$=CHR$(0) + CHR$(72) THEN GOTO SubDirNum2 ' Arrow Up
              IF Exitk$= CHR$(0) + CHR$(59) THEN GOSUB DisplHelp : GOTO AddDirNow   ' F1 = Help
 SubDirTrim:             
              IF RTRIM$(LTRIM$(SubDir$(1)))<>"" AND SubDir$(1)=SubDir$(2) THEN GOSUB MsgSubNamesMustDiffer : GOTO SubDirNum1
              IF RTRIM$(LTRIM$(SubDir$(2)))<>"" AND SubDir$(2)=SubDir$(3) THEN GOSUB MsgSubNamesMustDiffer : GOTO SubDirNum2
              IF RTRIM$(LTRIM$(SubDir$(3)))<>"" AND SubDir$(3)=SubDir$(1) THEN GOSUB MsgSubNamesMustDiffer : GOTO SubDirNum1	
		
' Add subdirectories to V9T9 Image File		              	
              NewDiskNam$=NewDiskName$
              CALL ShortLongName(NewDiskNam$,CR$,3) ' Get Short Name out of a long filename  
              OPEN NewDiskNam$ FOR RANDOM ACCESS READ WRITE AS #frf% LEN = 256
              GET #frf%, 1, Rekord 
              'SectAU
              VrtlPtr=1	' Pointer to first Subdirectory field in Sector Zero
              ' Pointer to first Sector that will contain the new Directory, 256 bytes for 126 pointers to file FDRs
              ' There will be 3 of such sectors
              'NewDirPtr=66
              ' Place the 3 dirs now
              JustDone=0
              T=0
              FOR VrtlPtr=21 TO 21+12*2 STEP 12
              ' See if there is room
              IF MID$(Rekord.Content,VrtlPtr,12)<> STRING$(12,CHR$(0)) THEN GOTO NxtVrtlPtr
             	
NextFolder:   T=T+1: IF T>3 THEN GOTO AddingDone
              ' Now choose the first Dir to be placed
              IF SubAlphaPtr(T)=0 OR RTRIM$(LTRIM$(SubDir$(T)))="" THEN GOTO NextFolder
              
              L1$=NumToString(SubAlphaPtr(T))
              DirName$=SubDir$(T)+L1$
            	MID$(Rekord.Content,VrtlPtr)=DirName$
   	
            	Call UpdateFUBMSZ(SubAlphaPtr(T),Rekord.Content,SectAU)  ' Update Free Used BitMap in Sector Zero
            	
            	'NewDirPtr=NewDirPtr+SectAU
            	JustDone=JustDone+1
            	
NoFolder:    	
NxtVrtlPtr:	NEXT VrtlPtr
AddingDone:
       	IF JustDone>0 THEN PUT #frf%, 1, Rekord 
       		
' Now ZeroIn all the sectors that will work as Directory (Directory is a sector-container for all FDRs belonging to that directory)
		NewDirPtr=66
		Rekord.Content=STRING$(256, CHR$(0))
       	FOR T=1 TO 3
       	IF SubAlphaPtr(T)=0 OR RTRIM$(LTRIM$(SubDir$(T)))="" THEN GOTO NoFolder2
              PUT #frf%,SubAlphaPtr(T)+1,Rekord
              'NewDirPtr=NewDirPtr+SectAU
 
 NoFolder2:   NEXT T         		
              CLOSE #frf%
		IF JustDone=0 THEN GOTO AddFoldEnd
		LOCATE 23,3,1  : COLOR 10,HBC :
              PRINT "Tip: Directories can be deleted from any green TI Catalog, available at most";  ': COLOR FC,BC
              LOCATE 24,3,1  : COLOR 10,HBC :
              PRINT "TI-PC menus. Press F5 while on the TI Disk Image Filename for it...         "; ' : COLOR FC,BC
		LOCATE 19,13,1 : COLOR HFC,HBC :
              PRINT "The new folders have been succesfully added to your new disk. ": COLOR FC,BC
              LOCATE 21,27,1 : PRINT "- Press any key to exit -"; 
              DO: K$ = INKEY$: LOOP UNTIL K$ <> "" 

AddFoldEnd:          
              RETURN 
              
AddDirScreen:        
              CLS
              CALL BOX(1,1,80,25,SingleBorder$)
              LOCATE 2,23,1 : PRINT "ADD UP TO 3 SUBDIRECTORIES TO YOUR V9T9 DISK"
              LOCATE 4,3,1 : PRINT "DOS disk name: ";NewDiskName$;
              LOCATE 5,3,1 : PRINT "TI Disk Name :"; TAB(18);TIDskName$ ; 
              LOCATE 6,3,1 : PRINT "Total Sectors:";TotSect&;
              LOCATE 8,1,1 : PRINT "";STRING$(78,"");"";
              LOCATE 23,3,1 : PRINT  "Leave blank the SubDir field you don't want to create. ESC to abort."
              LOCATE 18,1,1 : PRINT "";STRING$(78,"");"";
              LOCATE 22,1,1 : PRINT  "";STRING$(78,"");"";
              LOCATE 10,3,1 : PRINT "1st Subdirectory Name : ";TAB (27) ;SubDir$(1)
              LOCATE 12,3,1 : PRINT "2nd Subdirectory Name : ";TAB (27) ;SubDir$(2)
              LOCATE 14,3,1 : PRINT "3rd Subdirectory Name : ";TAB (27) ;SubDir$(3)
                         
              RETURN
              
SaveVariables: ' Save all the user's variables in "CrVrtl.DAT" file
		OPEN "CrVrtl.DAT" FOR OUTPUT AS #ff%	
		PRINT #ff%, "' This file, CrVrtl.DAT, stores all the variables generated by CrVrtl.BAS,"
		PRINT #ff%, "' a QBasic program that creates a V9T9 TI Disk as a file on a PC."
		PRINT #ff%, "' Lines beginning with an apostrophe are to be ignored."
		PRINT #ff%, "' Variables are assigned on a strict sequential order; you can't change that, unless you change CrVrtl.BAS."
		PRINT #ff%, "' Values are saved each time you exit CrVrtl.BAS, so there is no point in editing this file."
		PRINT #ff%, TIDskName$
		PRINT #ff%, LUC$; " ' Chosen type of disk"
		PRINT #ff%, SktTrk$(0); " ' SktTrk$(0), Sector per Track, Custom V9T9 Disk Formatting"
		PRINT #ff%, TrkSide$(0); " ' TrkSide$(0), Tracks per Side, Custom V9T9 Disk Formatting"
		PRINT #ff%, NSides$(0);" ' NSides$(0, Number of Sides, Custom V9T9 Disk Formatting"
		PRINT #ff%, DiskDens$(0);" ' DiskDens$(0), Disk Density, Custom V9T9 Disk Formatting"
		PRINT #ff%, AddSub$;" ' AddSub$, You can now add Sudirectories to your new disk (Y/N)"
		PRINT #ff%, "' The following 3 lines will contain the SUBDIRECTORY names."
		PRINT #ff%, SubDir$(1) 
		PRINT #ff%, SubDir$(2) 
		PRINT #ff%, SubDir$(3) 
		PRINT #ff%, ;"' <<CrVrtl.DAT ends here!>>"
		'TIDskName$="TI99PC_DSK"
		           '1234567890  
		'LUC$="D"   
              CLOSE #ff%
              RETURN 

GetVariables: ' Get back all the user's variables from "CrVrtl.DAT" file		
		ON ERROR GOTO FileNotFound
		OPEN "CrVrtl.DAT" FOR INPUT AS #ff%  ' Default Variables
		ON ERROR GOTO 0 
              WHILE EOF(ff%) = 0
              LINE INPUT #ff%, AA$
              IF LEFT$(AA$,1)="'" THEN GOTO NextVariab
              Call GetVal(AA$,A$) ' Get the value from the rest (get rid of whatever follows the apostrophe)
              VARIAB=VARIAB+1
              SELECT CASE VARIAB
              CASE 1
              IF A$<>"" THEN TIDskName$=A$ ELSE TIDskName$="TI99PC_DSK"
              CASE 2
              LUC$=A$
              CASE 3
              IF A$<>"" THEN SktTrk$(0)=A$ ELSE SktTrk$(0)="18"
              CASE 4
              IF A$<>"" THEN TrkSide$(0)=A$ ELSE TrkSide$(0)="40"
              CASE 5
              IF A$<>"" THEN NSides$(0)=A$ ELSE NSides$(0)="2"
              CASE 6 
              IF A$<>"" THEN DiskDens$(0)=A$ ELSE DiskDens$(0)="2" 
              CASE 7
              IF A$<>"" THEN AddSub$=A$ ELSE AddSub$="N"
              CASE 8
              IF A$<>"" THEN SubDir$(1)=A$ ELSE SubDir$(1)="SUBDIR1"
              CASE 9
              IF A$<>"" THEN SubDir$(2)=A$ ELSE SubDir$(2)="SUBDIR2"
              CASE 10
              IF A$<>"" THEN SubDir$(3)=A$ ELSE SubDir$(3)="SUBDIR3"
              CASE ELSE 
              END SELECT
              
NextVariab:   WEND
NoMoreVariab: CLOSE #ff%
		GOTO FileNotFnd3

FileNotFound: RESUME FileNotFnd2
FileNotFnd2:  ON ERROR GOTO 0 
		
              'DskSize$ (0)="1440"	' Sectors per Disk= 360, 720, 1440, 2880, 5760 or whatever
              'SktTrk$ (0)="18"	' Sector per Track. 9, 16, 18, 36 or whatever
              'TrkSide$ (0)="40"	' Track/side 40 or 80 or whatever
              'NSides$  (0)="2"	' Number of Sides. 1= Single Side, 2=Double Side
              'DiskDens$ (0)="2"	' Disk Density. 1=Single Density, 2=Double Density, 3=High Density, 4=
              'SktAU 	' How many sectors per AU (Allocation Unit) 1,2, or whatever           
		
FileNotFnd3:	RETURN



' Display Message: Edit ....
MsgEditSubName:             
              LOCATE 20,3,1 : COLOR 12,0 : PRINT "No blank must be left inside the Directory Name. Please edit it.    ": COLOR FC,BC
		LOCATE 21,3,1 : PRINT SPACE$(77)  
              RETURN 
              
' Display Message: Subdir Names must differ ....
MsgSubNamesMustDiffer:             
              LOCATE 20,3,1 : COLOR 12,0 : PRINT "No two subdirectories can have the same name. Please edit them.     ": COLOR FC,BC
		LOCATE 21,3,1 : PRINT SPACE$(77)  
              RETURN               
                            
DisplHelp:    CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "13.20.00") 
              RETURN
              
'***********************
' Find a Free Sector in Free/Used Bit Map In sector Zero and Update it 
'***********************		
FindFreeSector:	
		
		FOR T% = 1 TO UpperABM - 1 	'31.10.2008 Fix. It was="200", which may be beyond the real Free/Used BitMap in Sector Zero
		CV% = ASC(MID$(Rekord.Content, 56 + T%, 1))
		IF CV% = 255 THEN GOTO NextBlock
		FOR ex% = 0 TO 7
		IF (CV% AND 2 ^ ex%) = 0 THEN 
			CV%=CV% OR 2 ^ ex% 
			SectNum= (((T%-1)*8+ex%)*SectAU)
		       MID$(Rekord.Content, 56 + T%, 1)= CHR$(CV%) ' Update Free/Used BitMap in memory copy of Sector Zero 
		       ' Rekord.Content won't be saved this time. We need to update it, though, so that next calls will find assigned sectors as Used.
'PRINT "T%=";T%;" - ex%=";ex%; " - Sectnum=";SectNum :input CCC$
			GOTO GotFreeSec
			END IF 
		NEXT ex%

NextBlock:    NEXT T%
		SectNum=0 ' Free sector not found
GotFreeSec:	RETURN 	

' *************************
' ' Some room inside the disk has already been taken
' *************************
SomeRoomTaken:
  	
		CLS
              CALL BOX(7,1,80,8,DoubleBorder$)
              LOCATE 9,3,1 : COLOR HFC,HBC  : PRINT "You can add only";AllowedSubs;"Subdirectories to your disk.";  : COLOR FC,BC 
              LOCATE 11,3,1 : PRINT "Some room inside the disk has already been taken.";  
              LOCATE 13,13,1 : PRINT "- Press ESCape to exit, any other key to go on - "; 
              LOCATE 12,39,1
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
		RETURN
              
Sub box (Y, X, W, H, Charac$)
              ' Call Box(StartRow, StartColumn, Width, Height, BoxChar$)
              ' Y=StartRow,X=StartColumn; W=Width,H=Height)
              
              TL$ = MID$(Charac$, 1, 1)
              t$ = MID$(Charac$, 2, 1)
              TR$ = MID$(Charac$, 3, 1)
              L$ = MID$(Charac$, 4, 1)
              R$ = MID$(Charac$, 5, 1)
              BL$ = MID$(Charac$, 6, 1)
              B$ = MID$(Charac$, 7, 1)
              BR$ = MID$(Charac$, 8, 1)

'DoubleBorder$="ͻͼ"        ' Double Border Box characters  
'SingleBorder$="Ŀ"        ' Single Border Box characters  
              LOCATE Y, X
              PRINT TL$; : FOR t = 1 TO W - 2: PRINT t$; : NEXT t: PRINT TR$;
              
              FOR v = 1 TO H - 2
              LOCATE Y + v, X
              PRINT L$; TAB(X + W - 1); : PRINT R$;
              NEXT v
              
              LOCATE Y + H - 1, X
              PRINT BL$; : FOR t = 1 TO W - 2: PRINT B$; : NEXT t: PRINT BR$;

END SUB              

SUB Fischio
              IF MyVal(1) = 0 THEN EXIT SUB
              SOUND 1 * 400 + 500, 1
              SOUND 2 * 400 + 500, 1
              SOUND 3 * 400 + 500, 1
              SOUND 4 * 400 + 500, 1
              SOUND 5 * 400 + 500, 1
              SOUND 6 * 400 + 500, 1
END SUB


FUNCTION NumToString$ (MyVal) ' Convert an integer to 2 characters
	NumToString = CHR$(INT(MyVal / 256))+ CHR$(MyVal MOD 256)
	END FUNCTION


FUNCTION AdjDskName$(A$,C) ' Adjust Diskname: 1) must start with a non-blank character, 2) be 10 bytes long, padded with blanks
                           ' to the right, 3) must not contain any blank inside the name itself
	B$=LTRIM$(A$)
	IF LEN(B$)<10 THEN B$=B$+SPACE$(10-LEN(B$))
		
	C$=RTRIM$(B$): C=INSTR(C$," ")
	AdjDskName$=B$
	END SUB 	
	
SUB GetVal(AA$,A$) ' Get the value from the rest (get rid of whatever follows the apostrophe)	
	P=INSTR(AA$,"'") : IF P>0 THEN A$= LEFT$(AA$,P-1) ELSE A$=AA$
	A$=RTRIM$(LTRIM$(A$))
	END SUB 
SUB UpdateFUBMSZ(SectorN,SectZero$,SectAU)  ' Update Free Used BitMap in Sector Zero	
	
	FUBMSZAU%=INT(SectorN/SectAU): FUBMSZ%=INT(FUBMSZAU%/8) 	' Get pointer to Byte
	ex%=INT(FUBMSZAU% MOD 8)		' Get pointer to bit
	CV% = 2 ^ ex%
	B$=MID$(SectZero$, 57 + FUBMSZ%)
	OCV%=ASC(B$)
	CV%=OCV% OR  CV% ' Update Free/Used bit 
	MID$(SectZero$, 57 + FUBMSZ%) = CHR$(CV%) ' Mark that sector as used on Sector Zero
	'NewFreeSect% = ((FUBMSZ% * 8)+ ex%)*SectAU    ' Get the free sector number

	END SUB 	

SUB ShowASCI(A$)
	CALL BOX(1,1,80,3,DoubleBorder$)
	LOCATE 9,2,1 
	FOR T=1 TO LEN(a$)
       PRINT ASC(MID$(A$,T,1));
       NEXT T
       PRINT 
       'DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
	END SUB 
	
SUB ShortLongName (A$,B$,FUNC As Integer)
' Get either a LongName or a Shortname, depending on the value assigned to the control variable FUNC
' FUNC = 1  -  Get ShortFilename (8.3 characters) out of a LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 2  -  Get LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 3  -  Get ShortFilename (8.3 characters) out of a LongFilename. Create one LongFilename if no ShortFilename exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 4  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the longest Filename available. If file is created, a second record containing "CR!" will be returned. 
'      = 5  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.

                SELECT CASE MyVal(0)
                CASE 0 TO 999  ' Plain DOS OS
                EXIT SUB
                CASE 1000 TO 1999  ' Windows 95, 98, XP
                GOTO ShortLongN1
                CASE 2000 TO 3000  ' Windows XP, Vista
                GOTO ShortLongN1
                CASE ELSE
                END SELECT
                EXIT SUB
                
ShortLongN1:    Select CASE FUNC
                CASE 1  ' Get short filename (8.3 characters) but don't create a new file.
                C$ = "INT7160.com"
                CASE 2  ' Get Longest Filename but don't create a new file.
                C$ = "INT716RL.com"
                CASE 3  ' Get ShortFilename and create a long one if none exists. Return the short one anyway
                C$ = "INT716C.com"
                CASE 4  ' Get Long Filename out of a short one. Create a long one if none exists.
                C$ = "INT716CO.com"  ' The new  filename returned to the caller will be of the longest type available.
                CASE 5  ' Get Long Filename out of a short one. Create a long one if none exists.
                C$ = "INT716CL.com"  ' The new  filename returned to the caller will be of the shortest type available.

                CASE Else
                Exit Sub
                END SELECT
                
                
                C$ = C$ + " " + A$ + " >--"'Redirect output to a file named "--"
                SHELL C$
                B$=""
                ff% = FREEFILE
                OPEN "--" FOR INPUT AS #ff%
                IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
                LINE INPUT #ff%, A$
                IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
                LINE INPUT #ff%, B$
ShortLongN2:    CLOSE #ff%
                KILL "--"
END Sub

	
	
SUB ThisHelp(Banner$, DatFile$, IDXFile$, Argum$)
              GOTO GetHelp

' Because of MS QBasic quirks, GetIDX routine has to be placed before the rest of the code.

' Get .IDX file values into an array, that is, 
' Get Array Parameters from Index (IDX) file
GetIDX:         
              OPEN IDXFile$ FOR RANDOM ACCESS READ AS #3 LEN = LEN(IDXRecord)
              GET #3, , IDXRecord
              TLines% = IDXRecord.StartRec' First record is special: total records that follow
              
              
              REDIM IDXSect$(TLines%)
              REDIM IdxStart(TLines%)
              REDIM IdxLength(TLines%)
              FOR t = 1 TO TLines%
              GET #3, , IDXRecord
              IDXSect$(t) = LTRIM$(IDXRecord.Section)
              IdxStart(t) = IDXRecord.StartRec
              IdxLength(t) = IDXRecord.RecLength
              IDXSect$(t) = LTRIM$(RTRIM$(IDXSect$(t)))
              NEXT t
              CLOSE #3
              
              RETURN
              

              

GetHelp:        CLS
              LOCATE 1, 26: PRINT Banner$
              InizRw% = 2
              TotScrRws% = 12
              CurrScrRw% = 1
              
              GOSUB RedrawBox
              GOSUB GetIDX
              FOR Arg% = 1 TO TLines%
              IF Argum$ = IDXSect$(Arg%) THEN GOTO ArgFnd
              NEXT Arg%
              Arg% = 1
              
ArgFnd:         CurntLine% = Arg%
              RcLen% = 77 + 2
              OPEN DatFile$ FOR RANDOM ACCESS READ AS #59 LEN = RcLen%
              FIELD #59, RcLen% - 2 AS DL$
              FIELD #59, 2 AS CRLF$
              
'===================================
' MAIN LOOP STARTS HERE
'===================================       
NextLineName:
              COLOR 7, 0
              
              IF CurrScrRw% = 1 THEN FstLine% = CurntLine%   ' Get Number of first Line only
              GOSUB DisplayRw
              CurntLine% = CurntLine% + 1 ' Next Line
              LastScrRw% = CurrScrRw%      ' Save last Screen Row used
              CurrScrRw% = CurrScrRw% + 1  ' Next Screen Row
              IF CurrScrRw% < TotScrRws% + 1 AND CurntLine% <= TLines% THEN GOTO NextLineName
'===================================
' MAIN LOOP ENDS HERE
'===================================
'           
              GOSUB BotLine              ' Clear Unused Bottom Lines
              LastLine% = CurntLine% - 1
              CurntLine% = FstLine%  ' Current Line is now first Line in screen
              
              CurrScrRw% = 1
              IF KeepCursBot% = 0 THEN GOTO LocCursor2
              ' Last key used was Arrow Down. Move Cursor and FileNumber pointer to last Line in Screen
              CurrScrRw% = TotScrRws%: KeepCursBot% = 0: CurntLine% = LastLine%
              GOTO LocCursor2
              
LocCursor:
              GOSUB HeRestColor

LocCursor2:
              LOCATE InizRw% + CurrScrRw%, 2, 1
              COLOR 0, 7: GOSUB DisplayRw: COLOR 7, 0 ' Display Current Row
              LOCATE InizRw% + CurrScrRw%, 2, 1
              OldScrRw% = CurrScrRw%
              OldLine% = CurntLine%
              IF GoToThisDir% <> 0 THEN CurntLine% = GoToThisDir%: GoToThisDir% = 0: GOTO Exekit
              'GOSUB ShowValues    ' My little Debugger
              
              
DoHeAgain:      GOSUB GetChar

              ' IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO DoHeAgain

              ' ESCape Key
              IF UH$ = CHR$(27) THEN GOTO HAbort
              
              ' ENTER Key
              IF UH$ <> CHR$(13) THEN GOTO IsArrDown
EnterKey:       CALL FISCHIO
              GOSUB ThisSect
              GOSUB RePaintHelp
              GOTO NMatch

IsArrDown:     ' Arrow Down Key
              IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO OthKey0
              IF CurrScrRw% < LastScrRw% THEN CurrScrRw% = CurrScrRw% + 1: CurntLine% = CurntLine% + 1: GOTO LocCursor
              IF CurntLine% = TLines% THEN GOTO LocCursor
              CurntLine% = FstLine% + 1
              KeepCursBot% = 1
              IF CurntLine% < 1 THEN CurntLine% = 1
              GOTO Exekit
OthKey0:         'Arrow up Key
              IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO OthKey1
              IF CurntLine% = 1 THEN GOTO NMatch
              IF CurrScrRw% > 1 THEN CurrScrRw% = CurrScrRw% - 1: CurntLine% = CurntLine% - 1: GOTO LocCursor
              CurntLine% = FstLine% - 1: IF CurntLine% < 1 THEN CurntLine% = 1
              GOTO Exekit
              
OthKey1:         ' Page Up Key
              IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO OthKey2
              CurntLine% = FstLine% - TotScrRws%
              IF CurntLine% < 1 THEN CurntLine% = 1
              GOTO Exekit

OthKey2:        ' Page Down Key
              IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO OthKey7
              IF LastLine% + 1 + TotScrRws% > TLines% THEN CurntLine% = TLines% - TotScrRws% + 1: IF CurntLine% < 1 THEN CurntLine% = 1: GOTO Exekit
              CurntLine% = FstLine% + TotScrRws%
              IF CurntLine% > TLines% THEN CurntLine% = FstLine%
              GOTO Exekit
              
OthKey7:         ' Home Key : simply move cursor to top
              IF UH$ <> CHR$(0) + CHR$(71) THEN GOTO OthKey8
              CurrScrRw% = 1: CurntLine% = FstLine%: GOTO LocCursor

OthKey8:         ' End Key : simply move cursor to bottom
              IF UH$ <> CHR$(0) + CHR$(79) THEN GOTO OthKey9
              CurrScrRw% = LastScrRw%: CurntLine% = LastLine%
              GOTO LocCursor
              
OthKey9:        ' F3 = Show Error List
              IF UH$ <> CHR$(0) + CHR$(61) THEN GOTO OthKey10
              GOSUB RePaintHelp
              GOTO NMatch

OthKey10:       ' F7 = Show Sector as Hex
              IF UH$ <> CHR$(0) + CHR$(65) THEN GOTO OthKey11
              GOSUB RePaintHelp
              GOTO NMatch
              
OthKey11:       'CTRL Page Down
              IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO OthKey12
              GOTO EnterKey
OthKey12:           
              GOTO NMatch


Exekit:         CurrScrRw% = 1     ' Cursor on first screen row
              LOCATE InizRw% + CurrScrRw%, 2, 1
              GOTO NextLineName   ' Start next round

NMatch:         GOTO LocCursor
              
RePaintHelp:     
              GOSUB RedrawBox
              SaveCurrLine% = CurntLine%
              SavCurrScrRw% = CurrScrRw%
              CurntLine% = FstLine%
              FOR CurrScrRw% = 1 TO TotScrRws%
              GOSUB DisplayRw  ' Display Current Row
              CurntLine% = CurntLine% + 1 ' Next Line
              LastScrRw% = CurrScrRw%      ' Save last Screen Row used
              IF CurntLine% > TLines% THEN CurrScrRw% = CurrScrRw% + 1: GOTO RePaintHelp2
              NEXT CurrScrRw%   ' Next Screen Row
              
RePaintHelp2:          
              
              CurntLine% = SaveCurrLine%
              CurrScrRw% = SavCurrScrRw%
              RETURN

HeRestColor:    TempScreenRw% = CurrScrRw%
              TempLine% = CurntLine%
              CurrScrRw% = OldScrRw%
              CurntLine% = OldLine%
              COLOR 7, 0: GOSUB DisplayRw ' Display Current Row
              CurrScrRw% = TempScreenRw%
              CurntLine% = TempLine%
              RETURN

'==========================
' DISPLAY CURRENT ROW
'==========================
DisplayRw:
              LOCATE InizRw% + CurrScrRw%, 2, 1
              GET #59, IdxStart(CurntLine%)
              TL$ = DL$
              FOR t = 1 TO LEN(TL$): IF MID$(TL$, t, 1) <> " " AND MID$(TL$, t, 1) <> "*" THEN GOTO StrtFound
              NEXT t
StrtFound:      TL$ = RIGHT$(TL$, LEN(TL$) - t + 1)
              
              FOR t = LEN(TL$) TO 1 STEP -1: IF MID$(TL$, t, 1) <> " " AND MID$(TL$, t, 1) <> "*" THEN GOTO EndFnd
              NEXT t
EndFnd:         TL$ = LEFT$(TL$, t)
              'PRINT IDXSect$(CurntLine%); TAB(10); TL$; SPACE$(79 - 10 - LEN(TL$));
              PRINT IDXSect$(CurntLine%); TAB(12); TL$; SPACE$(79 - 12 - LEN(TL$));
              RETURN
              
'====================
' CLEAR BOTTOM LINES
'====================       
BotLine: 
              
              LOCATE InizRw% + CurrScrRw%, 2, 1

              IF CurrScrRw% >= TotScrRws% THEN GOTO HlpClear ' Blank all unused screen rows, if any

              FOR V = CurrScrRw% TO TotScrRws%
              LOCATE InizRw% + V, 2, 1
              PRINT "                                                                              "
              NEXT V
              
HlpClear:        LOCATE 23, 1: PRINT "Enter=Get Doc. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
              RETURN

              
' Create Box
RedrawBox:      CALL box(2, 1, 80, TotScrRws% + 2, DoubleBorder$)
              RETURN
Pranyk:

              PRINT "                         - press any key to return -"
              GOSUB GetChar
              RETURN
              
GetChar:
              DO: UH$ = INKEY$: LOOP UNTIL UH$ <> ""
              RETURN


ThisSect:       TotSectRws% = 19
              SectInizRw% = 2
              SectCurrRw% = 1
              SectStart# = IdxStart(CurntLine%)
              SectCount# = IdxLength(CurntLine%)
              SectCurr# = 0
              Blank$ = SPACE$(78)
              LOCATE 23, 1: PRINT "Enter=Line Down. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
              CALL box(2, 1, 80, TotSectRws% + 2, DoubleBorder$)
NewRound:             
              FirstRec# = SectCurr#
SectNewLine:             
              GET #59, SectStart# + SectCurr#
              LOCATE SectInizRw% + SectCurrRw%, 2, 1
              PRINT DL$;
              SectCurr# = SectCurr# + 1
              LastSectRw% = SectCurrRw%      ' Save last Screen Row used
              SectCurrRw% = SectCurrRw% + 1
              IF SectCurrRw% < TotSectRws% + 1 AND SectCurr# < SectCount# THEN GOTO SectNewLine
              
              FOR V = SectCurrRw% TO TotSectRws%
              LOCATE SectInizRw% + V, 2
              PRINT Blank$;
              NEXT V
              
GetAnother:     GOSUB GetChar
              'IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO GetAnother
              SectCurr# = FirstRec#
              SectCurrRw% = 1
              ' ESC Key
              IF UH$ = CHR$(27) THEN GOTO SectExit
              
              ' ENTER Key
              IF UH$ <> CHR$(13) THEN GOTO SectArrowDown
SectEnter:      IF SectCurr# < SectCount# - 6 THEN SectCurr# = SectCurr# + 1
              GOTO NewRound
              
SectArrowDown:  ' Arrow Down Key
              IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO SectKey0
              GOTO SectEnter
              
SectKey0:       'Arrow up Key
              IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO SectKey1
              IF SectCurr# > 0 THEN SectCurr# = SectCurr# - 1
              GOTO NewRound
SectKey1:           
              ' Page Up Key
              IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO SectKey2
SectPageUp:     SectCurr# = SectCurr# - TotSectRws%
              IF SectCurr# < 0 THEN SectCurr# = 0
              GOTO NewRound
              
SectKey2:        ' Page Down Key
              IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO SectKey11
SectPageDown:   SectCurr# = SectCurr# + TotSectRws%
              IF SectCurr# > SectCount# - TotSectRws% THEN SectCurr# = SectCount# - TotSectRws%
              IF SectCurr# < 0 THEN SectCurr# = 0
              GOTO NewRound
              
SectKey11:      'CTRL Page Down
              IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO SectKey12
              GOTO SectPageDown
              
SectKey12:      'CTRL Page Up
              IF UH$ <> CHR$(0) + CHR$(132) THEN GOTO SectKey13
              GOTO SectPageUp
SectKey13:          
              GOTO NewRound
SectExit:               
              V = InizRw% + TotScrRws%
              LOCATE V, 1, 1
              IF V >= 22 THEN GOTO DontDoit ' Blank all unused screen rows, if any

              FOR V = V TO 23
              LOCATE V, 1, 1
              PRINT SPACE$(80)
              NEXT V
DontDoit:
              
              RETURN
HAbort:             
              CLOSE #59
END SUB



DEFINT A-Z

              FUNCTION Xinput$ (Row%, Col%, FieldLen%, Default$, AllowCharsMask$, EndingKeys$, ExitKey$, RealStrLen%) STATIC

'Ŀ
'         XINPUT 2.1:  A Powerful Replacement for standard QBasic INPUT       
'                 
'                              First written                                  
'                                   by                                        
'          Frederick Volking, QBNews, Volume  1, Number  3  May 22, 1990      
'                                                                             
'                    ͻ                      
'                             Paolo Bagnaresi                               
'                           Via J.F. Kennedy 17                             
'                      20097 San Donato Milanese (MI)                       
'                                Italy                                      
'                          Tel. ++39-2-514.202                              
'                                                     
'                    e-mail: paul.bagnaresi@gmail.com 
'                    ͼ                      
'                                                                             
'          Almost entirely rewrote it and deeply enhanced it on June 1995     
'                                                                             
' Vers. 2.0 : Some bad bugs corrected on March 1996 (cursor position and      
'             returned string length)                                         
' Vers. 2.1 : May 2000. FieldLen% bug fixed.                                  
'Ĵ
'SYNTAX:Xinput$(Row%,Col%,FLen%,Default$,Allow$,EndKeys$,ExitKey$,RealStrLen%)
'WHERE: Row% & Col% - where input to occur                                    
'         FLen% - Field Length - maximum allowable                            
'         Default$ - Field's beginning default value                          
'         Allow$ - Character Set allowable for input                          
'         EndKeys$ - Keystrokes acceptable for finishing.                     
'            SUCH: [Enter] is CHR$(13)                                        
'                  [Esc] is CHR$(27)                                          
'                  [F1] is CHR$(255)+CHR$(59)                                 
'                  [Ctrl+PgUp] is CHR$(255)+CHR$(132)                         
'                  ... etc                                                    
'         ExitKey$ - The keystroke (from above EndKeys$)                      
'                    which was struck at function end.                        
'         RealStrLen% - The Real String Length, not counting unused space     
'                       at the string end. However, Spaces added manually     
'                       do count!                                             
'  SIMPLEST USE:  A$ = Xinput$(0,0,0,"","","",Any$,RealStrLen%)               
'         Will default to cursor's current row/col, length is                 
'         autoset to right margin, allowable chars are ALL,                   
'         only ending key is [Enter].                                         
'Ĵ
'                                                                             
'   Instructions and enhancements discussion after the end of program         
'                           ***  see below ***                                
'                                                                             
'
'  Discussion 
'
'                 XINPUT program eXtends the standard QBasic INPUT.
'
'     Unlike QB INPUT, XINPUT allows editing a previously created string.
'     This is the strongest feature of Xinput and the very reason why this
'     task was undertaken. I just could not bear any longer the tedious
'     retyping of any string change that was needed in some program
'     I developed through the years.
'     The original routine written by Frederick Volking on QBNews, named
'     ENPUT,  did not alllow a string editing, which is why I felt compelled
'     to rewrite the Volking routine.
'
'     Other valuable features are:
'
'- Exit keys (Xinput terminators) are user selectable, and detectable by caller.
'- All the user allowed keys are also pre-selectable. Caller can create a mask
'  containing the all the keys that the callee will be allowed to use.
'  A low sound will signal hitting an unselected key.
'
'- Insert key remains active until you deselect it by pressing it again.
'- Backspace pressed 8 times at 1st string position reverts you to start string.
'- Screen start position is user selectable.
'- Cursor Up key and Cursor Down key will move you through the rows.
'- Page Up will moves you to first row. Page Down to the last row.
'- CTRL+Home erases all the field from cursor position up to 1st string char.
'- All the standard QB Input features are emulated, including CTRL+End,
'  CTRL+R, CTRL+E, Tab and CTRL+I...
'- Escape key or CTRL+U, if aren't redefined as an exit key, will entirely
'  blank the string field.
'- Source code in plain QBasic is here, waiting for your enhancements.
'  BTW, I would gladly receive your enhancements, if you can send them to my
'  address:                   Paolo Bagnaresi
'                           Via J.F. Kennedy 17
'                      20097 San Donato Milanese (MI)
'                                Italy
'                          Tel. ++39-2-514.202
'                   e-mail: paul.bagnaresi@gmail.com 

              SHARED ScreenWidth%, EmptySpaceChar$

' 1 character Key vakues
              CtrlB$ = CHR$(2)         ' Ctrl+ B = Cursor to the word on the left
              CtrlE$ = CHR$(5)         ' Ctrl+ E = Cancel all chars from Cursor Posit. to end
              CtrlF$ = CHR$(6)         ' Ctrl+ F = Cursor to the word on the right
              BackS$ = CHR$(8)         ' Backspace
              Tabul$ = CHR$(9)         ' Tabulator
              CtrlI$ = CHR$(9)         ' Ctrl+ I = Tabulator
              CtrlK$ = CHR$(11)        ' Ctrl+ K = Cursor to start of field (= Home)
              Enter$ = CHR$(13)        ' Enter
              CtrlN$ = CHR$(14)        ' Ctrl+ N = Cursor to end of field (= End)
              CtrlR$ = CHR$(18)        ' Ctrl+ R = Insert mode toggle
              CtrlU$ = CHR$(21)        ' Ctrl+ U = Clear all input field
              Esc$ = CHR$(27)          ' Escape
              CtrlRevSlash$ = CHR$(28) ' Ctrl+ \ = Cursor Right
              CtrlClSquare$ = CHR$(29) ' Ctrl+ ] = Cursor Left
              
              CTRLC$ = CHR$(3)         ' CTRL+ C
              CTRLV$ = CHR$(22)        ' CTRL+ V

' 2 character Key vakues
              CursLeft$ = CHR$(0) + CHR$(75)
              CursRight$ = CHR$(0) + CHR$(77)
              CursUp$ = CHR$(0) + CHR$(72)
              CursDown$ = CHR$(0) + CHR$(80)

              Insert$ = CHR$(0) + CHR$(82)
              Delete$ = CHR$(0) + CHR$(83)
              Home$ = CHR$(0) + CHR$(71)
              End$ = CHR$(0) + CHR$(79)
              PageUp$ = CHR$(0) + CHR$(73)
              PageDown$ = CHR$(0) + CHR$(81)

              CtrlHome$ = CHR$(0) + CHR$(119)
              CtrlEnd$ = CHR$(0) + CHR$(117)
              CtrlPageUp$ = CHR$(0) + CHR$(132)
              CtrlPageDown$ = CHR$(0) + CHR$(118)
              CtrlCursLeft$ = CHR$(0) + CHR$(115)
              CtrlCursRight$ = CHR$(0) + CHR$(116)


' Other Key vakues, currently unused
              F1$ = CHR$(59)           'F1
              F2$ = CHR$(60)           'F2
              F3$ = CHR$(61)           'F3
              F4$ = CHR$(62)           'F4
              F5$ = CHR$(63)           'F5
              F6$ = CHR$(64)           'F6
              F7$ = CHR$(65)           'F7
              F8$ = CHR$(66)           'F8
              F9$ = CHR$(67)           'F9
              F10$ = CHR$(68)          'F10
              F10$ = CHR$(133)         'F11
              F10$ = CHR$(134)         'F12

' Verify if SHARED globals are set
              IF ScreenWidth% = 0 THEN ScreenWidth% = 80
              IF LastRow% = 0 THEN LastRow% = 24
              TotalScreenLength% = LastRow% * ScreenWidth%
              IF EmptySpaceChar$ = "" THEN EmptySpaceChar$ = CHR$(32)

' If not specified then supply defaults to incoming vars
              IF AllowCharsMask$ = "" THEN AllowCharsMask$ = CHR$(34) + " !#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
              IF EndingKeys$ = "" THEN EndingKeys$ = CHR$(13)
              IF Row% = 0 THEN Row% = CSRLIN
              IF Col% = 0 THEN Col% = POS(0)
              ReturnVar$ = Default$
              IF FieldLen% = 0 THEN FieldLen% = LEN(ReturnVar$)
              IF FieldLen% <= LEN(ReturnVar$) THEN GOTO FieldLenOk
              ReturnVar$ = ReturnVar$ + STRING$(FieldLen% - LEN(ReturnVar$), EmptySpaceChar$)
              FieldLen% = LEN(ReturnVar$)
              Default$ = ReturnVar$
              
FieldLenOk:
' Define internal defaults

              CursPos% = 1
              ReturnVar$ = Default$
              Separator$ = " !#$%&'()*+,-./:;<=>?@[\]^_`{|}~" + CHR$(34) ' Valid separators for CTRL+LEFT or CTRL+RIGHT
              IF TabLen% = 0 THEN TabLen% = 8 ' Tabulator lenght
              NotDone% = 1
              standard% = 6 'Cursor Shape if in Standard Mode
              Insert% = 4   'Cursor Shape if in Insert Mode
              CurShape% = standard%

'  MAIN LOOP STARTS HERE 
              Riga% = Row%: Lonna% = Col%
              DO
              LOCATE Riga%, Lonna%, 0
              IF Lonna% + LEN(ReturnVar$) > ScreenWidth% THEN
              Part1$ = LEFT$(ReturnVar$, ScreenWidth% - Lonna% + 1)
              Part2$ = RIGHT$(ReturnVar$, LEN(ReturnVar$) - (ScreenWidth% - Lonna% + 1))
              ELSE
              Part1$ = ReturnVar$: Part2$ = ""
              END IF
              PRINT Part1$; Part2$;

              RowCurs% = INT((Lonna% + CursPos% - 1) / ScreenWidth%)
              ColCurs% = (Lonna% + CursPos% - 1) MOD ScreenWidth%
              IF ColCurs% = 0 THEN ColCurs% = ScreenWidth%: RowCurs% = RowCurs% - 1
              VirtPos% = (Riga% * ScreenWidth% - 1) + Lonna% + FieldLen%
              IF VirtPos% > TotalScreenLength% THEN
              Riga% = Riga% - (INT((VirtPos% - TotalScreenLength% - 1) / ScreenWidth%))

              LOCATE Riga%, Lonna%, 0
              END IF
              LOCATE Riga% + RowCurs%, ColCurs%, 1, CurShape%, 7
              DO
              KeyStroke$ = INKEY$
              LOOP WHILE KeyStroke$ = ""


              If INSTR(AllowCharsMask$, KeyStroke$) > 0 THEN
              Mark% = 0'No Backspace at Posit. 0
              IF CurShape% = standard% THEN
              MID$(ReturnVar$, CursPos%, 1) = KeyStroke$

              ELSE
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + KeyStroke$ + MID$(ReturnVar$, CursPos%, FieldLen% - CursPos%)
              END IF

              IF CursPos% < FieldLen% THEN
              CursPos% = CursPos% + 1
              ELSE
              IF MyVal(1) <> 0 AND FieldLen%>1 THEN BEEP
              END IF
              ELSE

              IF INSTR(EndingKeys$, KeyStroke$) > 0 THEN
              ExitKey$ = KeyStroke$
              NotDone% = 0
              ELSE
'  Check for other keys  

              SELECT CASE KeyStroke$
              CASE CursLeft$
              IF CursPos% > 1 THEN
              CursPos% = CursPos% - 1
              END IF
              CASE CursRight$
              IF CursPos% < FieldLen% THEN
              CursPos% = CursPos% + 1
              END IF
              CASE BackS$
              IF CursPos% > 1 THEN
              Mark% = 0'No Backspace at Posit. 0
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 2) + RIGHT$(ReturnVar$, FieldLen% - CursPos% + 1) + EmptySpaceChar$
              CursPos% = CursPos% - 1
              ELSE
              Mark% = Mark% + 1:
              SOUND Mark% * 400 + 500, 1
              IF Mark% > 7 THEN
              Mark% = 0
              ReturnVar$ = Default$
              ' IF LEN(ReturnVar$) < FieldLen% THEN
              '    ReturnVar$ = ReturnVar$ + SPACE$(FieldLen% - LEN(ReturnVar$))
              ' END IF
              END IF
              END IF
              CASE Delete$
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + RIGHT$(ReturnVar$, FieldLen% - CursPos%) + EmptySpaceChar$
              CASE Insert$, CtrlR$
              IF CurShape% = standard% THEN
              CurShape% = Insert%
              ELSE CurShape% = standard%
              END IF

              CASE Home$, CtrlK$  ' Cursor to field start
              CursPos% = 1

              CASE End$, CtrlN$  ' Cursor to field end
              CursPos% = LEN(ReturnVar$)

              CASE CursUp$  ' Cursor 1 line up
              IF CursPos% > ScreenWidth% THEN CursPos% = CursPos% - ScreenWidth%

              CASE CursDown$ ' Cursor 1 line down
              IF CursPos% + ScreenWidth% < LEN(ReturnVar$) + 1 THEN CursPos% = CursPos% + ScreenWidth%

              CASE CtrlHome$  ' Cancel all chars from Cursor Position -1  up to start
              ReturnVar$ = RIGHT$(ReturnVar$, FieldLen% - CursPos% + 1) + STRING$(CursPos% - 1, EmptySpaceChar$)
              CursPos% = 1

              CASE CtrlEnd$, CtrlE$ ' Ctrl+ E = Cancel all chars from Cursor Posit. up to end
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + STRING$(FieldLen% - CursPos% + 1, EmptySpaceChar$)

              CASE PageUp$  ' Cursor to 1st line
              DO WHILE CursPos% > ScreenWidth%
              CursPos% = CursPos% - ScreenWidth%
              LOOP

              CASE PageDown$ ' Cursor to last line
              DO WHILE CursPos% + ScreenWidth% < LEN(ReturnVar$) + 1
              CursPos% = CursPos% + ScreenWidth%
              LOOP

              CASE CtrlCursLeft$, CtrlB$ ' Ctrl+ B = Cursor to the word on the left
              IF CursPos% > 1 THEN
              P% = CursPos% - 1
              DO WHILE (P% > 1) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) > 0
              P% = P% - 1
              LOOP

              DO WHILE (P% > 1) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) = 0
              P% = P% - 1
              LOOP
              CursPos% = P%
              IF CursPos% < 1 THEN CursPos% = 1
              IF CursPos% > 1 THEN CursPos% = CursPos% + 1
              END IF

              CASE CtrlCursRight$, CtrlF$ ' Ctrl+ F = Cursor to the word on the right
              P% = CursPos%
              DO WHILE (P% < FieldLen%) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) = 0
              P% = P% + 1
              LOOP
              DO WHILE (P% < FieldLen%) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) > 0
              P% = P% + 1
              LOOP

              CursPos% = P%
              IF CursPos% > FieldLen% THEN CursPos% = FieldLen%

              CASE Esc$, CtrlU$  ' Ctrl+ U = Clear all input field, if Escape is not
              ' activate to exit by XINPUT caller
              ReturnVar$ = STRING$(FieldLen%, EmptySpaceChar$)
              CursPos% = 1

              CASE Tabul$  ' Tabulator in QBasic works in the following way:
              ' Cursor moves to past the NEXT 8th character,
              '   character 1 in string being 1st character.
              ' I.e., to 9th, 17th, 25th, 33rd character and so on.
              ' If INSERT key is not active, up to 8 character will be blanked.
              ' If INSERT key is ACTIVE, up to 8 blanks will be INSERTED.

              P% = (INT((CursPos% - 1 + TabLen%) / TabLen%) * TabLen%) + 1 ' Find Cursor position of next tabulation
              IF P% > FieldLen% + 1 THEN P% = FieldLen% + 1
              IF CursPos% > 1 THEN R1$ = LEFT$(ReturnVar$, CursPos% - 1) ELSE R1$ = ""
              IF CurShape% = standard% THEN
              IF CursPos% < P% THEN R2$ = RIGHT$(ReturnVar$, FieldLen% - P% + 1) ELSE R2$ = ""
              ELSE
              IF CursPos% < FieldLen% THEN R2$ = MID$(ReturnVar$, CursPos%, FieldLen% + 1 - P%) ELSE R2$ = ""
              END IF
              ReturnVar$ = R1$ + STRING$(P% - CursPos%, CHR$(32)) + R2$
              IF P% > FieldLen% THEN P% = FieldLen%
              CursPos% = P%
              
              Case CTRLC$  ' CTRL+ C
              If Len(ReturnVar$)>0 Then MyName$(13)=ReturnVar$
              
              Case CTRLV$  ' CTRL+ V
              If Len(MyName$(13))=0 Then GoTo SelectEnd
              If Len(MyName$(13)) > Len(ReturnVar$) Then ReturnVar$= left$(MyName$(13),Len(ReturnVar$)) Else ReturnVar$=MyName$(13)
              CursPos% = 1
              
              Case ELSE
              SOUND 500, 1
              End SELECT
SelectEnd:      
              
              END IF
              End IF
              LOOP WHILE NotDone%

'  Exit from here  

              RealStrLen% = LEN(ReturnVar$)
              Xinput$ = ReturnVar$
              END FUNCTION

