' - Paolo Bagnaresi, July 2000 - January 2004 - May 2004 - September 2009 e-mail: paolo.bagnaresi@fastwebnet.it
' 
'
' This module can Launch different qbasic programs with a CHAIN qbasic instruction.
' Just add the same COMMON arrays to your launchees. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.
' 
' To add a new entry in any menu: 
' 1) Find the proper menu: TI Menu, DOSMenu, Utilities. Add entry:
' 2) as a String to be displayed, i.e. " 3) Transfer a PC-99 disk image file to a TI99-PC disk image file"
' 3) as an item in the corresponding entry in CASE list: TI Menu, DOSMenu, Utilities, i.e. InpFld%=1 : GOSUB PC99toIMAGE
' 4) as a GOSUB called by the new CASE entry, i.e. PC99toIMAGE CLS : ... 
' 5) assign return vectors, usually 3:  a) Source Catalog vector, b) Destin. Catalog vector, c) Return from Program vector, i.e. 21, 22, 23
' 6) update the 'Last Used Vector(1)) = xx at the top of this file (just a REM), i.e. 23 
' 7) as a CALL RunScreen() in the GOSUB [insert there the new return vectors], i.e. CALL RunScreen(13, Title$, "","",SourPF$, V9T9Path%, DestPF$, IMGTI99%, TabChng$, 21, 22, 23, PC992I$,InpFld%,HelpArg1$,HelpArg2$,ChkVF1%,ChkVF2%)
' 8) assign the new Program Name to be run, i.e. PC992I$="PC992I-2.bas"  
' 9) insert new return vectors in the suitable return vector table [TIDisk (for TI Menu), DOSDisk (for DOSMenu)], i.e. CASE 23  InpFld%=2 : GOSUB PC99toIMAGE  


DECLARE SUB box (Y%, X%, W%, H%, t$)
DECLARE SUB Fischio ()
DECLARE SUB Pranyk ()
DECLARE SUB RunScreen (Depth%, Title$,Titl2$,Titl3$, Source$, SPath%, Destin$, DPath%, BotMsg$, Cat1%, Cat2%, Exec%, ExePrg$,InpFld%,HelpArg1$,HelpArg2$,ChkVF1%,ChkVF2%)
DECLARE FUNCTION Xinput$ (Row%, Col%, FieldLen%, Default$, AllowCharsMask$, EndingKeys$, ExitKey$, RealStrLen%)
DIM Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER

COMMON SHARED Endk$
COMMON SHARED TI2PC$
DIM SHARED PcCat$
DIM SHARED TIDir$
DIM SHARED DoubleBorder$    ' Double Border Box characters
DIM SHARED SingleBorder$
DEFINT A-Z      
              TYPE IDXType
              Section AS STRING * 20
              StartRec AS DOUBLE
              RecLength AS SINGLE
              END TYPE
              DIM SHARED IDXRecord AS IDXType
' MyName$() Indexes 
CONST PC99path% = 21          ' PC 99 Path, usually c:\pc99\dsk\t1.dsk                       
CONST IMGTI99% = 22           ' Standard path, usually C:\temp\ti-pc.img
CONST TIdskPath% = 23         ' TI floppy disk drive path, usually B:
CONST V9T9Path% = 24          ' V9T9 Path, usually c:\V9T9run\disks\t1.dsk
CONST ExtrPath% = 25          ' Extract path, usually C:\Extract
CONST AnaPath% = 26           ' Anadisk Dump path, usually c:\temp\Image.ana
CONST SplitPath% = 27         ' Split Path; if undefined, it becomes = ExtrPath%



DEFINT A-Z
'Last Used Vector(1)= 38
'MyName$(0) = "F:\Sources\QBasic\main-02.bas"   ' MAIN Program
'MyName$(1) = "F:\Sources\QBasic\"              ' Main Program Directory
'MyName$(2) = ""                                ' Temp Buffer to and from Disk Catalog
'MyName$(3) = ""                                ' Source file for Chained programs
'MyName$(4) = ""                                ' TI-99/4A Menu User Choice Copy: Don't initialize it
'MyName$(5) = ""                                ' Destination file for Chained programs
'MyName$(6) = ""                                ' Util  User Choice Copy: Don't initialize it
'MyName$(7) = ""                                ' Main  Menu User Choice Copy: Don't initialize it
'MyName$(8) = ""                                ' DOS   Menu User Choice Copy: Don't initialize it
'MyName$(9) = ""                                ' Tools Menu User Choice Copy: Don't initialize it
'MyName$(10) = ""                               ' Temp Variable to pass strings to Chained programs. Rewritten again each
              '     time a chained program is accessed.
'MyName$(11) = ""                               ' TI-Dir return program name. Unshared, so it can be called from any program
'MyName$(12) = ""                               ' TI-Dir - Disk image filename TI-Dir has to work upon. Unshared, so it can be called from any program
'MyName$(13) = ""                               ' Xinput String Copy Buffer (CTRL+C, CTRL+V)

'MyVal(0)=0                                     ' Current OS: 1-999 = DOS, 1000-1999=Windows95,98,ME, 2000 and above = Windows XP, Vista. 
'                                               ' See file BOOT.BAS for more explanations about the coding system
'MyVal(1)=0                                     ' 0=Sound Disabled, 1= Sound Enabled
'MyVal(2)=0                                     ' "ERR" Error I will return with the "ON ERROR" trap. Useful in SUBs. 0=No error
'                                                 Must be reset to zero once the ERR code carried inside has been taken care of.
'MyVal(3)=40 or whatever value below 80         ' Position at which DOS places the start of a Filename/Directory in the output listing of a "DIR" command.
'                                               ' It varies, depending not only on the DOS version, but even on the OS User's Language
'Vector(1)=                                     ' Return vector

'MyName$(PC99path%) PC99Img$ = c:\pc99\dsk\t1.dsk        = PC99 Path Name
'MyName$(IMGTI99%) TI99PCImg$ = c:\temp\ti-pc.img       = TI99-PC Path Name
'MyName$(TIdskPath%) TIDisk$ = B:                         = TI-99/4A Default Disk Drive
'MyName$(V9T9Path%) V9T9Img$ = c:\V9T9run\disks\t1.dsk   = V9T9 Path Name
'MyName$(ExtrPath%) ExtractPath$ = c:\extract\           = Extract to DOS path Name
'MyName$(AnaPath%) AndskImgFile$ = c:\temp\Image.ana    = Anadisk Dump File Path Name
'MyName$(IMGTI99%) AndskImgFile$ = c:\temp\ti-pc.im1    = Anadisk TI99-PC Path Name

' TI99-PC Programs:
AnaPrg$ = "ConvAna.bas"         ' Opt. 1,8,1 - UTIL 1) Convert Anadisk Dump file to TI99-PC Image
ImprtPrg$ = "DOS2I1.bas"        ' Opt. 2,6 - Import files from DOS or ARK files and store them in a newly built TI99-PC Image File 
Help$ = "Help3.bas"             ' Help - Runs with F1 key from any input field, except while "TI99_PC.COM" is running
ExtrPrg$ = "Extract9.bas"       ' Opt. 1,6 - List and extract TI-99/4A Image File either to DOS or to ARK file
FL2PC99$ = "FL2PC993.bas"       ' Opt. 1,2 and 1,3 - Convert an Image File to PC99 format
FL2V9T9$ = "FL2V9T9.bas"        ' Opt. 1,4 and 1,5 - Convert an Image File to V9T9 format
MainProg$ = "Main-02.bas"       ' Main Program (this one!)
PcCat$ = "PC-Dir05.bas"         ' Lists a PC Directory - Runs from any filename input field in Main Program
PC992I$ = "PC992I-2.bas"        ' Opt. 2,3 - Convert PC99 Image File to a TI99-PC Image File
Split$ = "Splitim9.bas"         ' Opt. 1,7 - Split/Resize any Disk Image file to a new V9T9 file
Img2Dsk$="Img2Dsk.bas"          ' Opt. 2,1 - Copy a TI99-PC file image to TI-99/4A real floppy disk
PC992Dsk$="PC992Dsk.bas"        ' Opt. 2,2 - Copy a PC99 file image to TI-99/4A real floppy disk
'TI2PC$ = "TI99_PC.COM"          ' The assembler program that accesses a TI-99/4A real floppy disk at low-level 
TIDir$ = "TI-Dir.bas"           ' The TI Disk catalog of a TI Disk Image File - - Runs from any filename input field in Main Program
CrVirtl$ = "CrVirtl.bas"        ' Opt. 3,3 - Create a Virtual Disk of any size

ScratchFile$ = "t-__--__.--_"   ' Temporary file created to Convert a TI disk to PC99 or VT99 format

DoubleBorder$ = "ͻͼ"      ' Double Border Box characters
SingleBorder$ = "Ŀ"      ' Single Border Box characters
Endk$ = CHR$(13)
Endk$ = Endk$ + CHR$(27)
Endk$ = Endk$ + CHR$(9)
Endk$ = Endk$ + CHR$(0) + CHR$(72) '
Endk$ = Endk$ + CHR$(0) + CHR$(80) ' Arrow Up
Endk$ = Endk$ + CHR$(0) + CHR$(59) ' F1 = Help 
Endk$ = Endk$ + CHR$(0) + CHR$(63) ' F5  Key
Endk$ = Endk$ + CHR$(0) + CHR$(64) ' F6  Key
Endk$ = Endk$ + CHR$(0) + CHR$(68) ' F10 Key

TabChng$ = "Enter=Execute, TAB=input fields, ESC=Abort, F5-F6=TI-DOS listing, F1=Help"

Dest$ = "Destination"
Path$=" Path"
DestP$ = Dest$+Path$
PnF$=Path$+" and Filename"
DestPF$ = Dest$ + PnF$
Sour$ = "Source"
SourPF$ = Sour$+PnF$
SourDrv1$= "TI-99/4A "
SourDrv2$= " Disk Drive (A: or B:)"
SourDrv$= SourDrv1$ + "Source"+SourDrv2$
DestnDrv$= SourDrv1$ + Dest$+SourDrv2$

CONST ChkPath%     = 1   ' Check if path exists.
CONST ChkFilXist%  = 2   ' Check if path\filename exists.
CONST ChkFilCreat% = 4   ' Check if filename can be created (i.e. if path exists and filename 
CONST ChkNewFile%  = 8   ' Check if filename is a new one. Issues a warning if it isn't a new one. 
              ' has not the same name of an existing directory)

STATION:   ' All returns from CHAIN will be managed here, at the STATION
              RESET                  ' PB 2004-05-08 - Close all files
              UM$ = MyName$(7)       ' Main Menu user's choice
              UC$ = MyName$(4)       ' TI Menu    "      "
              UD$ = MyName$(8)       ' DOS menu   "      "
              UT$ = MyName$(6)       ' TI Menu Util. "   "
              UU$ = MyName$(9)       ' Tools Menu "   "
              IF MyVal(0)<2000 THEN 
              		TI2PC$ = "TI99_PC.COM"          ' The assembler program that accesses a TI-99/4A real floppy disk at low-level 
	      ELSE 
	      	        TI2PC$ = "TI99-PC.EXE"          ' The Visual Basic program that accesses a TI-99/4A real floppy disk at high level in Windows XP, Vista and 7
	      END IF               			
              IF Vector(1) <> 0 THEN GOTO HndlRet
              
              KillFile "~Merge.DAT"
              GOSUB AssVars  ' Assign user variables
              GOSUB Banner
              GOTO MainMenu
              
HndlRet:        
              SELECT CASE MyName$(7) ' Main Menu User Choice Copy
              CASE "1"
              GOSUB TIDisk
              GOSUB TiMenu
              GOTO MainMenu
              CASE "2"
              GOSUB DOSDISK
              GOSUB DOSMenu
              GOTO MainMenu
              CASE "3"
              GOSUB ToolsM
              GOSUB ToolsMenu
              GOTO MainMenu
              END SELECT
              GOTO MainMenu
              
'==============================================

Banner: ' Call Box(StartRow, StartColumn, Width, Height, Character$)
              
              GOSUB OutputBanner
              LOCATE 24, 20: PRINT "Press any key to begin... or F1 for help.";
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
              IF K$ = CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "01.01.00")  ' : CLS : GOTO Banner
              IF K$ = CHR$(27) THEN GOTO FExit
              CLS
              RETURN
              
OutputBanner:
              CLS
              CALL box(1, 1, 80, 25, DoubleBorder$)
              
              LOCATE 3, 8: PRINT "                     "
              LOCATE 4, 8: PRINT "                                          "
              LOCATE 5, 8: PRINT "                               "
              LOCATE 6, 8: PRINT "                                        "
              
              LOCATE 8, 4: PRINT "A transfer program for old TI-99/4A floppies (all Densities and Sides)"
              LOCATE 10, 4: PRINT "- Version 3.2.1 of September 2009 - Windows XP, Vista and 7 supported -";
              LOCATE 12, 1: PRINT"͹";
              LOCATE 14, 10: PRINT "Author: Paolo Bagnaresi, Italy, paul.bagnaresi@gmail.com"
              LOCATE 16, 10: PRINT "Revision: Andrew R. Becker, U.S.A., ab31@juno.com"
              LOCATE 18, 10: PRINT "Editing: Peter Killick, U.K., peter.killick@btinternet.com"
              LOCATE 20, 10: PRINT "Driver: OmniFlop, Sherlock Consulting Limited,"
              LOCATE 21, 18: PRINT "by Jason Watton, U.K., jasonwatton@hotmail.com"

              
              RETURN

'==============================================       
MainMenu:
              Cls
              CALL box(1, 1, 80, 23, SingleBorder$)
              
              LOCATE 2, 34: PRINT "TI99-PC MAIN MENU"
              
              LOCATE 4, 3: PRINT " 1) FROM TI-99/4A disk to DOS or Emulators"
              LOCATE 5, 3: PRINT " 2) TO TI-99/4A disk from Emulators or DOS"
              LOCATE 6, 3: PRINT " 3) Tools"
              LOCATE 7, 3: PRINT " 4) Help and Acknowledgements"
              LOCATE 8, 3: PRINT " 0) Exit"
              
              
              LOCATE 22, 3: PRINT "Your choice:"
              
MainAgain:      
              LOCATE 22, 17, 1
              IF UM$ = "" THEN UM$ = MyName$(7)
              PRINT UM$
              LOCATE 22, 17, 1

MainWaitAgain: DO: UM$ = INKEY$: LOOP UNTIL UM$ <> ""
              IF UM$ =CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "10.02.00") : UM$=MyName$(7) : GOTO MainMenu
              IF UM$ = CHR$(27) THEN UM$ = MyName$(7): GOSUB ExitProg: GOTO MainMenu
              IF UM$ = CHR$(0) + CHR$(31) THEN GOSUB SoundToggle: GOTO MainWaitAgain
              IF UM$ = CHR$(13) AND MyName$(7) <> "" THEN UM$ = MyName$(7)
              IF UM$ < "0" OR UM$ > "6" THEN GOTO MainWaitAgain
              MyName$(7) = UM$
              
              LOCATE 22, 17, 1
              SELECT CASE UM$    ' MENU SELECTION

              CASE "1"     '1) TI-99/4A disk to DOS
              
              GOSUB TiMenu

              CASE "2"     '2) DOS to TI-99/4A disk
              
              GOSUB DOSMenu
              
              CASE "3"     '3) DOS to PC Emulators
              GOSUB ToolsMenu
              
              CASE "4"       '6) Help, Hardware Requirements and Acknowledgements
              Vector(1) = 2  ' Vector to return from Help
              CHAIN Help$    ' Return will take place at STATION, CASE=2
              
              
              CASE "0"     ' 0) Exit"
              GOSUB ExitProg: : GOTO MainMenu
              
              CASE ELSE
              GOTO MainWaitAgain
              
              END SELECT
              GOTO MainMenu

'==============================================       
TiMenu:
              CLS
              GOSUB TiShowMenu

TiAgain:
              LOCATE 22, 17, 1
              IF UC$ = "" THEN UC$ = MyName$(4)
              PRINT UC$
              LOCATE 22, 17, 1

TiWaitAgain:     DO: UC$ = INKEY$: LOOP UNTIL UC$ <> ""
              IF UC$ =CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "11.01.01") : UC$=MyName$(4) : GOTO TiMenu
              IF UC$ = CHR$(27) THEN UC$ = MyName$(4): RETURN
              IF UC$ = CHR$(0) + CHR$(31) THEN GOSUB SoundToggle: GOTO TiWaitAgain
              IF UC$ = CHR$(13) AND MyName$(4) <> "" THEN UC$ = MyName$(4)
              IF UC$ < "0" OR UC$ > "9" THEN GOTO TiWaitAgain
              MyName$(4) = UC$
              
              LOCATE 22, 17, 1
              PRINT UC$
              SELECT CASE UC$    ' MENU SELECTION

              CASE "1"     '1) Transfer a TI-99/4A floppy disk to a PC file, in plain disk image format
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO TiMenu
              GOSUB STDIMAGE

              CASE "2"     '2) Transfer a TI-99/4A floppy disk to a PC-99 disk image file
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO TiMenu
              GOSUB FLOPPY2PC99
              
              CASE "3"     '3) Transfer disk image file to a PC-99 disk image file
              InpFld%=1 : GOSUB IMG2PC99
              
              CASE "4"     '4) Transfer a TI-99/4A floppy disk to a V9T99 disk image file
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO TiMenu
              GOSUB FLOPPY2V9T9
              
              CASE "5"     '5) Transfer disk image file to a V9T9 disk image file
              InpFld%=1 : GOSUB IMG2V9T9
              
              
              CASE "6"     '6) Extract (to DOS or ARK file) single TI-Files from any disk image file
              InpFld%=1 : GOSUB SELPATH
              
              CASE "7"     ' 7) Split/Resize any Disk Image file to a new V9T9 file
              InpFld%=1 : GOSUB Split

              CASE "8"     ' 8) Utilities
              GOSUB UTIL     ' Vector to return from Help
              
              
              CASE "9"     ' 9) Help and Hardware Requirements
              Vector(1) = 2  ' Vector to return from Help
              CHAIN Help$    ' Return will take place at STATION, CASE=2
              
              CASE "0"     ' 0) Exit
              RETURN

              END SELECT
              GOTO TiMenu
              
'==============================================
DOSMenu:

              CLS
              GOSUB DOSShowMenu

DOSAgain:
              LOCATE 22, 17, 1
              IF UD$ = "" THEN UD$ = MyName$(8)
              PRINT UD$
              LOCATE 22, 17, 1

DOSWaitAgain:  DO: UD$ = INKEY$: LOOP UNTIL UD$ <> ""
              IF UD$ =CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "12.01.01") : UD$=MyName$(8) : GOTO DOSMenu
              IF UD$ = CHR$(27) THEN UD$ = MyName$(8): RETURN
              IF UD$ = CHR$(0) + CHR$(31) THEN GOSUB SoundToggle: GOTO DOSWaitAgain
              IF UD$ = CHR$(13) AND MyName$(8) <> "" THEN UD$ = MyName$(8)
              IF UD$ < "0" OR UD$ > "9" THEN GOTO DOSWaitAgain
              MyName$(8) = UD$
              
              LOCATE 22, 17, 1
              PRINT UD$
              SELECT CASE UD$    ' MENU SELECTION

              CASE "1"     '1) Transfer a TI99-PC DOS image file to a TI-99/4A floppy disk
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO DOSMenu
              GOSUB TI99ImgToFloppy
              GOTO DOSMenu

              CASE "2"     '2) Transfer a PC-99 disk image file to a TI-99/4A floppy disk
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO DOSMenu
              GOSUB PC99toDSK: GOTO DOSMenu
              
              CASE "3"     '3) Transfer a PC-99 disk image file to a TI99-PC DOS image file
              InpFld%=1 : GOSUB PC99toIMAGE
              GOTO DOSMenu
              
              CASE "4"     '4) Transfer a V9T9 disk image file to a TI-99/4A floppy disk
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO DOSMenu
              GOSUB V9T9toDSK: GOTO DOSMenu
              
              CASE "5"     '5) Transfer a V9T9 disk image file to a TI99-PC DOS image file
              InpFld%=1 : GOSUB V9T9toIMAGE
              GOTO DOSMenu
              
              CASE "6"     '6) Import Files from DOS or ARK files to a V9T9 disk image file
              InpFld%=1 : GOSUB DOS2IMG: GOTO DOSMenu
              
              CASE "7"     ' 7) Format a TI-99/4A floppy disk
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO DOSMenu
              Exec$ = TI2PC$ + " /MENU"  '+ " >NUL"
              SHELL Exec$
              GOTO DOSMenu

              CASE "8"     ' 8) Utilities
              GOSUB NotYet: GOTO DOSMenu
              
              CASE "9"     ' 9) Help and Hardware Requirements
              Vector(1) = 2  ' Vector to return from Help
              CHAIN Help$    ' Return will take place at STATION, CASE=2
              
              
              CASE "0"     ' 0) Exit
              RETURN

              END SELECT
              GOTO DOSMenu

NotYet:       CALL box(20, 20, 50, 3, DoubleBorder$)
              LOCATE 21, 21: PRINT " Option not ready yet... Sorry about that!";
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
              IF K$ =CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "")
              RETURN

'==============================================
ToolsMenu:

              CLS
              GOSUB ToolsShowMenu
ToolsAgain:
              LOCATE 22, 17, 1
              IF UU$ = "" THEN UU$ = MyName$(9)
              PRINT UU$
              LOCATE 22, 17, 1

ToolsWaitAgain:  DO: UU$ = INKEY$: LOOP UNTIL UU$ <> ""
              IF UU$ =CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "13.01.00") : UU$=MyName$(9) : GOTO ToolsMenu
              IF UU$ = CHR$(27) THEN UU$ = MyName$(9): RETURN
              IF UU$ = CHR$(0) + CHR$(31) THEN GOSUB SoundToggle: GOTO ToolsWaitAgain
              IF UU$ = CHR$(13) AND MyName$(9) <> "" THEN UU$ = MyName$(9)
              IF UU$ < "0" OR UU$ > "9" THEN GOTO ToolsWaitAgain
              MyName$(9) = UU$
              
              LOCATE 22, 17, 1
              PRINT UU$
              SELECT CASE UU$    ' MENU SELECTION

              CASE "1"     '1) TI Disk Formatter and other Floppy Utilities
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO ToolsMenu
              Exec$ = TI2PC$ + " /MENU"  '+ " >NUL"
              SHELL Exec$
              GOTO ToolsMenu

              CASE "2"     '2) Floppy Disk Catalog
              GOSUB DoesOSallowit : IF DU$<>"" THEN GOTO ToolsMenu
              Exec$ = TI2PC$ + " /DIR"  '+ " >NUL"
              SHELL Exec$
              GOTO ToolsMenu
              
              CASE "3"     '3) Format a V9T9 Disk of any size / Add Subdirs to an existing V9T9 disk"
              InpFld%=1 : GOSUB FormatVirtual 
              GOTO ToolsMenu
              
              CASE "4"     '4)
              GOSUB NotYet: GOTO ToolsMenu
              
              CASE "5"     '5)
              GOSUB NotYet: GOTO ToolsMenu
              
              CASE "6"     '6)
              GOSUB NotYet: GOTO ToolsMenu
              
              CASE "7"     ' 7)
              GOSUB NotYet: GOTO ToolsMenu

              CASE "8"     ' 8)
              GOSUB NotYet: GOTO ToolsMenu
              
              CASE "9"     ' 9)
              GOSUB NotYet: GOTO ToolsMenu
              
              CASE "0"     ' 0) Exit
              RETURN

              END SELECT
              GOTO ToolsMenu

              
'==============================================

ExitProg:       ' GOSUB OutputBanner
              CALL box(20, 18, 53, 3, DoubleBorder$)
              LOCATE 21, 20: PRINT " Final Exit - Press Enter to confirm - [OS: ";RTRIM$(LTRIM$(STR$(MyVal(0))));"]";
              LOCATE 21, 69
              DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
              IF K$ <> CHR$(13) THEN RETURN
FExit:  CLS
              SYSTEM
              END
              
'==============================================
              

TiShowMenu:
              CALL box(1, 1, 80, 23, SingleBorder$)
              
              LOCATE 2, 26: PRINT "FROM TI-99/4A DISK MENU"
              
              LOCATE 4, 3: PRINT " 1) Transfer a TI-99/4A floppy disk to TI99-PC disk image file"
              LOCATE 5, 3: PRINT " 2) Transfer a TI-99/4A floppy disk to a PC-99 disk image file"
              LOCATE 6, 3: PRINT " 3) Transfer any disk image file to a PC-99 disk image file"
              LOCATE 7, 3: PRINT " 4) Transfer a TI-99/4A floppy disk to a V9T9 disk image file"
              LOCATE 8, 3: PRINT " 5) Transfer a TI99-PC disk image file  to a V9T9 disk image file"
              LOCATE 9, 3: PRINT " 6) Extract (to DOS or ARK file) single TI-Files from any disk image file"
              LOCATE 10, 3: PRINT " 7) Split/Resize any Disk Image file to a new V9T9 file"
              LOCATE 11, 3: PRINT " 8) Utilities"
              LOCATE 12, 3: PRINT " 9) Help, Hardware Requirements and Acknowledgements"
              LOCATE 13, 3: PRINT " 0) Exit"
              
              
              LOCATE 22, 3: PRINT "Your choice:"
              
              RETURN
'==============================================
              
DOSShowMenu:
              CALL box(1, 1, 80, 23, SingleBorder$)
              
              LOCATE 2, 26: PRINT "TO TI-99/4A DISK MENU"
              
              LOCATE 4, 3: PRINT " 1) Transfer any disk image file to a TI-99/4A floppy disk"
              LOCATE 5, 3: PRINT " 2) - superseeded - "
              LOCATE 6, 3: PRINT " 3) Transfer a PC-99 disk image file to a V9T9 disk image file"
              LOCATE 7, 3: PRINT " 4) - superseeded -"
              LOCATE 8, 3: PRINT " 5) - superseeded - "
              LOCATE 9, 3: PRINT " 6) Import Files from DOS or ARK files to a V9T9 disk image file"
              LOCATE 10, 3: PRINT " 7) Format a TI-99/4A floppy disk"
              LOCATE 11, 3: PRINT " 8) Utilities"
              LOCATE 12, 3: PRINT " 9) Help, Hardware Requirements and Acknowledgements"
              LOCATE 13, 3: PRINT " 0) Exit"
              
              
              LOCATE 22, 3: PRINT "Your choice:"
              
              RETURN
'==============================================
              
ToolsShowMenu:
              CALL box(1, 1, 80, 23, SingleBorder$)
              
              LOCATE 2, 37: PRINT "TOOLS MENU"
              
              LOCATE 4, 3: PRINT " 1) Floppy Disk Formatter and other Floppy Utilities"
              LOCATE 5, 3: PRINT " 2) Floppy Disk Catalog"
              LOCATE 6, 3: PRINT " 3) Format a V9T9 Disk of any size / Add Subdirs to an existing V9T9 disk"
              LOCATE 7, 3: PRINT " 4) " ' User's selected .BAS program of TI99-PC type"
              LOCATE 8, 3: PRINT " 5) "
              LOCATE 9, 3: PRINT " 6) "
              LOCATE 10, 3: PRINT " 7) "
              LOCATE 11, 3: PRINT " 8) "
              LOCATE 12, 3: PRINT " 9) Run any program"
              LOCATE 13, 3: PRINT " 0) Exit"
              
              
              LOCATE 22, 3: PRINT "Your choice:"
              
              RETURN
'==============================================
TIDisk:       
              SELECT CASE Vector(1)
              CASE 1 ' Return from PC Disk Catalog, called by 4)EXTRACT, Get Source
              MyName$(IMGTI99%) = MyName$(2)
              InpFld%=1 : GOSUB SELPATH
              CASE 2 ' Return from HELP, called by 9)HELP
              CASE 3 ' Return from EXTRACT, called by 6)EXTRACT
              InpFld%=1 : GOSUB SELPATH
              CASE 4 ' Return from PC Disk Catalog, called by 1)Create a Disk Image file from a TI-99/4A
              MyName$(IMGTI99%) = MyName$(2)
              GOSUB STDIMAGE
              CASE 5 ' Vector to return from PC DiskCatalog of 2) TRANSFER A TI-99/4A FLOPPY DISK TO A PC-99 DISK IMAGE FILE
              MyName$(PC99path%) = MyName$(2)
              GOSUB FLOPPY2PC99
              CASE 6 ' Vector to return from 2) TRANSFER A TI-99/4A FLOPPY DISK TO A PC-99 DISK IMAGE FILE
              CASE 7 ' Vector to return from Source PC DiskCatalog of 3) TRANSFER DISK IMAGE FILE TO A PC-99 DISK IMAGE FILE
              MyName$(IMGTI99%) = MyName$(2)
              InpFld%=1 : GOSUB IMG2PC99
              CASE 8 ' Vector to return from Destin. PC DiskCatalog of 3) TRANSFER DISK IMAGE FILE 1) TO A PC-99 DISK IMAGE FILE
              MyName$(PC99path%) = MyName$(2)
              InpFld%=2 : GOSUB IMG2PC99
              CASE 9 ' Vector to return  3) TRANSFER DISK IMAGE FILE TO A PC-99 DISK IMAGE FILE
              InpFld%=2 : GOSUB IMG2PC99
              CASE 10 ' Vector to return from Source PC DiskCatalog of 7) Split/Resize any Disk Image file to a new V9T9 file
              MyName$(IMGTI99%) = MyName$(2)
              InpFld%=1 : GOSUB Split
              CASE 11 ' Vector to return from 7) Split/Resize any Disk Image file to a new V9T9 file
              InpFld%=2 : GOSUB Split
              CASE 12 ' Vector to return from Destin. PC DiskCatalog of 7) Split/Resize any Disk Image file to a new V9T9 file
              MyName$(SplitPath%) = MyName$(2)
              InpFld%=2 : GOSUB Split
              CASE 13 ' Vector to return from Source PC DiskCatalog of 5) TRANSFER DISK IMAGE FILE TO A V9T9 DISK IMAGE FILE
              MyName$(IMGTI99%) = MyName$(2)
              InpFld%=1 : GOSUB IMG2V9T9
              CASE 14 ' Vector to return from Destin. PC DiskCatalog of 5) TRANSFER DISK IMAGE FILE TO A V9T9 DISK IMAGE FILE
              MyName$(V9T9Path%) = MyName$(2)
              InpFld%=2 : GOSUB IMG2V9T9
              CASE 15 ' Vector to return  5) TRANSFER DISK IMAGE FILE TO A V9T9 DISK IMAGE FILE
              InpFld%=2 : GOSUB IMG2V9T9
              CASE 16 ' Vector to return Destin. from PC DiskCatalog of 2) TRANSFER A TI-99/4A FLOPPY DISK TO A V9T9 DISK IMAGE FILE
              MyName$(V9T9Path%) = MyName$(2)
              GOSUB FLOPPY2V9T9
              CASE 17 ' Vector to return from 4) TRANSFER A TI-99/4A FLOPPY DISK TO A V9T9 DISK IMAGE FILE
              CASE 18 ' Vector to return from Source PC DiskCatalog of UTIL 1) TRANSFER AN ANADISK (SYBEX) DUMP FILE TO TI99-PC DISK IMAGE FILE
              MyName$(AnaPath%) = MyName$(2)
              InpFld%=1 : GOSUB ANDSK2IMG
              CASE 19 ' Vector to return from Destin. PC DiskCatalog of 1) TRANSFER AN ANADISK (SYBEX) DUMP FILE TO TI99-PC DISK IMAGE FILE
              MyName$ (IMGTI99%) = MyName$(2)
              InpFld%=2 : GOSUB ANDSK2IMG
              CASE 20 ' Vector to return  1) TRANSFER AN ANADISK (SYBEX) DUMP FILE TO TI99-PC DISK IMAGE FILE
              InpFld%=2 : GOSUB ANDSK2IMG
              CASE 24 ' Return from PC Disk Catalog, called by 4)EXTRACT, Get Destination
              MyName$(ExtrPath%) = MyName$(2)
              InpFld%=2 :GOSUB SELPATH
              END SELECT
              RETURN
'==============================================       
DOSDisk:              
              SELECT CASE Vector(1)
              CASE 2 ' Return from HELP, called by 9)HELP
              CASE 21
              MyName$(PC99path%) = MyName$(2) ' Source Directory to Inspect
              InpFld%=1 : GOSUB PC99toIMAGE        ' 3)Transfer a PC-99 disk image file to a TI99-PC disk image file
              CASE 22
              MyName$(IMGTI99%) = MyName$(2) ' Destination Directory to Inspect
              InpFld%=2 : GOSUB PC99toIMAGE        ' 3)Transfer a PC-99 disk image file to a TI99-PC disk image file
              CASE 23
              InpFld%=2 : GOSUB PC99toIMAGE        ' Vector to return from TO TI99/4A 3)Transfer a PC-99 disk image file to a TI99-PC disk image file
              CASE 25
              MyName$(V9T9Path%) = MyName$(2) ' Source Directory to Inspect 5) Transfer a v9t9 disk image file to a ti99-pc disk image file
              InpFld%=1 : GOSUB V9T9toIMAGE
              CASE 26
              MyName$(IMGTI99%) = MyName$(2) ' Destin. Directory to Inspect 5) Transfer a v9t9 disk image file to a ti99-pc disk image file
              InpFld%=2 : GOSUB V9T9toIMAGE
              CASE 27
              InpFld%=2 : GOSUB V9T9toIMAGE  ' Execute Transfer 5) Transfer a v9t9 disk image file to a ti99-pc disk image file
              CASE 28
              MyName$(ExtrPath%) = MyName$(2) ' Source Directory to Inspect
              InpFld%=1 : GOSUB DOS2IMG
              CASE 29
              MyName$(IMGTI99%) = MyName$(2) ' Destin. Directory to Inspect
              InpFld%=2 : GOSUB DOS2IMG
              CASE 30
              GOSUB DOS2IMG
              CASE 31
              MyName$(IMGTI99%) = MyName$(2) ' Source Directory to Inspect
              GOSUB TI99ImgToFloppy
              CASE 32
              MyName$(IMGTI99%) = MyName$(3) ' Execute Transfer
              GOSUB TI99ImgToFloppy
              CASE 33
              MyName$(PC99path%) = MyName$(2) ' Source Directory to Inspect
              GOSUB PC99toDSK
              CASE 34
              MyName$(PC99path%) = MyName$(3) ' Execute Transfer
              GOSUB PC99toDSK
              CASE 35
              MyName$(V9T9Path%) = MyName$(2) ' Source Directory to Inspect
              GOSUB V9T9toDSK
              CASE 36
              MyName$(V9T9Path%) = MyName$(3) ' Execute Transfer
              GOSUB V9T9toDSK
              
              END SELECT
              RETURN
'==============================================       

ToolsM:              
              SELECT CASE Vector(1)
              CASE 37
              MyName$(IMGTI99%) = MyName$(2) ' Source Directory to Inspect
              InpFld%=1 : GOSUB FormatVirtual
              CASE 38
              InpFld%=1 : GOSUB FormatVirtual
              END SELECT           
              RETURN 
              
              
STDIMAGE:       Title$ = "1) TRANSFER A TI-99/4A FLOPPY DISK TO A PC FILE, IN PLAIN DISK IMAGE FORMAT"
              CALL RunScreen(12, Title$,"","",SourDrv$, TIdskPath%, DestPF$, IMGTI99%, TabChng$, 0,4,0, "",2,"11.01.02","11.01.02",0,ChkFilCreat%)
              IF Vector(1) =9999 THEN GOTO STDIMEsc
              DxPath$=MyName$(IMGTI99%)
              IF MyVal(0)<2000 THEN 
	              	CALL ShortLongName(DxPath$,CR$,3) ' 3 = Create a LongFilename if no ShortFilename exists. Return short filename.
	              	Call KillFile(DxPath$)
	              	Exec$ = TI2PC$ + " " + MyName$(TIdskPath%) + " " + DxPath$  '+ " >NUL"
              	ELSE
              		Exec$ = TI2PC$ + " " + MyName$(TIdskPath%) + " " + CHR$(34) + DxPath$ + CHR$(34) + " /READ" '+ " >NUL"
              END IF 
              
              SHELL Exec$
              CALL Fischio
              CALL PranykLoc
STDIMEsc:                
              RETURN


FLOPPY2PC99:    
              Title$ = "2) TRANSFER A TI-99/4A FLOPPY DISK TO A PC-99 DISK IMAGE FILE"
              CALL RunScreen(12, Title$,"","",SourDrv$, TIdskPath%, DestPF$, PC99path%, TabChng$, 0,5,0, FL2PC99$,2,"11.01.03","11.01.03",0,ChkFilCreat%)
              IF Vector(1) =9999 THEN GOTO FL2PC99Esc

              Call KillFile(ScratchFile$)
              Exec$ = TI2PC$ + " " + MyName$(TIdskPath%) + " " + ScratchFile$ '+ " >NUL"
              IF MyVal(0)>1999 THEN Exec$ = Exec$ + " /READ" ' + " >NUL"
              SHELL Exec$
              RUC$ = INKEY$: IF RUC$ = CHR$(27) THEN GOTO FL2PC99Esc

              Vector(1) = 6     ' Vector to return from 2) TRANSFER A TI-99/4A FLOPPY DISK TO A PC-99 FILE
              MyName$(3) = ScratchFile$  'Temporary file containing TI Image Disk
              MyName$(5) = MyName$(PC99path%)
              CALL ShortLongName(MyName$(5),CR$,3) ' 3 = Create a LongFilename if no ShortFilename exists. Return short filename.
              CHAIN FL2PC99$    ' Return will take place at STATION
              
FL2PC99Esc:
              RETURN


IMG2PC99:
              
              Title$ = "3) TRANSFER DISK IMAGE FILE TO A PC-99 DISK IMAGE FILE"
              CALL RunScreen(13, Title$,"","",SourPF$, IMGTI99%, DestPF$, PC99path%, TabChng$, 7,8,9, FL2PC99$,InpFld%,"17.02.00","17.02.00",ChkFilXist%,ChkFilCreat%)
              RETURN


FLOPPY2V9T9:     

              Title$ = "4) TRANSFER A TI-99/4A FLOPPY DISK TO A V9T9 DISK IMAGE FILE"
              CALL RunScreen(12, Title$,"","",SourDrv$, TIdskPath%, DestPF$, V9T9Path%, TabChng$, 0,16,0, FL2V9T9$,2,"11.01.04","11.01.04",0,ChkFilCreat%)
              IF Vector(1) =9999 THEN GOTO FLOPV9T9esc
              LOCATE 14, 1
              Call KillFile(ScratchFile$)
              Exec$ = TI2PC$ + " " + MyName$(TIdskPath%) + " " + ScratchFile$ '+ " >NUL"
              IF MyVal(0)>1999 THEN Exec$ = Exec$ + " /READ" ' + " >NUL"
	                          
              SHELL Exec$
              RUC$ = INKEY$: IF RUC$ = CHR$(27) THEN GOTO FLOPV9T9esc

              Vector(1) = 17     ' Vector to return from 2) TRANSFER A TI-99/4A FLOPPY DISK TO A PC-99 FILE
              MyName$(3) = ScratchFile$       'Temporary file containing TI Image Disk, Source Path
              MyName$(5) = MyName$(V9T9Path%) ' Destin. Path
              CHAIN FL2V9T9$    ' Return will take place at STATION
FLOPV9T9esc:             
              RETURN
              
IMG2V9T9:

              Title$ = "5) TRANSFER DISK IMAGE FILE TO A V9T9 DISK IMAGE FILE"
              CALL RunScreen(13, Title$,"","",SourPF$, IMGTI99%, DestPF$, V9T9Path%, TabChng$, 13,14,15, FL2V9T9$,InpFld%,"17.02.01","17.02.01",ChkFilXist%,ChkFilCreat%)
              RETURN

SELPATH:
              Title$ = "6) EXTRACT (TO DOS OR ARK FILE) SINGLE TI-FILES FROM ANY DISK IMAGE FILE"
              CALL RunScreen(13, Title$,"","",SourPF$, IMGTI99%, DestP$, ExtrPath%, TabChng$, 1,24,3, ExtrPrg$,InpFld%,"17.03.00","17.03.00",ChkFilXist%,ChkPath%)
              RETURN
Split:                  
              IF MyName$(27) = "" THEN MyName$(27) = MyName$(IMGTI99%): MID$(MyName$(27), LEN(MyName$(27)), 1) = "1"
              Title$ = "7) SPLIT/RESIZE ANY DISK IMAGE FILE TO A NEW V9T9 FILE"
              Titl2$="   Next output file names will have the last char. incremented by 1"
              Titl3$="i.e. TI-FILE.IM1 will be folllowed by TI-FILE.IM2, TI-FILE.IM3 and so on"
              CALL RunScreen(13, Title$,Titl2$,Titl3$,SourPF$, IMGTI99%, DestPF$, SplitPath%, TabChng$, 10,12,11, Split$,InpFld%,"17.04.00","17.04.00",ChkFilXist%,ChkFilCreat%)
              RETURN
              
SoundToggle:    LOCATE 19, 2: COLOR 0, 7
              PRINT "ALT S = Sound Toggle: ";
              IF MyVal(1) = 0 THEN MyVal(1) = 1: PRINT "Enabled"; : CALL Fischio:  ELSE MyVal(1) = 0: PRINT "Disabled";
              PRINT " - Press any key to continue -";
              WHILE INKEY$ = "": WEND
              LOCATE 19, 2: COLOR 7, 0
              PRINT "                                                               ";
              RETURN
              
'
' 8) UTILITIES
UTIL:          CLS
              UT$ = MyName$(6)
              GOSUB UtilMenu
UtilMore:      LOCATE 22, 17
              PRINT UT$;
UtilAgain:     LOCATE 22, 17
              DO: UT$ = INKEY$: LOOP UNTIL UT$ <> ""
              IF UT$ =CHR$(0) + CHR$(59)  THEN CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "18.03.00") : UT$=MyName$(6) : GOTO UTIL
              IF UT$ = CHR$(27) THEN GOTO ExitUtil
              IF UT$ = CHR$(13) AND MyName$(6) <> "" THEN UT$ = MyName$(6)
              IF UT$ < "0" OR UT$ > "9" THEN GOTO UtilAgain
              MyName$(6) = UT$
              
              LOCATE 22, 17, 1
              SELECT CASE UT$    ' MENU SELECTION

              CASE "1"     '1) Transfer an Anadisk (Sybex) Dump file to TI99-PC disk image format"
              GOSUB ANDSK2IMG
              GOTO UTIL
              CASE "2"     '2)
              
              GOTO UtilMore
              CASE "3"     '3)
              
              GOTO UtilMore
              CASE "4"     '4)
              
              GOTO UtilMore
              CASE "5"     '5)
              
              GOTO UtilMore
              CASE "6"     '6)
              
              GOTO UtilMore
              CASE "7"     ' 7)
              
              GOTO UtilMore
              CASE "8"     ' 8)
              
              GOTO UtilMore
              CASE "9"     ' 9)
              
              GOTO UtilMore
              CASE "0"    ' 0) Exit
ExitUtil:
              RETURN
              CASE ELSE

              END SELECT
              GOTO UTIL
              
UtilMenu:
              CALL box(1, 1, 80, 23, SingleBorder$)
              LOCATE 2, 34: PRINT "UTILITIES  - MENU"
              LOCATE 4, 3: PRINT " 1) Transfer an Anadisk (Sybex) Dump file to TI99-PC disk image format"
              LOCATE 5, 3: PRINT " 2) "
              LOCATE 6, 3: PRINT " 3) "
              LOCATE 7, 3: PRINT " 4) "
              LOCATE 8, 3: PRINT " 5) "
              LOCATE 9, 3: PRINT " 6) "
              LOCATE 10, 3: PRINT " 7) "
              LOCATE 11, 3: PRINT " 8) "
              LOCATE 12, 3: PRINT " 9) "
              LOCATE 22, 3: PRINT "Your choice:"
              
              RETURN
'
'UTIL 1) Transfer an Anadisk (Sybex) Dump file to TI99-PC disk image format"
ANDSK2IMG:
              Title$ = "UT: 1) TRANSFER AN ANADISK (SYBEX) DUMP FILE TO TI99-PC DISK IMAGE FORMAT"
              Titl2$="   Dump file from Anadisk v 2.07 must be obtained with INCLUDE SECTOR"
              Titl3$="   ID INFORMATION enabled (mark YES)."
              CALL RunScreen(13, Title$,Titl2$,Titl3$, "Disk image filename", AnaPath%, DestPF$, IMGTI99%, TabChng$, 18, 19, 20, AnaPrg$,InpFld%,"18.03.00","18.03.00",ChkFilXist%,ChkFilCreat%)
              RETURN

TI99ImgToFloppy: Title$ = "1) TRANSFER ANY DISK IMAGE FILE TO A TI-99/4A FLOPPY DISK" 
              MyName$(10)= TI2PC$
              'CALL RunScreen(13, Title$, "","",SourPF$, IMGTI99%, DestnDrv$, TIdskPath%, TabChng$, 31,0,32, Img2Dsk$,1,"12.01.02","12.01.02",ChkFilXist%,0)
              CALL RunScreen(13, Title$, "","",SourPF$, IMGTI99%, DestnDrv$, TIdskPath%, TabChng$, 31,0,32, PC992Dsk$,1,"12.01.02","12.01.02",ChkFilXist%,0)
              RETURN
              
PC99toDSK:      Title$ = "2) TRANSFER A PC99 VIRTUAL DISK TO A TI-99/4A FLOPPY DISK"
              MyName$(10)= TI2PC$
              CALL RunScreen(13, Title$, "","",SourPF$, PC99path%, DestnDrv$, TIdskPath%, TabChng$, 33, 0, 34, PC992Dsk$,InpFld%,"12.01.03","12.01.03",ChkFilXist%,0)
              RETURN
              
PC99toIMAGE:    Title$ = "3) TRANSFER ANY DISK IMAGE FILE TO A V9T9 DISK IMAGE FILE" 
              CALL RunScreen(13, Title$, "","",SourPF$, PC99path%, DestPF$, IMGTI99%, TabChng$, 21, 22, 23, PC992I$,InpFld%,"18.02.00","18.02.00",ChkFilXist%,ChkFilCreat%)
              RETURN
              
V9T9toDSK:      Title$ = "4) TRANSFER A V9T9 DISK IMAGE FILE TO A TI-99/4A FLOPPY DISK"
              MyName$(10)= TI2PC$
              CALL RunScreen(13, Title$, "","",SourPF$, V9T9Path%, DestnDrv$, TIdskPath%, TabChng$, 35, 0, 36, PC992Dsk$,InpFld%,"12.01.02","12.01.03",ChkFilXist%,0)
              RETURN
              
V9T9toIMAGE:    Title$ = "5) TRANSFER A V9T9 VIRTUAL DISK TO A TI99-PC DISK IMAGE FILE"
              CALL RunScreen(13, Title$, "","",SourPF$, V9T9Path%, DestPF$, IMGTI99%, TabChng$, 25,26,27, PC992I$,InpFld%,"18.02.00","18.02.00",ChkFilXist%,ChkFilCreat%)
              RETURN
              
DOS2IMG:        Title$ = " 6) IMPORT FILES FROM DOS OR ARK FILE TO A V9T9 DISK IMG FILE"
              CALL RunScreen(13, Title$,"","",Sour$+Path$, ExtrPath%, DestPF$, IMGTI99%, TabChng$, 28,29,30, ImprtPrg$,InpFld%,"18.04.00","18.04.00",ChkPath%,ChkFilCreat%)
              RETURN
              
' =======================================        
FormatVirtual:   Title$ = " 3) FORMAT A V9T9 DISK OF ANY SIZE/ADD SUBDIRS TO AN EXISTING V9T9 DISK" 
              CALL RunScreen(13, Title$,"","",DestPF$, IMGTI99%, "", 9999 , TabChng$, 37,0,38, CrVirtl$,InpFld%,"13.20.00","13.20.00",ChkFilCreat%+ChkNewFile%,0)
              RETURN 
                            
'===============================              
' ASSIGN USER DEFAULTS TO PATHS (SOURCE AND DESTINATION)
AssVars:
              OPEN "Default.DAT" FOR INPUT AS #1  ' Default Variables
              WHILE EOF(1) = 0
              LINE INPUT #1, A$
              
              t = VAL(A$)
              IF t = 9999 THEN GOTO NoMoreVariab
              
              P1% = INSTR(A$, "=")
              P2% = INSTR(P1% + 1, A$, "=")
              IF P2% = 0 THEN P2% = LEN(A$) + 1
              IF t = 0 OR P1% = 0 THEN GOTO NoVariab
              A$ = MID$(A$, P1% + 1, P2% - P1% - 1)
              A$ =LTRIM$(RTRIM$(A$))
              SELECT CASE t
              CASE PC99path%
              MyName$(PC99path%) = A$
              CASE IMGTI99%
              MyName$(IMGTI99%) = A$
              CASE TIdskPath%
              MyName$(TIdskPath%) = A$
              CASE V9T9Path%
              MyName$(V9T9Path%) = A$
              CASE ExtrPath%
              MyName$(ExtrPath%) = A$
              CASE AnaPath%
              MyName$(AnaPath%) = A$
              END SELECT
NoVariab:             
              WEND
NoMoreVariab:    CLOSE #1
              IF MyName$(PC99path%) = "" THEN MyName$(PC99path%) = "c:\pc99\dsk\t1.dsk"
              IF MyName$(IMGTI99%) = "" THEN MyName$(IMGTI99%) = "c:\temp\ti-pc.img"
              IF MyName$(TIdskPath%) = "" THEN MyName$(TIdskPath%) = "B:"
              IF MyName$(V9T9Path%) = "" THEN MyName$(V9T9Path%) = "c:\V9T9run\disks\t1.dsk"
              IF MyName$(ExtrPath%) = "" THEN MyName$(ExtrPath%) = "c:\extract\"
              IF MyName$(AnaPath%) = "" THEN MyName$(AnaPath%) = "c:\temp\Image.ana"
              RETURN

' See if Operating System allows what the user requested. Only DOS, Windows 95, 98, ME allow low level disk operations. 
DoesOSallowit:
              DU$= "" :  IF MyVal(0)<2300 THEN GOTO DoesOSallow2
              CALL Fischio
              CALL BOX(17, 5, 68, 5, DoubleBorder$)
              COLOR 0, 7
              LOCATE 18, 6: PRINT  " The Operating System you're currently running hasn't been tested "
              LOCATE 19, 6 : PRINT " with the operation you requested.                                "
              LOCATE 20,6 :  PRINT "- Press F6 if you want to try anyway, or any other key to abort  -"
              DO: DU$ = INKEY$: LOOP UNTIL DU$ <> ""
              IF DU$= CHR$(0) + CHR$(64) THEN DU$="" ' F6 = Proceed
              COLOR 7,0
DoesOSallow2: RETURN 


              
Sub RunScreen (Depth, Title$, Title2$,Title3$,Source$, SPath, Destin$, DPath, BotMsg$, Cat1, Cat2, Exec, ExePrg$,CursOn%,HelpArg1$,HelpArg2$,ChkVF1%,ChkVF2%)
' Depth                 = How many rows the Draw Box routine has to create
' Title$,Title2$,Title3$= Top lines to be displayed
' Source$               = Source Message (row 6)
' Spath                 = Source  path: Index of MyName$() array 
' Destin$               = Destin. Message (row 9)
' Dpath                 = Destin. path: Index of MyName$() array
' BotMsg$               = Bottom Message
' Cat1                  = Return vector for disk Source Disk Catalog 
' Cat2                  = Return vector for disk Destin.Disk Catalog 
' Exec                  = Return vector for Executing routine 
' ExePrg$               = Name of program to be executed (CHAINed)
' CursOn%               = What input field has to be activated first: 2=Destinat.; Any other value=Source
' HelpArg1$             = Argument (File Index) of Help File for First  Input Field: the index to the specific argument in the Help file
' HelpArg2$             = Argument (File Index) of Help File for Second Input Field: the index to the specific argument in the Help file
'                         
'
' If Exec = 0, don't execute the program.
' If Cat1 or Cat2 =0, don't execute disk catalog
' If ESC key has been pressed, exit with a Vector(1)=9999


              GOSUB ShowRunScreen
              IF CursOn%=2 THEN GOTO RunScr2
              
RunScr1:       
              MyName$(SPath) = Xinput$(7-L, 4, 72, MyName$(SPath), "", Endk$, Exitk$, RealStrLen%)
              MyName$(SPath) = LTRIM$(RTRIM$(MyName$(SPath)))
              IF Exitk$ = CHR$(27) THEN GOTO RunScrAbort               ' ESC
              IF Exitk$ = CHR$(13) THEN GOTO RunScrExec                ' Enter
              IF Exitk$ = CHR$(0) + CHR$(63) THEN GOTO RunScrCat1      ' F5
              IF Exitk$ = CHR$(0) + CHR$(64) THEN GOTO RunScrCat1      ' F6
              IF Exitk$ = CHR$(0) + CHR$(80) THEN GOTO RunScr2         ' Arrow Down
              IF Exitk$ = CHR$(9) THEN GOTO RunScr2                    ' TAB
              IF Exitk$ <> CHR$(0) + CHR$(59)  THEN GOTO RunScr1       ' F1 = Help
              CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", HelpArg1$)
              GOSUB ShowRunScreen
              GOTO RunScr1
RunScr2:      IF DPath=9999 THEN GOTO RunScr1
              MyName$(DPath) = Xinput$(10-L, 4, 72, MyName$(DPath), "", Endk$, Exitk$, RealStrLen%)
              MyName$(DPath) = LTRIM$(RTRIM$(MyName$(DPath)))
              IF Exitk$ = CHR$(27) THEN GOTO RunScrAbort               ' ESC
              IF Exitk$ = CHR$(13) THEN GOTO RunScrExec                ' Enter
              IF Exitk$ = CHR$(0) + CHR$(63) THEN GOTO RunScrCat2      ' F5
              IF Exitk$ = CHR$(0) + CHR$(64) THEN GOTO RunScrCat2      ' F6
              IF Exitk$ = CHR$(0) + CHR$(72) THEN GOTO RunScr1         ' Arrow Up
              IF Exitk$ = CHR$(9) THEN GOTO RunScr1                    ' TAB
              IF Exitk$ <> CHR$(0) + CHR$(59)  THEN GOTO RunScr2       ' F1 = Help
              CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", HelpArg2$)
              GOSUB ShowRunScreen
              GOTO RunScr2
              
RunScrCat1:       
              IF Cat1=0 THEN  Exec$ = TI2PC$ + " " + MyName$(SPath) + " /DIR"  : SHELL Exec$:  GOSUB ShowRunScreen: GOTO RunScr1
              MyName$(2) = MyName$(SPath)         ' Source Directory to Inspect
              Vector(1) = Cat1    ' Source Catalog
              IF Exitk$ = CHR$(0) + CHR$(63) THEN GOTO RunScrCat3
              CHAIN PcCat$    ' Return will take place at STATION

RunScrCat2:   IF DPath=9999 THEN GOTO RunScr1
              IF Cat2=0 THEN  Exec$ = TI2PC$ + " " + MyName$(DPath) + " /DIR"  : SHELL Exec$:  GOSUB ShowRunScreen: GOTO RunScr2
              MyName$(2) = MyName$(DPath)        ' Destination Directory to Inspect
              Vector(1) = Cat2    ' Destination Catalg
              IF Exitk$ = CHR$(0) + CHR$(63) THEN GOTO RunScrCat3
              CHAIN PcCat$    ' Return will take place at STATION
              
RunScrCat3:   MyName$(11)=MyName$(0) : MyName$(12)=MyName$(2) : CHAIN TIDir$ ' Return will take place at STATION                               


RunScrExec:    

              LOCATE 14, 1
              CALL Fischio

              Vector(1) = Exec    ' Vector to return from CHAINed program
              
              If ChkVF1%<>0 Then If ValidFullPath(MyName$(SPath),ChkVF1%)<>0 Then Cls: GOSUB ShowRunScreen: GoTo RunScr1                            
              IF DPath<>9999 THEN If ChkVF2%<>0 Then If ValidFullPath(MyName$(DPath),ChkVF2%)<>0 Then Cls: GOSUB ShowRunScreen: GoTo RunScr2

              IF Vector(1)=0 THEN GOTO RunScrExit
              
              MyName$(3) = MyName$(SPath)  ' Source Path
              IF DPath<>9999 THEN MyName$(5) = MyName$(DPath)  ' Destination Path
              CHAIN ExePrg$
              GOTO RunScrAbort
ShowRunScreen: 
              CLS
              IF Exec =0 then L=1
              CALL box(1, 1, 80, Depth, SingleBorder$)
              LOCATE 2, 4: PRINT Title$
              LOCATE 3, 4: PRINT Title2$
              LOCATE 4, 4: PRINT Title3$
              LOCATE 6-L, 3: PRINT Source$
              LOCATE 7-L, 3: PRINT "="
              IF DPath<>9999 THEN LOCATE 9-L, 3: PRINT Destin$ : LOCATE 10-L, 3: PRINT "="
              
              LOCATE 12-L, 3
              PRINT BotMsg$
              LOCATE 7-L, 4
              PRINT MyName$(SPath)
              
              IF DPath<>9999 THEN  LOCATE 10-L, 4 : PRINT MyName$(DPath)
              RETURN
              
RunScrAbort:    Vector(1)=9999     ' Abort function  (ESC key pressed)
RunScrExit:
END SUB

Sub box (Y, X, W, H, Charac$)
              ' Call Box(StartRow, StartColumn, Width, Height, BoxChar$)
              ' Y=StartRow,X=StartColumn; W=Width,H=Height)
              
              TL$ = MID$(Charac$, 1, 1)
              t$ = MID$(Charac$, 2, 1)
              TR$ = MID$(Charac$, 3, 1)
              L$ = MID$(Charac$, 4, 1)
              R$ = MID$(Charac$, 5, 1)
              BL$ = MID$(Charac$, 6, 1)
              B$ = MID$(Charac$, 7, 1)
              BR$ = MID$(Charac$, 8, 1)

'DoubleBorder$="ͻͼ"        ' Double Border Box characters  
'SingleBorder$="Ŀ"        ' Single Border Box characters  
              LOCATE Y, X
              PRINT TL$; : FOR t = 1 TO W - 2: PRINT t$; : NEXT t: PRINT TR$;
              
              FOR v = 1 TO H - 2
              LOCATE Y + v, X
              PRINT L$; TAB(X + W - 1); : PRINT R$;
              NEXT v
              
              LOCATE Y + H - 1, X
              PRINT BL$; : FOR t = 1 TO W - 2: PRINT B$; : NEXT t: PRINT BR$;

END SUB

SUB Fischio
              IF MyVal(1) = 0 THEN EXIT SUB
              SOUND 1 * 400 + 500, 1
              SOUND 2 * 400 + 500, 1
              SOUND 3 * 400 + 500, 1
              SOUND 4 * 400 + 500, 1
              SOUND 5 * 400 + 500, 1
              SOUND 6 * 400 + 500, 1
END SUB

SUB PranykLoc
              LOCATE  24,28,0
              call Pranyk
END SUB

SUB Pranyk
              PRINT "- press any key to return -";
waitMore:
              IF INKEY$ = "" THEN GOTO waitMore
END SUB


DEFSNG A-Z

SUB ThisHelp(Banner$, DatFile$, IDXFile$, Argum$)
              GOTO GetHelp

' Because of MS QBasic quirks, GetIDX routine has to be placed before the rest of the code.

' Get .IDX file values into an array, that is, 
' Get Array Parameters from Index (IDX) file
GetIDX:         
              OPEN IDXFile$ FOR RANDOM ACCESS READ AS #3 LEN = LEN(IDXRecord)
              GET #3, , IDXRecord
              TLines% = IDXRecord.StartRec' First record is special: total records that follow
              
              
              REDIM IDXSect$(TLines%)
              REDIM IdxStart(TLines%)
              REDIM IdxLength(TLines%)
              FOR t = 1 TO TLines%
              GET #3, , IDXRecord
              IDXSect$(t) = LTRIM$(IDXRecord.Section)
              IdxStart(t) = IDXRecord.StartRec
              IdxLength(t) = IDXRecord.RecLength
              IDXSect$(t) = LTRIM$(RTRIM$(IDXSect$(t)))
              NEXT t
              CLOSE #3
              
              RETURN
              

              

GetHelp:        CLS
              LOCATE 1, 26: PRINT Banner$
              InizRw% = 2
              TotScrRws% = 12
              CurrScrRw% = 1
              
              GOSUB RedrawBox
              GOSUB GetIDX
              FOR Arg% = 1 TO TLines%
              IF Argum$ = IDXSect$(Arg%) THEN GOTO ArgFnd
              NEXT Arg%
              Arg% = 1
              
ArgFnd:         CurntLine% = Arg%
              RcLen% = 77 + 2
              OPEN DatFile$ FOR RANDOM ACCESS READ AS #59 LEN = RcLen%
              FIELD #59, RcLen% - 2 AS DL$
              FIELD #59, 2 AS CRLF$
              
'===================================
' MAIN LOOP STARTS HERE
'===================================       
NextLineName:
              COLOR 7, 0
              
              IF CurrScrRw% = 1 THEN FstLine% = CurntLine%   ' Get Number of first Line only
              GOSUB DisplayRw
              CurntLine% = CurntLine% + 1 ' Next Line
              LastScrRw% = CurrScrRw%      ' Save last Screen Row used
              CurrScrRw% = CurrScrRw% + 1  ' Next Screen Row
              IF CurrScrRw% < TotScrRws% + 1 AND CurntLine% <= TLines% THEN GOTO NextLineName
'===================================
' MAIN LOOP ENDS HERE
'===================================
'           
              GOSUB BotLine              ' Clear Unused Bottom Lines
              LastLine% = CurntLine% - 1
              CurntLine% = FstLine%  ' Current Line is now first Line in screen
              
              CurrScrRw% = 1
              IF KeepCursBot% = 0 THEN GOTO LocCursor2
              ' Last key used was Arrow Down. Move Cursor and FileNumber pointer to last Line in Screen
              CurrScrRw% = TotScrRws%: KeepCursBot% = 0: CurntLine% = LastLine%
              GOTO LocCursor2
              
LocCursor:
              GOSUB HeRestColor

LocCursor2:
              LOCATE InizRw% + CurrScrRw%, 2, 1
              COLOR 0, 7: GOSUB DisplayRw: COLOR 7, 0 ' Display Current Row
              LOCATE InizRw% + CurrScrRw%, 2, 1
              OldScrRw% = CurrScrRw%
              OldLine% = CurntLine%
              IF GoToThisDir% <> 0 THEN CurntLine% = GoToThisDir%: GoToThisDir% = 0: GOTO Exekit
              'GOSUB ShowValues    ' My little Debugger
              
              
DoHeAgain:      GOSUB GetChar

              ' IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO DoHeAgain

              ' ESCape Key
              IF UH$ = CHR$(27) THEN GOTO HAbort
              
              ' ENTER Key
              IF UH$ <> CHR$(13) THEN GOTO IsArrDown
EnterKey:       CALL FISCHIO
              GOSUB ThisSect
              GOSUB RePaintHelp
              GOTO NMatch

IsArrDown:     ' Arrow Down Key
              IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO OthKey0
              IF CurrScrRw% < LastScrRw% THEN CurrScrRw% = CurrScrRw% + 1: CurntLine% = CurntLine% + 1: GOTO LocCursor
              IF CurntLine% = TLines% THEN GOTO LocCursor
              CurntLine% = FstLine% + 1
              KeepCursBot% = 1
              IF CurntLine% < 1 THEN CurntLine% = 1
              GOTO Exekit
OthKey0:         'Arrow up Key
              IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO OthKey1
              IF CurntLine% = 1 THEN GOTO NMatch
              IF CurrScrRw% > 1 THEN CurrScrRw% = CurrScrRw% - 1: CurntLine% = CurntLine% - 1: GOTO LocCursor
              CurntLine% = FstLine% - 1: IF CurntLine% < 1 THEN CurntLine% = 1
              GOTO Exekit
              
OthKey1:         ' Page Up Key
              IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO OthKey2
              CurntLine% = FstLine% - TotScrRws%
              IF CurntLine% < 1 THEN CurntLine% = 1
              GOTO Exekit

OthKey2:        ' Page Down Key
              IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO OthKey7
              IF LastLine% + 1 + TotScrRws% > TLines% THEN CurntLine% = TLines% - TotScrRws% + 1: IF CurntLine% < 1 THEN CurntLine% = 1: GOTO Exekit
              CurntLine% = FstLine% + TotScrRws%
              IF CurntLine% > TLines% THEN CurntLine% = FstLine%
              GOTO Exekit
              
OthKey7:         ' Home Key : simply move cursor to top
              IF UH$ <> CHR$(0) + CHR$(71) THEN GOTO OthKey8
              CurrScrRw% = 1: CurntLine% = FstLine%: GOTO LocCursor

OthKey8:         ' End Key : simply move cursor to bottom
              IF UH$ <> CHR$(0) + CHR$(79) THEN GOTO OthKey9
              CurrScrRw% = LastScrRw%: CurntLine% = LastLine%
              GOTO LocCursor
              
OthKey9:        ' F3 = Show Error List
              IF UH$ <> CHR$(0) + CHR$(61) THEN GOTO OthKey10
              GOSUB RePaintHelp
              GOTO NMatch

OthKey10:       ' F7 = Show Sector as Hex
              IF UH$ <> CHR$(0) + CHR$(65) THEN GOTO OthKey11
              GOSUB RePaintHelp
              GOTO NMatch
              
OthKey11:       'CTRL Page Down
              IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO OthKey12
              GOTO EnterKey
OthKey12:           
              GOTO NMatch


Exekit:         CurrScrRw% = 1     ' Cursor on first screen row
              LOCATE InizRw% + CurrScrRw%, 2, 1
              GOTO NextLineName   ' Start next round

NMatch:         GOTO LocCursor
              
RePaintHelp:     
              GOSUB RedrawBox
              SaveCurrLine% = CurntLine%
              SavCurrScrRw% = CurrScrRw%
              CurntLine% = FstLine%
              FOR CurrScrRw% = 1 TO TotScrRws%
              GOSUB DisplayRw  ' Display Current Row
              CurntLine% = CurntLine% + 1 ' Next Line
              LastScrRw% = CurrScrRw%      ' Save last Screen Row used
              IF CurntLine% > TLines% THEN CurrScrRw% = CurrScrRw% + 1: GOTO RePaintHelp2
              NEXT CurrScrRw%   ' Next Screen Row
              
RePaintHelp2:          
              
              CurntLine% = SaveCurrLine%
              CurrScrRw% = SavCurrScrRw%
              RETURN

HeRestColor:    TempScreenRw% = CurrScrRw%
              TempLine% = CurntLine%
              CurrScrRw% = OldScrRw%
              CurntLine% = OldLine%
              COLOR 7, 0: GOSUB DisplayRw ' Display Current Row
              CurrScrRw% = TempScreenRw%
              CurntLine% = TempLine%
              RETURN

'==========================
' DISPLAY CURRENT ROW
'==========================
DisplayRw:
              LOCATE InizRw% + CurrScrRw%, 2, 1
              GET #59, IdxStart(CurntLine%)
              TL$ = DL$
              FOR t = 1 TO LEN(TL$): IF MID$(TL$, t, 1) <> " " AND MID$(TL$, t, 1) <> "*" THEN GOTO StrtFound
              NEXT t
StrtFound:      TL$ = RIGHT$(TL$, LEN(TL$) - t + 1)
              
              FOR t = LEN(TL$) TO 1 STEP -1: IF MID$(TL$, t, 1) <> " " AND MID$(TL$, t, 1) <> "*" THEN GOTO EndFnd
              NEXT t
EndFnd:         TL$ = LEFT$(TL$, t)
              'PRINT IDXSect$(CurntLine%); TAB(10); TL$; SPACE$(79 - 10 - LEN(TL$));
              PRINT IDXSect$(CurntLine%); TAB(12); TL$; SPACE$(79 - 12 - LEN(TL$));
              RETURN
              
'====================
' CLEAR BOTTOM LINES
'====================       
BotLine: 
              
              LOCATE InizRw% + CurrScrRw%, 2, 1

              IF CurrScrRw% >= TotScrRws% THEN GOTO HlpClear ' Blank all unused screen rows, if any

              FOR V = CurrScrRw% TO TotScrRws%
              LOCATE InizRw% + V, 2, 1
              PRINT "                                                                              "
              NEXT V
              
HlpClear:        LOCATE 23, 1: PRINT "Enter=Get Doc. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
              RETURN

              
' Create Box
RedrawBox:      CALL box(2, 1, 80, TotScrRws% + 2, DoubleBorder$)
              RETURN
Pranyk:

              PRINT "                         - press any key to return -"
              GOSUB GetChar
              RETURN
              
GetChar:
              DO: UH$ = INKEY$: LOOP UNTIL UH$ <> ""
              RETURN


ThisSect:       TotSectRws% = 19
              SectInizRw% = 2
              SectCurrRw% = 1
              SectStart# = IdxStart(CurntLine%)
              SectCount# = IdxLength(CurntLine%)
              SectCurr# = 0
              Blank$ = SPACE$(78)
              LOCATE 23, 1: PRINT "Enter=Line Down. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
              CALL box(2, 1, 80, TotSectRws% + 2, DoubleBorder$)
NewRound:             
              FirstRec# = SectCurr#
SectNewLine:             
              GET #59, SectStart# + SectCurr#
              LOCATE SectInizRw% + SectCurrRw%, 2, 1
              PRINT DL$;
              SectCurr# = SectCurr# + 1
              LastSectRw% = SectCurrRw%      ' Save last Screen Row used
              SectCurrRw% = SectCurrRw% + 1
              IF SectCurrRw% < TotSectRws% + 1 AND SectCurr# < SectCount# THEN GOTO SectNewLine
              
              FOR V = SectCurrRw% TO TotSectRws%
              LOCATE SectInizRw% + V, 2
              PRINT Blank$;
              NEXT V
              
GetAnother:     GOSUB GetChar
              'IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO GetAnother
              SectCurr# = FirstRec#
              SectCurrRw% = 1
              ' ESC Key
              IF UH$ = CHR$(27) THEN GOTO SectExit
              
              ' ENTER Key
              IF UH$ <> CHR$(13) THEN GOTO SectArrowDown
SectEnter:      IF SectCurr# < SectCount# - 6 THEN SectCurr# = SectCurr# + 1
              GOTO NewRound
              
SectArrowDown:  ' Arrow Down Key
              IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO SectKey0
              GOTO SectEnter
              
SectKey0:       'Arrow up Key
              IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO SectKey1
              IF SectCurr# > 0 THEN SectCurr# = SectCurr# - 1
              GOTO NewRound
SectKey1:           
              ' Page Up Key
              IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO SectKey2
SectPageUp:     SectCurr# = SectCurr# - TotSectRws%
              IF SectCurr# < 0 THEN SectCurr# = 0
              GOTO NewRound
              
SectKey2:        ' Page Down Key
              IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO SectKey11
SectPageDown:   SectCurr# = SectCurr# + TotSectRws%
              IF SectCurr# > SectCount# - TotSectRws% THEN SectCurr# = SectCount# - TotSectRws%
              IF SectCurr# < 0 THEN SectCurr# = 0
              GOTO NewRound
              
SectKey11:      'CTRL Page Down
              IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO SectKey12
              GOTO SectPageDown
              
SectKey12:      'CTRL Page Up
              IF UH$ <> CHR$(0) + CHR$(132) THEN GOTO SectKey13
              GOTO SectPageUp
SectKey13:          
              GOTO NewRound
SectExit:               
              V = InizRw% + TotScrRws%
              LOCATE V, 1, 1
              IF V >= 22 THEN GOTO DontDoit ' Blank all unused screen rows, if any

              FOR V = V TO 23
              LOCATE V, 1, 1
              PRINT SPACE$(80)
              NEXT V
DontDoit:
              
              RETURN
HAbort:             
              CLOSE #59
END SUB

DEFINT A-Z

              FUNCTION Xinput$ (Row%, Col%, FieldLen%, Default$, AllowCharsMask$, EndingKeys$, ExitKey$, RealStrLen%) STATIC

'Ŀ
'         XINPUT 2.1:  A Powerful Replacement for standard QBasic INPUT       
'                 
'                              First written                                  
'                                   by                                        
'          Frederick Volking, QBNews, Volume  1, Number  3  May 22, 1990      
'                                                                             
'                    ͻ                      
'                             Paolo Bagnaresi                               
'                           Via J.F. Kennedy 17                             
'                      20097 San Donato Milanese (MI)                       
'                                Italy                                      
'                          Tel. ++39-2-514.202                              
'                                                     
'                    e-mail: paul.bagnaresi@gmail.com 
'                    ͼ                      
'                                                                             
'          Almost entirely rewrote it and deeply enhanced it on June 1995     
'                                                                             
' Vers. 2.0 : Some bad bugs corrected on March 1996 (cursor position and      
'             returned string length)                                         
' Vers. 2.1 : May 2000. FieldLen% bug fixed.                                  
'Ĵ
'SYNTAX:Xinput$(Row%,Col%,FLen%,Default$,Allow$,EndKeys$,ExitKey$,RealStrLen%)
'WHERE: Row% & Col% - where input to occur                                    
'         FLen% - Field Length - maximum allowable                            
'         Default$ - Field's beginning default value                          
'         Allow$ - Character Set allowable for input                          
'         EndKeys$ - Keystrokes acceptable for finishing.                     
'            SUCH: [Enter] is CHR$(13)                                        
'                  [Esc] is CHR$(27)                                          
'                  [F1] is CHR$(255)+CHR$(59)                                 
'                  [Ctrl+PgUp] is CHR$(255)+CHR$(132)                         
'                  ... etc                                                    
'         ExitKey$ - The keystroke (from above EndKeys$)                      
'                    which was struck at function end.                        
'         RealStrLen% - The Real String Length, not counting unused space     
'                       at the string end. However, Spaces added manually     
'                       do count!                                             
'  SIMPLEST USE:  A$ = Xinput$(0,0,0,"","","",Any$,RealStrLen%)               
'         Will default to cursor's current row/col, length is                 
'         autoset to right margin, allowable chars are ALL,                   
'         only ending key is [Enter].                                         
'Ĵ
'                                                                             
'   Instructions and enhancements discussion after the end of program         
'                           ***  see below ***                                
'                                                                             
'
'  Discussion 
'
'                 XINPUT program eXtends the standard QBasic INPUT.
'
'     Unlike QB INPUT, XINPUT allows editing a previously created string.
'     This is the strongest feature of Xinput and the very reason why this
'     task was undertaken. I just could not bear any longer the tedious
'     retyping of any string change that was needed in some program
'     I developed through the years.
'     The original routine written by Frederick Volking on QBNews, named
'     ENPUT,  did not alllow a string editing, which is why I felt compelled
'     to rewrite the Volking routine.
'
'     Other valuable features are:
'
'- Exit keys (Xinput terminators) are user selectable, and detectable by caller.
'- All the user allowed keys are also pre-selectable. Caller can create a mask
'  containing the all the keys that the callee will be allowed to use.
'  A low sound will signal hitting an unselected key.
'
'- Insert key remains active until you deselect it by pressing it again.
'- Backspace pressed 8 times at 1st string position reverts you to start string.
'- Screen start position is user selectable.
'- Cursor Up key and Cursor Down key will move you through the rows.
'- Page Up will moves you to first row. Page Down to the last row.
'- CTRL+Home erases all the field from cursor position up to 1st string char.
'- All the standard QB Input features are emulated, including CTRL+End,
'  CTRL+R, CTRL+E, Tab and CTRL+I...
'- Escape key or CTRL+U, if aren't redefined as an exit key, will entirely
'  blank the string field.
'- Source code in plain QBasic is here, waiting for your enhancements.
'  BTW, I would gladly receive your enhancements, if you can send them to my
'  address:                   Paolo Bagnaresi
'                           Via J.F. Kennedy 17
'                      20097 San Donato Milanese (MI)
'                                Italy
'                          Tel. ++39-2-514.202
'                   e-mail: paul.bagnaresi@gmail.com 

              SHARED ScreenWidth%, EmptySpaceChar$

' 1 character Key vakues
              CtrlB$ = CHR$(2)         ' Ctrl+ B = Cursor to the word on the left
              CtrlE$ = CHR$(5)         ' Ctrl+ E = Cancel all chars from Cursor Posit. to end
              CtrlF$ = CHR$(6)         ' Ctrl+ F = Cursor to the word on the right
              BackS$ = CHR$(8)         ' Backspace
              Tabul$ = CHR$(9)         ' Tabulator
              CtrlI$ = CHR$(9)         ' Ctrl+ I = Tabulator
              CtrlK$ = CHR$(11)        ' Ctrl+ K = Cursor to start of field (= Home)
              Enter$ = CHR$(13)        ' Enter
              CtrlN$ = CHR$(14)        ' Ctrl+ N = Cursor to end of field (= End)
              CtrlR$ = CHR$(18)        ' Ctrl+ R = Insert mode toggle
              CtrlU$ = CHR$(21)        ' Ctrl+ U = Clear all input field
              Esc$ = CHR$(27)          ' Escape
              CtrlRevSlash$ = CHR$(28) ' Ctrl+ \ = Cursor Right
              CtrlClSquare$ = CHR$(29) ' Ctrl+ ] = Cursor Left
              
              CTRLC$ = CHR$(3)         ' CTRL+ C
              CTRLV$ = CHR$(22)        ' CTRL+ V

' 2 character Key vakues
              CursLeft$ = CHR$(0) + CHR$(75)
              CursRight$ = CHR$(0) + CHR$(77)
              CursUp$ = CHR$(0) + CHR$(72)
              CursDown$ = CHR$(0) + CHR$(80)

              Insert$ = CHR$(0) + CHR$(82)
              Delete$ = CHR$(0) + CHR$(83)
              Home$ = CHR$(0) + CHR$(71)
              End$ = CHR$(0) + CHR$(79)
              PageUp$ = CHR$(0) + CHR$(73)
              PageDown$ = CHR$(0) + CHR$(81)

              CtrlHome$ = CHR$(0) + CHR$(119)
              CtrlEnd$ = CHR$(0) + CHR$(117)
              CtrlPageUp$ = CHR$(0) + CHR$(132)
              CtrlPageDown$ = CHR$(0) + CHR$(118)
              CtrlCursLeft$ = CHR$(0) + CHR$(115)
              CtrlCursRight$ = CHR$(0) + CHR$(116)


' Other Key vakues, currently unused
              F1$ = CHR$(59)           'F1
              F2$ = CHR$(60)           'F2
              F3$ = CHR$(61)           'F3
              F4$ = CHR$(62)           'F4
              F5$ = CHR$(63)           'F5
              F6$ = CHR$(64)           'F6
              F7$ = CHR$(65)           'F7
              F8$ = CHR$(66)           'F8
              F9$ = CHR$(67)           'F9
              F10$ = CHR$(68)          'F10
              F10$ = CHR$(133)         'F11
              F10$ = CHR$(134)         'F12

' Verify if SHARED globals are set
              IF ScreenWidth% = 0 THEN ScreenWidth% = 80
              IF LastRow% = 0 THEN LastRow% = 24
              TotalScreenLength% = LastRow% * ScreenWidth%
              IF EmptySpaceChar$ = "" THEN EmptySpaceChar$ = CHR$(32)

' If not specified then supply defaults to incoming vars
              IF AllowCharsMask$ = "" THEN AllowCharsMask$ = CHR$(34) + " !#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
              IF EndingKeys$ = "" THEN EndingKeys$ = CHR$(13)
              IF Row% = 0 THEN Row% = CSRLIN
              IF Col% = 0 THEN Col% = POS(0)
              ReturnVar$ = Default$
              IF FieldLen% = 0 THEN FieldLen% = LEN(ReturnVar$)
              IF FieldLen% <= LEN(ReturnVar$) THEN GOTO FieldLenOk
              ReturnVar$ = ReturnVar$ + STRING$(FieldLen% - LEN(ReturnVar$), EmptySpaceChar$)
              FieldLen% = LEN(ReturnVar$)
              Default$ = ReturnVar$
              
FieldLenOk:
' Define internal defaults

              CursPos% = 1
              ReturnVar$ = Default$
              Separator$ = " !#$%&'()*+,-./:;<=>?@[\]^_`{|}~" + CHR$(34) ' Valid separators for CTRL+LEFT or CTRL+RIGHT
              IF TabLen% = 0 THEN TabLen% = 8 ' Tabulator lenght
              NotDone% = 1
              standard% = 6 'Cursor Shape if in Standard Mode
              Insert% = 4   'Cursor Shape if in Insert Mode
              CurShape% = standard%

'  MAIN LOOP STARTS HERE 
              Riga% = Row%: Lonna% = Col%
              DO
              LOCATE Riga%, Lonna%, 0
              IF Lonna% + LEN(ReturnVar$) > ScreenWidth% THEN
              Part1$ = LEFT$(ReturnVar$, ScreenWidth% - Lonna% + 1)
              Part2$ = RIGHT$(ReturnVar$, LEN(ReturnVar$) - (ScreenWidth% - Lonna% + 1))
              ELSE
              Part1$ = ReturnVar$: Part2$ = ""
              END IF
              PRINT Part1$; Part2$;

              RowCurs% = INT((Lonna% + CursPos% - 1) / ScreenWidth%)
              ColCurs% = (Lonna% + CursPos% - 1) MOD ScreenWidth%
              IF ColCurs% = 0 THEN ColCurs% = ScreenWidth%: RowCurs% = RowCurs% - 1
              VirtPos% = (Riga% * ScreenWidth% - 1) + Lonna% + FieldLen%
              IF VirtPos% > TotalScreenLength% THEN
              Riga% = Riga% - (INT((VirtPos% - TotalScreenLength% - 1) / ScreenWidth%))

              LOCATE Riga%, Lonna%, 0
              END IF
              LOCATE Riga% + RowCurs%, ColCurs%, 1, CurShape%, 7
              DO
              KeyStroke$ = INKEY$
              LOOP WHILE KeyStroke$ = ""


              If INSTR(AllowCharsMask$, KeyStroke$) > 0 THEN
              Mark% = 0'No Backspace at Posit. 0
              IF CurShape% = standard% THEN
              MID$(ReturnVar$, CursPos%, 1) = KeyStroke$

              ELSE
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + KeyStroke$ + MID$(ReturnVar$, CursPos%, FieldLen% - CursPos%)
              END IF

              IF CursPos% < FieldLen% THEN
              CursPos% = CursPos% + 1
              ELSE
              IF MyVal(1) <> 0 AND FieldLen%>1 THEN BEEP 
              END IF
              ELSE

              IF INSTR(EndingKeys$, KeyStroke$) > 0 THEN
              ExitKey$ = KeyStroke$
              NotDone% = 0
              ELSE
'  Check for other keys  

              SELECT CASE KeyStroke$
              CASE CursLeft$
              IF CursPos% > 1 THEN
              CursPos% = CursPos% - 1
              END IF
              CASE CursRight$
              IF CursPos% < FieldLen% THEN
              CursPos% = CursPos% + 1
              END IF
              CASE BackS$
              IF CursPos% > 1 THEN
              Mark% = 0'No Backspace at Posit. 0
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 2) + RIGHT$(ReturnVar$, FieldLen% - CursPos% + 1) + EmptySpaceChar$
              CursPos% = CursPos% - 1
              ELSE
              Mark% = Mark% + 1:
              SOUND Mark% * 400 + 500, 1
              IF Mark% > 7 THEN
              Mark% = 0
              ReturnVar$ = Default$
              ' IF LEN(ReturnVar$) < FieldLen% THEN
              '    ReturnVar$ = ReturnVar$ + SPACE$(FieldLen% - LEN(ReturnVar$))
              ' END IF
              END IF
              END IF
              CASE Delete$
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + RIGHT$(ReturnVar$, FieldLen% - CursPos%) + EmptySpaceChar$
              CASE Insert$, CtrlR$
              IF CurShape% = standard% THEN
              CurShape% = Insert%
              ELSE CurShape% = standard%
              END IF

              CASE Home$, CtrlK$  ' Cursor to field start
              CursPos% = 1

              CASE End$, CtrlN$  ' Cursor to field end
              CursPos% = LEN(ReturnVar$)

              CASE CursUp$  ' Cursor 1 line up
              IF CursPos% > ScreenWidth% THEN CursPos% = CursPos% - ScreenWidth%

              CASE CursDown$ ' Cursor 1 line down
              IF CursPos% + ScreenWidth% < LEN(ReturnVar$) + 1 THEN CursPos% = CursPos% + ScreenWidth%

              CASE CtrlHome$  ' Cancel all chars from Cursor Position -1  up to start
              ReturnVar$ = RIGHT$(ReturnVar$, FieldLen% - CursPos% + 1) + STRING$(CursPos% - 1, EmptySpaceChar$)
              CursPos% = 1

              CASE CtrlEnd$, CtrlE$ ' Ctrl+ E = Cancel all chars from Cursor Posit. up to end
              ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + STRING$(FieldLen% - CursPos% + 1, EmptySpaceChar$)

              CASE PageUp$  ' Cursor to 1st line
              DO WHILE CursPos% > ScreenWidth%
              CursPos% = CursPos% - ScreenWidth%
              LOOP

              CASE PageDown$ ' Cursor to last line
              DO WHILE CursPos% + ScreenWidth% < LEN(ReturnVar$) + 1
              CursPos% = CursPos% + ScreenWidth%
              LOOP

              CASE CtrlCursLeft$, CtrlB$ ' Ctrl+ B = Cursor to the word on the left
              IF CursPos% > 1 THEN
              P% = CursPos% - 1
              DO WHILE (P% > 1) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) > 0
              P% = P% - 1
              LOOP

              DO WHILE (P% > 1) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) = 0
              P% = P% - 1
              LOOP
              CursPos% = P%
              IF CursPos% < 1 THEN CursPos% = 1
              IF CursPos% > 1 THEN CursPos% = CursPos% + 1
              END IF

              CASE CtrlCursRight$, CtrlF$ ' Ctrl+ F = Cursor to the word on the right
              P% = CursPos%
              DO WHILE (P% < FieldLen%) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) = 0
              P% = P% + 1
              LOOP
              DO WHILE (P% < FieldLen%) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) > 0
              P% = P% + 1
              LOOP

              CursPos% = P%
              IF CursPos% > FieldLen% THEN CursPos% = FieldLen%

              CASE Esc$, CtrlU$  ' Ctrl+ U = Clear all input field, if Escape is not
              ' activate to exit by XINPUT caller
              ReturnVar$ = STRING$(FieldLen%, EmptySpaceChar$)
              CursPos% = 1

              CASE Tabul$  ' Tabulator in QBasic works in the following way:
              ' Cursor moves to past the NEXT 8th character,
              '   character 1 in string being 1st character.
              ' I.e., to 9th, 17th, 25th, 33rd character and so on.
              ' If INSERT key is not active, up to 8 character will be blanked.
              ' If INSERT key is ACTIVE, up to 8 blanks will be INSERTED.

              P% = (INT((CursPos% - 1 + TabLen%) / TabLen%) * TabLen%) + 1 ' Find Cursor position of next tabulation
              IF P% > FieldLen% + 1 THEN P% = FieldLen% + 1
              IF CursPos% > 1 THEN R1$ = LEFT$(ReturnVar$, CursPos% - 1) ELSE R1$ = ""
              IF CurShape% = standard% THEN
              IF CursPos% < P% THEN R2$ = RIGHT$(ReturnVar$, FieldLen% - P% + 1) ELSE R2$ = ""
              ELSE
              IF CursPos% < FieldLen% THEN R2$ = MID$(ReturnVar$, CursPos%, FieldLen% + 1 - P%) ELSE R2$ = ""
              END IF
              ReturnVar$ = R1$ + STRING$(P% - CursPos%, CHR$(32)) + R2$
              IF P% > FieldLen% THEN P% = FieldLen%
              CursPos% = P%
              
              Case CTRLC$  ' CTRL+ C
              If Len(ReturnVar$)>0 Then MyName$(13)=ReturnVar$
              
              Case CTRLV$  ' CTRL+ V
              If Len(MyName$(13))=0 Then GoTo SelectEnd
              If Len(MyName$(13)) > Len(ReturnVar$) Then ReturnVar$= left$(MyName$(13),Len(ReturnVar$)) Else ReturnVar$=MyName$(13)
              CursPos% = 1
              
              Case ELSE
              SOUND 500, 1
              End SELECT
SelectEnd:      
              
              END IF
              End IF
              LOOP WHILE NotDone%

'  Exit from here  

              RealStrLen% = LEN(ReturnVar$)
              Xinput$ = ReturnVar$
              END FUNCTION


DefInt A-Z
SUB KillFile (A$)
              nF% = FREEFILE
              OPEN A$ FOR OUTPUT AS #nF%
              CLOSE #nF%
              KILL A$
END Sub




DEFSNG A-Z
FUNCTION WorkOutPath$ (A$, X$)
' Get just the path out of Path+Filename
' Whatever after last "\" gets stripped, and X$ added.
' Examples:   
' 1) Input : A$="c:\MyDir\ti99pc.img", X$=""
'    Output: "c:\MyDir"
'
' 2) Input : A$="c:\MyDir\ti99pc.img", X$="\"
'    Output: "c:\MyDir\"
'
' 3) Input : A$="c:\MyDir\ti99pc.img", X$="\MyApp.dat"
'    Output: "c:\MyDir\MyApp.dat"

              FOR T = LEN(A$) TO 1 STEP -1
              IF MID$(A$, T, 1) = "\" THEN B$ = LEFT$(A$, T - 1): GOTO WorkOutPath2
              NEXT T
WorkOutPath2: WorkOutPath = B$ + X$
              
END FUNCTION

MyErrorTrap:  MyVal(2) = ERR  ' "ERR" Error I will return with the "ON ERROR" trap. Useful in SUBs/FUNCTIONs. 0=No error
              RESUME NEXT

FUNCTION ValidFullPath(PFN As String,FUNC As Integer)
' Check Path and/or Filename
' PFN$ = Path or Path+Filename to be checked
' FUNC = Desired functions. Each function has an assigned number. Multiple functions can be obtained by summing
'                           together the numerical values of the desired functions. Values are powers of 2=1,2,4,8,16,...
'        1 = Check if path exists. Must be just path, without filename. Returns error if path doesn't exist
'        2 = Check if path\filename exists. Returns error if path+filename doesn't exist (file must not be already opened)
'        4 = Check if filename can be created (i.e. if path exists already; if filename is correct and will not conflict with
'            an already existing path in the same directory.
'        8 = Like 4 (check if a filename can be created), but returns a warning if the new filename already exists

' Returned value
' ValidFullPath = 0 means file is a valid one
' ValidFullPath = ERR Code (76 = Path not found)
' 
' Programmers: please note the correct use of ON ERROR in a FUNCTION or SUB. Label of ON ERROR GOTO *must* be placed 
' outside the FUNCTION/SUB (MyErrorTrap:). There, ERR code is assigned to a SHARED variable, so that the following 
' RESUME NEXT instruction will return the right Error Code to the routine that originally triggered the error. 


              ff% = FREEFILE
              MyVal(2) = 0            ' Assume no error
              On ERROR GOTO MyErrorTrap
              A$ = RTRIM$(PFN$)
              
' Any function Must have a ":" in postion 2
              IF MID$(A$, 2, 1) <> ":" THEN MyVal(2) = 76: GOTO ValidFullP1a ' 76= "Path not found"
              
              CALL ShortLongName(A$,CR$,1) ' Get Short Name out of a long filename
              
' FUNC = 1 Check if path exists (must be just path, without filename). Return error if path doesn't exist
              IF (FUNC AND 1) > 0 THEN B$ = A$: GOTO ValidFullP1         ' FUNC = 1 : "Check if path exists"
              
' FUNC = 2 Check if path exists. Returns error if path+filename doesn't exist 
' FUNC = 4 Check if filename can be created (i.e. check if path exists already and filename is a possible one
              IF ((FUNC AND 2) = 0) AND ((FUNC AND 4) = 0) THEN GOTO ValidFullP2       ' Skip if FUNC=2 or FUNC=4 are not required
              B$ = WorkOutPath(A$, "")         ' Get bare path (no filename at the end)
              CALL ShortLongName(B$,CR$,1)     ' Get Short Name out of a long filename
              
ValidFullP1:  IF RIGHT$(B$, 1) = "\" THEN B$ = LEFT$(B$, LEN(B$) - 1)
              OPEN B$ + "\CON" FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
              CLOSE #ff%
              IF MyVal(2) = 0 THEN GOTO ValidFullP2  ' Here OK only if NO ERR code has been reported
              	
ValidFullP1a: Call DispBoxnWait (18,"Error","File "+PFN$+" . Path part is invalid","","","","","") 
              GOTO ValidFullPErr


' FUNC = 2 = Check if path+filename exists. Returns error if path+filename doesn't exist
' Path+Filename must really open a file. See if it does it.
ValidFullP2: 
              IF (FUNC AND 2) = 0 THEN GOTO ValidFullP4
              OPEN A$ FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
              CLOSE #ff%
              IF MyVal(2) = 0 THEN GOTO ValidFullP4  ' Here OK only if NO ERR code has been reported
              Call DispBoxnWait (18,"Error","File "+PFN$+" does not exist","","","","","")
              GOTO ValidFullPErr

' FUNC =  4 =   Check if filename can be created (i.e. check if path exists already; if filename is correct and will not
'               match the name of an existing directory, in which case there would be an error at creation time.
'
'                         +------------------+
'                         |      START       |
'                         +------------------+ 
'                  NO <---| does path exist? |---> YES
'                ERROR    +-------(1)--------+      |
'                                                   |
'                                   *---------------*
'                                   |
'                   +-----------------------------------+ 
'           NO <--- | can filename be opened as a file ?|---> YES OK File exists
'           |       +-----------------------------------+            already (2)
'           |
'           *------------------------*
'                                    |
'                 +-----------------------------------+                          
'         NO <--- | can filename\CON be still opened ?|---> YES ERROR: FILENAME
'         OK      +-----------------------------------+     IS ACTUALLY A PATH   
'     FILENAME IS                                           (because we saw before
'     NOT A PATH                                             it was not an existing 
'                                                            file)
' 
' .........................................................................................
' Notes
' =====
' (1) Strip away the filename (i.e. get to the first "\" starting from the end of string.
' (2) In QBasic creating a new file or overwriting an old one boils down to be the same operation.


ValidFullP4:
              IF (FUNC AND 4) = 0 THEN GOTO ValidFullP8
'  Filename cannot be name of an existing directory. But if it is, and it isn't an existing file, then path$\CON can be opened: aha...
              OPEN A$ FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
              CLOSE #ff%
              IF MyVal(2) = 0 THEN GOTO ValidFullP8 ' File already exists
              MyVal(2) = 0
              OPEN A$ + "\CON" FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
              CLOSE #ff%
              IF MyVal(2) <> 0 THEN GOTO ValidFullP8  ' Here OK only if an ERR code has been reported
ValidFullP4Err: Call DispBoxnWait (18,"Error","File "+PFN$, "is the name of an already existing directory","","","","") 
              MyVal(2) = 76
              GOTO ValidFullPErr
              
ValidFullP8:  IF (FUNC AND 8) = 0 THEN GOTO ValidFullPOK
              OPEN A$ FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
              CLOSE #ff%
              IF MyVal(2) <> 0 THEN GOTO ValidFullPOK ' File already exists
              C$=CHR$(22)
              Call DispBoxnWait (18,"Warning!","File "+PFN$, "already exists. Press ESCape to avoid overwriting it","","","",C$) 
              IF ASC(C$)<>27 THEN GOTO ValidFullPOK
              MyVal(2) = 58
              GOTO ValidFullPErr

ValidFullPOK: ValidFullPath = 0
              GOTO ValidFullPEnd
ValidFullPErr:
              ValidFullPath = MyVal(2)
ValidFullPEnd:
              MyVal(2) = 0
              ON ERROR GOTO 0
END FUNCTION
DEFINT A-Z
SUB DispBoxnWait (StRow%,A1$,A2$,A3$,A4$,A5$,A6$,RetKey$)
' Call DispBoxnWait$(StartRow,"Error","This file ","c:\temp\myfile.txt ", "does not exist"," ",CHR$(10))
' Rules: 
' 1) Empty string will have no action: is as if the parameter did not exist. If all strings are empty, exit with no action
' 2) A string containing just one character which is a blank will be printed as a line
' 4) If caller's RetKey$ is an empty string, add 2 extra lines to the box, print "- Press any key -", centered.
'    If caller's RetKey$ is NOT an empty string, print that string as the last one in the box,  centered.
'    In both the above cases, wait for a user's key pressed and return the pressed key to the caller in RetKey$. 
'    If caller's RetKey$ is CHR$(10) then exit right away (no wait). 
'    
'    the caller in RetKey$
Dim DBW$(7)
              DBW$(1)=A1$
              DBW$(2)=A2$
              DBW$(3)=A3$
              DBW$(4)=A4$
              DBW$(5)=A5$
              DBW$(6)=A6$
              
' Work out max string length
              For T=1 To 6
              If DBW$(T)="" Then GoTo DispBoxn6
              If Len(DBW$(T)) > MLen% Then MLen%=Len(DBW$(T))
DispBoxn5:      Lin%=Lin%+1
DispBoxn6:      Next t
' End of String Length Check
              If MLen%>76 Then MLen%=76
              If Lin%=0 Then RetKey$="" : GoTo DispBoxnEnd
              If RetKey$=CHR$(10) Then A=0 Else A=2
'Print RetKey$                  
              CALL box(StRow%, 40-Int((MLen%/2)+.5),MLen%+2+1 , Lin%+2+A, DoubleBorder$)
              
              Lin%=0
              For T=1 To 6
              LOCATE StRow%+1+Lin%, 40-Int((MLen%/2)+.5)+1
              If DBW$(T)="" Then GoTo DispBoxn16
              Print  LEFT$(DBW$(T),77)
              Lin%=Lin%+1
DispBoxn16:     Next T

DispBoxn20:   If RetKey$=CHR$(10) Then  RetKey$="": GoTo DispBoxnEnd
		If RetKey$=CHR$(22) Then RetKey$= " - Press any other key to go on -"
              If RetKey$<>"" Then  B$=RetKey$ : GoTo DispBoxn30
              B$= " - Press any key to exit -"
DispBoxn30:     
              LOCATE StRow%+Lin%+A, 40-Int((Len(B$)/2)+.5)+1
              Print B$
              LOCATE StRow%+Lin%+A, 40 +Int((Len(B$)/2)+.5)+1
              DO: DU$ = INKEY$: LOOP UNTIL DU$ <> ""
              RetKey$=DU$

DispBoxnEnd:                    

END SUB 

SUB ShortLongName (A$,B$,FUNC As Integer)
' Get either a LongName or a Shortname, depending on the value assigned to the control variable FUNC
' FUNC = 1  -  Get ShortFilename (8.3 characters) out of a LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 2  -  Get LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 3  -  Get ShortFilename (8.3 characters) out of a LongFilename. Create one LongFilename if no ShortFilename exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 4  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the longest Filename available. If file is created, a second record containing "CR!" will be returned. 
'      = 5  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.

              SELECT CASE MyVal(0)
              CASE 0 TO 999  ' Plain DOS OS
              EXIT SUB
              CASE 1000 TO 1999  ' Windows 95, 98, XP
              GOTO ShortLongN1
              CASE 2000 TO 3000  ' Windows XP, Vista
              GOTO ShortLongN1
              CASE ELSE
              END SELECT
              EXIT SUB
              
ShortLongN1:    Select CASE FUNC
              CASE 1  ' Get short filename (8.3 characters) but don't create a new file.
              C$ = "INT7160.com"
              CASE 2  ' Get Longest Filename but don't create a new file.
              C$ = "INT716RL.com"
              CASE 3  ' Get ShortFilename and create a long one if none exists. Return the short one anyway
              C$ = "INT716C.com"
              CASE 4  ' Get Long Filename out of a short one. Create a long one if none exists.
              C$ = "INT716CO.com"  ' The new  filename returned to the caller will be of the longest type available.
              CASE 5  ' Get Long Filename out of a short one. Create a long one if none exists.
              C$ = "INT716CL.com"  ' The new  filename returned to the caller will be of the shortest type available.

              CASE Else
              Exit Sub
              END SELECT
              
              
              C$ = C$ + " " + A$ + " >--"'Redirect output to a file named "--"
              SHELL C$
              B$=""
              ff% = FREEFILE
              OPEN "--" FOR INPUT AS #ff%
              IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
              LINE INPUT #ff%, A$
              IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
              LINE INPUT #ff%, B$
ShortLongN2:    CLOSE #ff%
              KILL "--"
END Sub
