DECLARE SUB CheckingOS ()
DECLARE SUB OSChoice (K$, A$)
DECLARE SUB CheckVer ()
' This module can be Launched with a CHAIN qbasic instruction by a different qbasic program.
' Just add the same COMMON arrays to your launcher. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.

DIM Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER
MainProg$ = "Main-02.bas"       ' Main Program
                RESET
' =========================================================================================================================
' How to identify what Microsoft OS is running
'
' Windows Blind-Vista                  - "Windows" ?????????? Future Windows                 - Assign 2300
' Windows 7 from .BAS + CMD            - "Microsoft Windows [Version 6.1.7100]"              - Assign 2200   - Note: from "Ultimate" incarnation, but should be equal to all other Vistas
' Windows Vista 2007 from .BAS + CMD   - "Microsoft Windows [Version 6.0.6000]"              - Assign 2100   - Note: from "Ultimate" incarnation, but should be equal to all other Vistas
' Windows Vista 2007   from .BAS       - "MS-DOS Version 5.00.500"                           - Assign 2100
' Windows XP Home ITA                  - "Microsoft Windows XP [Versione 5.1.2600]"          - Assign 2000   - Note: "Versione", with a final "e", because it's an Italian version
' Windows XP Pro  ENG from Prompt      - "Microsoft Windows XP [Version 5.1.2600]"           - Assign 2000
' Windows XP Pro  ENG from .BAS        - "MS-DOS Version 5.00.500"                           - Assign 2000
' Windows XP Pro  ITA from .BAS        - "MS-DOS Versione 5.00.500"                          - Assign 2000   - Note: "Versione", with a final "e", because it's an Italian version
' Windows Millennium ITA from .BAS     - "Windows Millennium [Version 4.90.3000]"            - Assign 1030
' Boot Disk Millennium                 - "Windows Millennium [Version 4.90.3000]"            - Assign 1030
' MS-DOS 98   Boot Disk                - "Windows 98 [versione 4.10.1998]"                   - Assign 1020  - Note: "Versione", with a final "e", because it's an Italian version
' MS-DOS 95b  Boot Disk                - "Windows 95. [Version 4.00.1111]"                   - Assign 1000  - Note: The second Windows 95, Version "b"
' MS-DOS 95a  Boot Disk                - "Windows 95. [Version 4.00.950]"                    - Assign 1000  - Note: The "Original" Windows 95, Version "a"
' MS-DOS 6.22 Boot Disk                - "MS-DOS Version 6.22"                               - Assign   60      
' MS-DOS 5.00 Boot Disk                - "MS-DOS Version 5.00"                               - Assign   50      
' MS-DOS 4.01 Boot Disk                - "MS-DOS Version 4.01"                               - Assign   40      
' MS-DOS 3.30 Boot Disk                - "MS-DOS Version 3.30"                               - Assign   30    
' DR-DOS 6.0  Boot Disk                - "DR DOS Release 6.0"                                - Assign  360                
' DR-DOS 7.03 Boot Disk                - "Caldera DR-DOS 7.03"                               - Assign  370
' DR-DOS 7.05 Boot Disk                - "Caldera DR-DOS 7.05"                               - Assign  370
' IBM PC-DOS 4.01       Boot Disk      - "IBM DOS Version 4.00"                              - Assign  140
' IBM PC-DOS 5.0        Boot Disk      - "IBM DOS Version 5.00"                              - Assign  150
' IBM PC-DOS 6.3        Boot Disk      - "PC DOS Version 6.3"                                - Assign  160
' IBM PC-DOS 7.0 Rev. 0 Boot Disk      - "PC DOS Version 7.0"  "Revision 0" (two lines)      - Assign  170
' IBM PC-DOS 7.0 Rev. 1 Boot Disk      - "PC DOS Version 7.0"  "Revision 1" (two lines)      - Assign  170
'

' Try Windows XP/Vista first: see if a CMD command is accepted by DOS.
' With Windows XP/Vista, Microsoft starts handling the Console DOS from a running QBasic program
' differently from the way Console DOS directly from a prompt would be handled. The environmenr is sort of masked.
' A SHELLed VER command (with a leading CMD prefix)from running QBasic will report in Vista the string:
' "Microsoft Windows [Version 6.0.6000]" while the same command with no leading CMD prefix will report:
' "MS-DOS Version 5.00.500", which happens to
' be almost the same string issued by a normal VER command (no CMD) in Windows Millennium.
' Well, at least the beginning is the same. Now, why two OSes do have to report almost the same version?
' Just to make the application program (QBasic in this case) think that it is in the same environment as in the previous OS.
                
                
                StartTime = TIMER
                CALL CheckingOS
'A$="Caldera DR-DOS" : GoTo WinFound
                
                MyFile$ = "~~vercmd.txt"
                OPEN MyFile$ FOR OUTPUT AS #1
                CLOSE #1
                KILL MyFile$
                Exec$ = "cmd /C ver >" + MyFile$ '+ " >NUL"
                ON ERROR GOTO NoCMDFound
                SHELL Exec$
                
                ON ERROR GOTO NoCMDFound
                OPEN MyFile$ FOR INPUT AS #1
                ON ERROR GOTO 0
                
                IF LOF(1) = 0 THEN CLOSE #1: GOTO NoWinXPFound
                GOSUB GetRecord
                CLOSE #1
                If A$ = "" THEN GOTO NoVerFound2 ' Doesn't work. Assume MS-DOS Version 6.22
                IF INSTR(1, A$, "Microsoft Windows XP") > 0 THEN MyVal(0) = 2000: GOTO DOSVersionFound
                IF INSTR(1, A$, "Microsoft Windows [") > 0 Then
                                IF INSTR(1, A$, "6.0.") > 0 THEN MyVal(0) = 2100: GOTO DOSVersionFound
                          IF INSTR(1, A$, "6.1.") > 0 THEN MyVal(0) = 2200: GOTO DOSVersionFound
                ELSE 
                                MyVal(0) = 2250: GOTO DOSVersionFound
                END IF 
                IF INSTR(1, A$, "Windows") > 0 THEN MyVal(0) = 2300: GOTO DOSVersionFound
                A$ = "Microsoft After Windows 7": MyVal(0) = 2300
                GOTO DOSVersionFound
NoCMDFound:     RESUME NoCMDFound2
NoCMDFound2:    ON ERROR GOTO 0
                
                
NoWinXPFound:
                
                MyFile$ = "~~verver.txt"
                OPEN MyFile$ FOR OUTPUT AS #1
                CLOSE #1
                KILL MyFile$
                Exec$ = "ver >" + MyFile$ '+ " >NUL"
                SHELL Exec$
                CALL OSChoice(K$, A$): IF K$ <> "" THEN A$ = K$: GOTO DOSVersionFound
                ON ERROR GOTO NoVerFound
                OPEN MyFile$ FOR INPUT AS #1
                ON ERROR GOTO 0
                CALL OSChoice(K$, A$): IF K$ <> "" THEN A$ = K$: GOTO DOSVersionFound
                GOSUB GetRecord
                CLOSE #1
                IF A$ = "" THEN GOTO NoVerFound2 ' Doesn't work. Assume MS-DOS Version 6.22
WinFound:       
                Version$=GetNumber$(A$)   ' "Version" string changes in locale, so we have to skip it.
                P=InStr(1,Version$,".") : If P>0 Then SV$=left$(Version$,P) else SV$=Version$ ' SV$ = Short version
                IF INSTR(1, A$, "MS-DOS") >0 And  SV$="3." THEN MyVal(0) = 30: GOTO DOSVersionFound
                IF INSTR(1, A$, "MS-DOS") >0 And  SV$="4." THEN MyVal(0) = 40: GOTO DOSVersionFound
                IF INSTR(1, A$, "MS-DOS") >0 And  SV$="5." THEN MyVal(0) = 50: GOTO DOSVersionFound
                IF INSTR(1, A$, "MS-DOS") >0 And  SV$="6." THEN MyVal(0) = 60: GOTO DOSVersionFound
                IF INSTR(1, A$, "Windows 95") > 0 THEN MyVal(0) = 1000: GOTO DOSVersionFound
                IF INSTR(1, A$, "Windows 98") > 0 THEN MyVal(0) = 1020: GOTO DOSVersionFound
                IF INSTR(1, A$, "Windows Millennium") > 0 THEN MyVal(0) = 1030: GOTO DOSVersionFound
                
                IF INSTR(1, A$, "DR DOS") > 0 THEN MyVal(0) = 360: GOTO DOSVersionFound
                IF INSTR(1, A$, "Caldera DR-DOS") > 0 THEN MyVal(0) = 370: GOTO DOSVersionFound
                IF INSTR(1, A$, "IBM DOS") >0 And  SV$="4." THEN MyVal(0) = 140: GOTO DOSVersionFound
                IF INSTR(1, A$, "IBM DOS") >0 And  SV$="5." THEN MyVal(0) = 150: GOTO DOSVersionFound
                IF INSTR(1, A$, "IBM DOS") >0 And  SV$="6." THEN MyVal(0) = 160: GOTO DOSVersionFound
                IF INSTR(1, A$, "IBM DOS") >0 And  SV$="7." THEN MyVal(0) = 170: GOTO DOSVersionFound
'               If InStr(1,A$,"")>0 Then MyVal(0)= :GoTo DOSVersionFound
NoVerFound:     RESUME NoVerFound2
NoVerFound2:    A$ = "Unknown DOS": MyVal(0) = 60
                ON ERROR GOTO 0
                
DOSVersionFound:         
                PRINT A$, MyVal(0)
                PRINT
                PRINT " Press ENTER to enter your choice..."

                DO
                EndTime = TIMER
                IF EndTime < StartTime THEN EndTime = EndTime + (60 * 60 * 24)
                'Print EndTime; StartTime
                CALL OSChoice(K$, A$): IF K$ <> "" THEN A$ = K$: GOTO DOSVersionAssigned
                LOOP UNTIL (EndTime - StartTime) > 1
                
DOSVersionAssigned:                    

'================================================================
' **** Build 'Manual.DAT' if not built already.
                ON ERROR GOTO NoManDAT
                OPEN "MANUAL.DAT" FOR INPUT AS #1
                CLOSE #1
                ON ERROR GOTO 0
                GOTO ManDAT
NoManDAT:       RESUME NoManDAT1
NoManDAT1:      ON ERROR GOTO 0
                RUN "CRManDAT.bas"
                'Exec$ = "MD TEMP >NUL"   ' Create TEMP directory if it doesn't exist.
                'SHELL Exec$                  ' TEMP directory will be used to Decompress ARK files on the fly.

ManDAT:         IF MyVal(0)>1999 THEN 
                'SHELL "MsCOMins.bat" ' No need to install MSCOMCTL.OCX, since we keep it in the
                                      ' TI99-PC directory anyway.
                Exec$ = "OFlopVer.exe"          ' See if user has installed OmniFlop Driver 2.2c
                SHELL Exec$
                END IF 
' ***** Save current directory
                Exec$ = "currdir.com " '+ " >NUL"
                SHELL Exec$
                OPEN "--" FOR INPUT AS #1
                LINE INPUT #1, A$
                MyName$(1) = A$  ' Get Current Directory
                IF MyName$(0) = "" THEN MyName$(0) = A$ + MainProg$
                CLOSE #1
                
' Work out at what position DOS places the start of a Filename/Directory in the output listing of a "DIR" command
                Inf$ = "~WhereIs.TMP"
                
                SELECT CASE MyVal(0)
                CASE 0 TO 999  ' Plain DOS OS
                SHELLSTR$ = "dir " + MyName$(1) + MainProg$ + " >" + MyName$(1) +  Inf$ 
                CASE 1000 TO 1999  ' Windows 95, 98, ME
                SHELLSTR$ = "dir " + CHR$(34) + MyName$(1) + MainProg$ + CHR$(34) + " /OGNE /-P >" + + MyName$(1) +  Inf$ 
                CASE 2000 TO 3000  ' Windows XP, Vista
                SHELLSTR$ = "CMD /C dir " + CHR$(34) + MyName$(1) + MainProg$ + CHR$(34) + " /OGNE /-P >" + MyName$(1) + Inf$
                END SELECT
                SHELL SHELLSTR$
                
                OPEN MyName$(1) + Inf$ FOR INPUT AS #1
                WHILE NOT EOF(1)
                LINE INPUT #1, In$
                LisPos= INSTR(UCASE$(In$),UCASE$(MainProg$))
                IF LisPos>0 THEN GOTO PastThere
        
                WEND 
                LisPos=40       ' Assume Position is 40
PastThere:      OPEN MyName$(1) + "~PCDIR.DAT" FOR OUTPUT AS #2
                MyVal(3)=LisPos
                PRINT #2,RTRIM$(LTRIM$(STR$(LisPos)))
                CLOSE #2                
                CLOSE #1
                        
' Make sure Extract does exist
'               Work out root directory
                For T=Len(A$)-1 To 1 step -1
                T$=MID$(A$,T,1)
                If T$="\" Then  MyRoot$=LEFT$(A$,T): GoTo MyRootF
                Next T
                MyRoot$=A$
                
MyRootF:        ' See if Root\EXTRACT exists
                On ERROR GOTO NoExtract
                OPEN  MyRoot$ + "EXTRACT\CON" FOR INPUT AS #1
                CLOSE #1
                ON ERROR GOTO 0
                GOTO Extract
NoExtract:      Resume NoExtract1
NoExtract1:     ON ERROR GOTO 0
                Exec$ = "MD " + MyRoot$ + "EXTRACT >NUL"
                SHELL Exec$
                
Extract:        
                
LeaveIt:        CHAIN MyName$(0)
                DO: U$ = INKEY$: LOOP UNTIL U$ <> ""
                SYSTEM
                END
                
GetRecord:         
                WHILE (1) <> 0
                LINE INPUT #1, A$
                A$ = LTRIM$(RTRIM$(A$))
                IF A$ <> "" THEN GOTO FoundDOSVersion
                WEND
                
FoundDOSVersion:
                Return
Function GetNumber$(A$)
                ' Scan string from the beginning.
                ' Throw away all characters until a character that is either
                ' a number or a "." is found.
                ' Collect that character and all the following characters until a character
                ' that is neither a number nor a "." is found.
                For t=1 To Len(A$)
                T$=PickCharacter$(mid$(A$,t,1))
                Select Case T$
                Case ""
                If Collect$<>"" Then  Exit For
                Case Else
                Collect$=Collect$ + T$
                End Select
                Next t
                GetNumber$=Collect$
                
End Function 

Function PickCharacter$ (A$)
                Select Case A$
                Case "0" To "9"
                PickCharacter$=A$
                Case "."
                PickCharacter$=A$
                End Select
End Function            
                

SUB CheckingOS
                PRINT
                PRINT TAB(15); "*** TI99-PC is checking your operating system... ***"
                PRINT
                PRINT " OS found: ";
END SUB

SUB OSChoice (K$, A$)
                K$ = INKEY$
                IF K$ <> CHR$(27) AND K$ <> CHR$(0) + CHR$(83) AND K$ <> CHR$(32) AND K$ <> CHR$(13) THEN K$ = "": GOTO ChoiceExit
KeyPlease:      PRINT : PRINT : PRINT : PRINT
                PRINT " Ok, now tell TI99-PC what OS it is running on..."
                PRINT
                PRINT " 1) No Microsoft Windows (i.e. all the incarnations of DOS)"
                PRINT " 2) Microsoft Windows 95, 98, Millennium"
                PRINT " 3) Microsoft Windows XP, Vista, 7"
                PRINT
                PRINT " 0) None of the above: just accept what TI99-PC find out for itself"
                PRINT
                PRINT " Your choice (0-3) : ";
                
                INPUT "", K$
                SELECT CASE K$
                CASE "1"
                K$ = "No Microsoft Windows": MyVal(0) = 60
                CASE "2"
                K$ = "Microsoft Windows 95, 98, ME": MyVal(0) = 1030
                CASE "3"
                K$ = "Microsoft Windows XP/Vista": MyVal(0) = 2200
                CASE "0"
                K$ = A$
                CASE ""
                K$ = A$
                CASE ELSE
                BEEP: GOTO KeyPlease
                
                END SELECT
                PRINT : PRINT : PRINT "Chosen OS: "; K$
ChoiceExit:
END SUB

