' This module can Launch different qbasic programs with a CHAIN qbasic instruction.
' Just add the same COMMON arrays to your launcher. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.
' 
'
DIM Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER'

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER

                DIM SHARED FileNum AS INTEGER
                DIM SHARED FC AS INTEGER
                DIM SHARED BC AS INTEGER
                DIM SHARED HFC AS INTEGER
                DIM SHARED HBC AS INTEGER
                
                
                
                DIM SHARED TempArk AS STRING
                TempArk = "~ARKTMP.TMP"

                DIM SHARED DoubleBorder$    ' Double Border Box characters
                DIM SHARED SingleBorder$
                DoubleBorder$ = "ͻͼ"      ' Double Border Box characters
                SingleBorder$ = "Ŀ"      ' Single Border Box characters 
          

                NormForeColor = 7' Normal Foreground Color
                NormBackColor = 0 ' Normal Background Color
                FC = NormForeColor
                BC = NormBackColor
                
                Endk$ = CHR$(13)
                Endk$ = Endk$ + CHR$(27)
                Endk$ = Endk$ + CHR$(9)
                Endk$ = Endk$ + CHR$(0) + CHR$(72) '
                Endk$ = Endk$ + CHR$(0) + CHR$(80)
                Endk$ = Endk$ + CHR$(0) + CHR$(59) ' F1 = Help 
                Endk$ = Endk$ + CHR$(0) + CHR$(63) ' F5  Key
                Endk$ = Endk$ + CHR$(0) + CHR$(64) ' F6  Key
                Endk$ = Endk$ + CHR$(0) + CHR$(68) ' F10 Key
                
                CONST ChkPath%     = 1   ' Check if path exists.
                CONST ChkFilXist%  = 2   ' Check if path\filename exists.
                CONST ChkFilCreat% = 4   ' Check if filename can be created (i.e. if path exists and filename 
		                         ' has not the same name of an existing directory)
		                         
                Inffixed$ = "~DOSDIR.TMP"
                ReturnFile$= "~Merge.dat"
                OutFile$="~OutMrg.img"
	        GOTO PastChainBack
XtractExit:		  
ChainBack:      CHAIN "PC-DIR05.BAS"

PastChainBack:                
                OPEN ReturnFile$ FOR INPUT AS #72
                INPUT #72, Option$
                INPUT #72, TFNames% 
                INPUT #72, CurrentFilename%
                INPUT #72, CurrentScreenRow%
                INPUT #72, FirstFilename%
                INPUT #72, TotFiles2Copy%
                INPUT #72, TotSizeFiles2Copy#
                INPUT #72, CurrDir$
                
                'GOSUB IntroScreen
                'IF  DU$=CHR$(27) THEN CLOSE #72: GOTO XtractExit
                'If  DU$=CHR$(0) + CHR$(59) THEN COLOR FC, BC: GOSUB HelpAskedFor : GOTO IntroAgain   
             
                'OutFile$=CurrDir$+OutFile$
                REDIM CopyMark$(TFNames%)
                OPEN Inffixed$ FOR RANDOM ACCESS READ WRITE AS #4 LEN = 256
                FIELD #4, 256 AS L$
                LOCATE 4,4

' FIRST OFF, CHECK ALL SOURCE FILES               
                FOR FT% = 1 TO TFNames%  'Check all files
                LINE INPUT #72,CopyMark$(FT%)
                
                'IF CopyMark$(FT%)<>"X" THEN GOTO NotXtract
        	  IF FT%<>CurrentFilename% THEN GOTO NotXtract
                GET #4,FT%
		  print L$
		  INPUT "Xtract=", cccc$                
                ' PRINT " - "; ' Mystring$;
                
        
                
                'Give user the chance to choose if he wants to exclude files with sector 1 not matching                 
                
                
                  
   
                
NotXtract:       
                NEXT FT%
                CLOSE #72
                
                
'**************************************************                
                GOSUB DOSAsmblFilename: IF Mystring$ = "" THEN GOTO DOSNoMatch
		IF INSTR(Mystring$, ":") = 0 THEN Mystring$ = CurrDir$ + Mystring$
		CALL ShortLongName(Mystring$, CR$, 1)' Get Short Name out of a long filename
		CLS
		COLOR 14, 0
		PRINT TAB(5); "Catalog of Archive File: "; Mystring$
		'Exec$ = "Decomp4.com " + Mystring$ + " /s"
		Exec$ = "Decomp4.com " + Mystring$ + " " + MyName$(1)+"TMP\~tmpfile.tmp "
		SHELL Exec$
		COLOR FC, BC
		'CLS
DOSNoMatch:                
                INPUT "Xtract END", cccc$  
                CLOSE #4  
                GOTO XtractExit
                
                
DOSAsmblFilename:
		
		IF CurrentFilename% <= 5 THEN BEEP: Mystring$ = "": GOTO DOSAsmblFilexit
		GET #4, CurrentFilename%
		Mystring$ = XtrctFilename$(L$)
		IF LEFT$(L$, 1) = "\" THEN BEEP: Mystring$ = "": GOTO DOSAsmblFilexit
		' Mystring$ = LEFT$(L$, 12)
		Mystring$ = Shrink$(Mystring$): IF Mystring$ = "" THEN BEEP: GOTO DOSAsmblFilexit
		Mystring$ = CurrDir$ + Mystring$
DOSAsmblFilexit:
		RETURN        
		
SUB ShortLongName (A$, B$, FUNC AS INTEGER)
' Get either a LongName or a Shortname, depending on the value assigned to the control variable FUNC
' FUNC = 1  -  Get ShortFilename (8.3 characters) out of a LongFilename.
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 2  -  Get LongFilename.
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 3  -  Get ShortFilename (8.3 characters) out of a LongFilename. Create one LongFilename if no ShortFilename exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 4  -  Get Long Filename out of a short one. Create a long one if none exists.
'                  Return the longest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 5  -  Get Long Filename out of a short one. Create a long one if none exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.

		SELECT CASE MyVal(0)
		CASE 0 TO 999  ' Plain DOS OS
		EXIT SUB
		CASE 1000 TO 1999  ' Windows 95, 98, XP
		GOTO ShortLongN1
		CASE 2000 TO 3000  ' Windows XP, Vista
		GOTO ShortLongN1
		CASE ELSE
		END SELECT
		EXIT SUB
		
ShortLongN1:    SELECT CASE FUNC
		CASE 1  ' Get short filename (8.3 characters) but don't create a new file.
		C$ = "INT7160.com"
		CASE 2  ' Get Longest Filename but don't create a new file.
		C$ = "INT716RL.com"
		CASE 3  ' Get ShortFilename and create a long one if none exists. Return the short one anyway
		C$ = "INT716C.com"
		CASE 4  ' Get Long Filename out of a short one. Create a long one if none exists.
		C$ = "INT716CO.com"  ' The new  filename returned to the caller will be of the longest type available.
		CASE 5  ' Get Long Filename out of a short one. Create a long one if none exists.
		C$ = "INT716CL.com"  ' The new  filename returned to the caller will be of the shortest type available.

		CASE ELSE
		EXIT SUB
		END SELECT
		
		
		C$ = C$ + " " + A$ + " >--"'Redirect output to a file named "--"
		SHELL C$
		B$ = ""
		ff% = FREEFILE
		OPEN "--" FOR INPUT AS #ff%
		IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
		LINE INPUT #ff%, A$
		IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
		LINE INPUT #ff%, B$
ShortLongN2:    CLOSE #ff%
		KILL "--"
END SUB
	
FUNCTION XtrctFilename$ (A$)    ' Get long filename, is available; if not get the short one   
		SELECT CASE MyVal(0)
		CASE 0 TO 999  ' Plain DOS OS
		GOTO XtrctFilename1
		CASE 1000 TO 1999  ' Windows 95, 98, ME
		B$ = RTRIM$(LTRIM$(MID$(A$, MyVal(3), LEN(A$))))
		IF B$ <> "" THEN GOTO XtrctFilename4
		GOTO XtrctFilename1
		CASE 2000 TO 2099  ' Windows XP
		B$ = RTRIM$(LTRIM$(MID$(A$, MyVal(3), LEN(A$))))
		IF B$ = "" THEN B$ = MID$(A$, 2, 2)     ' In case "\.." (Parent Directory) is selected
		CASE 2100 TO 3000  ' Windows Vista
		B$ = RTRIM$(LTRIM$(MID$(A$, MyVal(3), LEN(A$))))
		IF B$ = "" THEN B$ = MID$(A$, 2, 2)     ' In case "\.." (Parent Directory) is selected
		END SELECT
		GOTO XtrctFilename4
		
		
		
XtrctFilename1: B$ = RTRIM$(LTRIM$(MID$(A$, 1, 13)))
		P = INSTR(1, B$, " "): IF P > 0 THEN MID$(B$, P) = "."
		IF LEFT$(B$, 1) = "\" THEN B$ = RIGHT$(B$, LEN(B$) - 1)
		
		
XtrctFilename4: XtrctFilename$ = B$
END FUNCTION

FUNCTION Shrink$ (In$)
		A$ = "": c1$ = " "
		FOR T = 1 TO LEN(In$): C$ = MID$(In$, T, 1): IF C$ = " " AND c1$ = " " THEN GOTO SKIP
		A$ = A$ + C$: c1$ = C$
SKIP:
		NEXT T
		A$ = LTRIM$(RTRIM$(A$))
		Shrink$ = A$
END FUNCTION        